 <?php 
 include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd_solicitud.msg'); 
class d_ga_pd_cambiado extends BizDataObj
{
 

    public function UpdateRecord($recArr, $oldRec=null)
    {
        $result = parent::UpdateRecord($recArr, $oldRec);

        if($result)
        {
			global $g_BizSystem;
			$dataObjSolicitud = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_solicitud");
			$dataObjSolicitud->setSearchRule("[num_pd]='".$recArr['num_pd']."'");
			$dataRec=$dataObjSolicitud->fetch();
      
			if(!isset ($dataRec[0]))
			  {
				logErr("No se encuentra la solicitud", "PD", false);
				return $result;
			}

			$oldRecSolicitud=$dataRec[0];

			if($dataRec[0]['estado']!=$recArr['estado'])
			{
				$dataRec[0]['estado']=$recArr['estado'];
                
				$resultSolicitud=$dataObjSolicitud->UpdateRecord($dataRec[0],$oldRecSolicitud);

				if(!$resultSolicitud)
				{
					logErr("No se cambio el estado de la solicitud", "Estado de la Solicitud", false);
					return $result;
				}
                
                $estado=array(1=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_1'),2=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_2'),
                    3=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_3'),4=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_4'),
                    6=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_6')
                        ,0=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_0'),7=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_7'), 
                            8=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_8'),10=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_10'),
                                11=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_11'));    
                $filtros=array('entidad'=>$this->m_MainTable,'campo'=>'estado','viejo_valor'=>$oldRecSolicitud['estado'],'nuevo_valor'=>$dataRec[0]['estado']);
                $valores=array(E_NUM_PD=>$recArr['num_pd'],E_ESTADO_ACTUAL=>$estado[$oldRecSolicitud['estado']],E_ESTADO_NUEVO=>$estado[$dataRec[0]['estado']]);
                $entidad_id=array('entidad_id'=>$dataRec[0]['Id']);
                
                
                global $g_BizSystem;
                $dataObjEnvioEmail = $g_BizSystem->GetObjectFactory()->GetObject("erp.parametrizacion_interna.dataobj.d_ga_erp_plantilla_parametrizacion_envio_email");
                $params=$dataObjEnvioEmail->buscarParametrizacionEnvioEmail('CAMBIO_ESTADO_PD',null,true,$filtros,$dataRec[0]['Id'],$valores);
     
                           
                $params['subject']=$dataObjEnvioEmail->aplicarBinarioHex($params['subject']); 
                $params['body']=$dataObjEnvioEmail->aplicarBinarioHex($params['body']);
               
                
                $dataObjEnvioEmail->enviarEmailSql($params);
			}

        }
        return $result;
    }

  

}