<?php 

class d_ga_pdc_cambiado_insert extends BizDataObj
{ 
    public function Fetch()
    {
        global $g_BizSystem;
        $resultRecords = parent::Fetch();    //logErr($resultRecords,1,false);       
        $registro_id = -1;
        foreach ($resultRecords as $key => $value) {
            
            
            if($value['accion']==1)
            continue;

            $raiz=substr($value['tabla'],3);
            // logErr($raiz,raiz,false); 
            if($raiz=="pd")
            {
            $cadenaObj="epd.pdc.dataobj.d_ga_pd";
            }
            elseif(substr_count($value['tabla'],"_comp")>=1 )
            {
            $raiz=str_replace("_comp","",$raiz);
            $cadenaObj="epd.".$raiz.".dataobj.d_".$value['tabla'];
            }
            elseif(substr_count($value['tabla'],"pd_shell")>=1)
            {
            $cadenaObj="epd.pd.dataobj.d_".$value['tabla'];
            }
            else 
            {
            $cadenaObj="epd.".$raiz.".dataobj.d_".$value['tabla'];
            }

            //logErr($cadenaObj,cadenaObj,false);
            if($registro_id != $value['registro_id'])
            {
            if(!$cadenaObj) continue;
            $dataObjUpdate= $g_BizSystem->GetObjectFactory()->GetObject($cadenaObj);
            if(!$dataObjUpdate)  continue;

            $dataObjUpdate->ResetRules();
            $dataObjUpdate->SetSearchRule("[Id]='".$value['registro_id']."'");
            $recordSetUpdate=$dataObjUpdate->Fetch();
            $registro_id = $value['registro_id'];  //logErr($recordSetUpdate,color,false);
            }    
            
            $resultRecords[$key]['valor_actual']=$recordSetUpdate[0][$value['campo']];
            if(isset($recordSetUpdate[0]['barniz_color']))
                $resultRecords[$key]['dependencia']=$recordSetUpdate[0]['barniz_color'];
            elseif(isset($recordSetUpdate[0]['tinta_color']))
                $resultRecords[$key]['dependencia']=$recordSetUpdate[0]['tinta_color'];

        }  
             
        foreach ($resultRecords as $key => $value) 
        {

            $tabla=$this->Nombres($value['tabla']);
            $resultRecords[$key]['tabla']=$tabla;
            
            if($value['accion']==1)continue;   
            
            $campo=$this->Nombres($value['tabla'], $value['campo']);
            $resultRecords[$key]['campo']=$campo;
            if(isset($value['dependencia']))
            $resultRecords[$key]['campo']=$campo." de (".$value['dependencia'].")";
           
        }       
              
        $band=false; $registro_id=0; $nuevo_registro=null;
        $resorset=array();
        foreach($resultRecords as $key => $value)
        {
          
            if($value['accion']!=1){
                $resorset[]=$value;
                continue;
            }
            
            if($registro_id!=$value['registro_id'])
            {
                 if(!is_null($nuevo_registro))
                {
                    $resorset[]=array('Id'=>$Id,'pd_id'=>$pd_id,'tabla'=>$tabla,
                    'campo'=>$nuevo_registro,'accion'=>1,'valor'=>'','valor_actual'=>'','fecha'=>$fecha,'usuario_username'=>$usuario,
                    'registro_id'=>$registro_id,'estado'=>1);
                    $nuevo_registro=null;
                }
                
            $registro_id=$value['registro_id'];
            $Id=$value['Id'];
            $pd_id=$value['pd_id'];
            $tabla=$value['tabla'];
            $fecha=$value['fecha'];
            $usuario=$value['usuario_username'];
            }
            elseif($value['registro_id']==$registro_id && (stripos($value['campo'],'m2')!==false || stripos($value['campo'],'color')!==false ||stripos($value['campo'],'cantidad')!==false))
            {
                $campo=$this->Nombres($value['tabla'], $value['campo']);
                $nuevo_registro.="<strong>".$campo.":</strong> ".$value['valor']."   &nbsp; "; //  logErr($nuevo_registro,nuevo,false);
               //unset($resultRecords[$key]);
            }elseif($value['registro_id']==$registro_id && (stripos($value['campo'],'utilizacion')!==false || stripos($value['campo'],'color')!==false ||stripos($value['campo'],'observaciones')!==false))
            {
                $tempTabla=$value['tabla'];   
                $campo=$this->Nombres($value['tabla'], $value['campo']);
                                                  
                if(stripos($value['campo'],'utilizacion')!==false && stripos($tempTabla,'dl')!==false)
                    $nuevo_registro.="<strong>".$campo.":</strong> ".$this->cargarSelection("TINTA_DL", $value['valor'],"epd.Selection")."   &nbsp; " ;
                elseif(stripos($value['campo'],'utilizacion')!==false && stripos($tempTabla,'lito')!==false)
                    $nuevo_registro.="<strong>".$campo.":</strong> ".$this->cargarSelection("TINTA_LITO", $value['valor'],"epd.Selection")."   &nbsp; " ;
                elseif(stripos($value['campo'],'utilizacion')!==false && stripos($tempTabla,'barniz')!==false)
                    $nuevo_registro.="<strong>".$campo.":</strong> ".$this->cargarSelection("TIPO_BARNIZ", $value['valor'],"epd.Selection")."   &nbsp; " ;
                else
                    $nuevo_registro.="<strong>".$campo.":</strong> ".$value['valor']."   &nbsp; " ;
            }
            
            
        }
        
        if(!is_null($nuevo_registro))
        {
            $resorset[]=array('Id'=>$Id,'pd_id'=>$pd_id,'tabla'=>$tabla,'campo'=>$nuevo_registro,'accion'=>1,'valor'=>'','valor_actual'=>'','fecha'=>$fecha,'usuario_username'=>$usuario,'registro_id'=>$registro_id,'estado'=>1);
            $nuevo_registro=null;
        }  
                  
        return $resorset;
    }

    protected function Nombres($nombreTabla,$NombreCampo=null)
    {
    if(!is_null($NombreCampo)){
        if($NombreCampo=='cantidad_m2_formula')
        {
            $NombreCampo="Aditivos (Fórmula)";
            
        }
        elseif($NombreCampo =='cantidad_aditivo')
        {
            $NombreCampo="Aditivos/1000 Tapas";  
        }
        elseif($NombreCampo=='cantidad_aditivo_m2')
        {
            $NombreCampo="Aditivos/m2";
            
        }
       
     $textoCom .= str_replace("_"," ",$NombreCampo) ;
    }
    $textoCom .=" ";
    if ($nombreTabla=="ga_pd"){
     $textoCom.="de la PD";
     $texto = "PD";
    }else if ($nombreTabla=="ga_pd_shell"){
     $textoCom.="";
     $texto = "Pasadas de la SHELL-PD";
    }else if ($nombreTabla=="ga_pd_barniz"){
     $textoCom.="de Barniz de la PD";
     $texto = "Barniz de la PD";
    }
    else if ($nombreTabla=="ga_pd_barniz_comp"){
       $textoCom.="de Barniz de la PD";
     $texto = "Formula de Barniz de la PD";
    }
    else if ($nombreTabla=="ga_pd_tinta_dl"){
       $textoCom.="de Tinta DL de la PD";
     $texto = "Tinta DL de la PD";
    }
    else if ($nombreTabla=="ga_pd_tinta_dl_comp"){
       $textoCom.="de Tinta DL de la PD";
     $texto = "Formula de Tinta DL de la PD";
    }
    else if ($nombreTabla=="ga_pd_tinta_lito"){
       $textoCom.="de Tinta Lito de la PD";
     $texto = "Tinta Lito de la PD";
    }
    else if ($nombreTabla=="ga_pd_tinta_lito_comp"){
        $textoCom.="de Tinta Lito de la PD";
     $texto = "Formula  Tinta Lito de la PD";
    }

    if(!is_null($NombreCampo))
    return $textoCom;
    return $texto;
    }
    
    
     public function cargarSelection($tag,$value,$direccion='erp.maquinas.Selection')
    {
                                                 
        $xmlFile = BizSystem::GetXmlFileWithPath ($direccion);     
        if (!$xmlFile) return;
        $xmlArr = &BizSystem::GetXmlArray($xmlFile);     
        if ($xmlArr) {
          $i=0;
          if (!key_exists($tag, $xmlArr["SELECTION"]))
            return;
          foreach($xmlArr["SELECTION"][$tag] as $node) {
            if($value==$node["ATTRIBUTES"]["VALUE"])
            {
                $list[$i]['val'] = $node["ATTRIBUTES"]["VALUE"];
                if ($node["ATTRIBUTES"]["TEXT"])
                {
                    $list[$i]['txt'] = I18n::getInstance()->translate($node["ATTRIBUTES"]["TEXT"]) ;
                }

                else
                {
                    $list[$i]['txt'] = I18n::getInstance()->translate($list[$i]['val']);
                } 
                return $list[$i]['txt'];     
            }                                                  
            $i++;
          }
        }  
        return "-"; 
    }
}