<?php 

require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/cambios/message/ga_pdc.msg');   
include_once(MODULE_PATH.'/epd/cambios/form/PDCEasyForm.php');    

class f_ga_pdc_list_cambiado extends PDCEasyForm 
{ 
       public function buscarRegistro($tabla,$params=array())
        {
            global $g_BizSystem;
            
            $raiz=substr($tabla,3);
            if($raiz=="pd")
            {
            $cadenaObj="epd.pdc.dataobj.d_ga_pd_cambiado";
            }
            elseif(substr_count($tabla,"_comp")>=1 )
            {
                $raiz=str_replace("_comp","",$raiz);
                $cadenaObj="epd.".$raiz.".dataobj.d_".$tabla."_aprobacion";
            }
             elseif(substr_count($tabla,"pd_shell")>=1)
            {
                 $cadenaObj="epd.pd.dataobj.d_".$tabla."_aprobacion";
            }
             else
            {
                $cadenaObj="epd.".$raiz.".dataobj.d_".$tabla."_aprobacion";
            }
            $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($cadenaObj);
            if (!$dataObj) return false;
            $dataObj->ResetRules();

            foreach($params as $k=>$value)
                $dataObj->setSearchRule("[".$k."] = '".$value."'");

            $dataRec=$dataObj->fetch();
            
            return $dataRec;
        }
        
        protected function Nombres($nombreTabla,$NombreCampo=null)
        {
         if(!is_null($NombreCampo)){
             $textoCom .= str_replace("_"," ",$NombreCampo) ;
         }
         $textoCom .=" ";
          if ($nombreTabla=="ga_pd"){
             $textoCom.=MSG_GA_PDC_CAMPO_PD;
             $texto = MSG_GA_PDC_ENTIDAD_PD;
          }else if ($nombreTabla=="ga_pd_shell"){
             $textoCom.="";
             $texto = MSG_GA_PDC_CAMPO_SHELL_PD;
          }else if ($nombreTabla=="ga_pd_barniz"){
             $textoCom.=MSG_GA_PDC_CAMPO_BARNIZ;
             $texto =MSG_GA_PDC_ENTIDAD_BARNIZ;
          }
          else if ($nombreTabla=="ga_pd_barniz_comp"){
               $textoCom.=MSG_GA_PDC_CAMPO_BARNIZ_COM;
             $texto = MSG_GA_PDC_ENTIDAD_BARNIZ_COM;
          }
          else if ($nombreTabla=="ga_pd_tinta_dl"){
               $textoCom.=MSG_GA_PDC_CAMPO_TINTA_DL;
             $texto = MSG_GA_PDC_ENTIDAD_TINTA_DL;
          }
          else if ($nombreTabla=="ga_pd_tinta_dl_comp"){
               $textoCom.=MSG_GA_PDC_CAMPO_TINTA_DL_COM;
             $texto = MSG_GA_PDC_ENTIDAD_TINTA_DL_COM;
          }
          else if ($nombreTabla=="ga_pd_tinta_lito"){
               $textoCom.=MSG_GA_PDC_CAMPO_TINTA_LITO;
             $texto = MSG_GA_PDC_ENTIDAD_TINTA_LITO;
          }
           else if ($nombreTabla=="ga_pd_tinta_lito_comp"){
                $textoCom.=MSG_GA_PDC_CAMPO_TINTA_LITO_COM;
             $texto = MSG_GA_PDC_ENTIDAD_TINTA_LITO_COM;
           }

        if(!is_null($NombreCampo))
            return $textoCom;
         return $texto;
       }
       
       protected function NombresCampo($NombreCampo)
        {
            $texto=$NombreCampo;
          if ($NombreCampo=="cantidad_aditivo"){
             $texto = "Aditivos/1000 Tapas";
          }else if ($NombreCampo=="tinta_color")
          {
             $texto = "Desc Tinta";
          }else if ($NombreCampo=="pd_tinta_lito_id")
          {
             $texto = "Id Tinta Lito PD";
          }else if ($NombreCampo=="pd_tinta_dl_id")
          {
             $texto = "Id Tinta DL PD";
          }else if ($NombreCampo=="pd_barniz_id")
          {
             $texto = "Id Barniz PD";
          }else if ($NombreCampo==" tinta_color1")
          {
             $texto = "tinta";
          }else if ($NombreCampo=="tinta_id")
          {
             $texto = "Cod Tinta";
          }else if ($NombreCampo=="Id")
          {
             $texto = "ID";
          }else if ($NombreCampo=="porciento")
          {
             $texto ="Porciento";
          }
          else if ($NombreCampo=="cantidad_aditivo_m2"){

             $texto = "Aditivos/m2";
          }
          else if ($NombreCampo=="cantidad_m2_formula"){

             $texto = "Aditivos (Formula)";
          }
          else if ($NombreCampo=="barniz_color"){

             $texto = "Barniz Color";
          }
          else if ($NombreCampo=="color"){

             $texto = "Color";
          }
            else if ($NombreCampo=="utilizacion"){

             $texto = "Utilizacion";
          }
           else if ($nombreTabla=="wetwet"){

             $texto = "wet&wet";
          }
           else if ($NombreCampo=="pasadas_esmaltado"){

             $texto = "Pasadas Esmaltado";
           }
           else if ($NombreCampo=="pasadas_Tampografia"){

             $texto = "Pasadas Tampografia";
           }
           else if ($NombreCampo=="pasadas_HotStamping"){

             $texto = "Pasadas HotStamping";
           }
           else if ($NombreCampo=="pasadas_serigrafia"){

             $texto = "Pasadas Serigrafia";
           }
            else if ($NombreCampo=="pasadas_offset"){

             $texto = "Pasadas Offset";
           }
            else if ($NombreCampo=="pasadas_litografia"){

             $texto = "Pasadas Litografia";
           }
            else if ($NombreCampo=="pasadas_barniz"){

             $texto = "Pasadas Barniz";
           }

         return $texto;
       }
	
}