<?php 

require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/cambios/form/f_ga_pdc_list_cambiado.php');    

class f_ga_pdc_list_cambiado_update_update extends f_ga_pdc_list_cambiado 
{ 
        public function FetchDataSet()
        {                  
            $result=parent::FetchDataSet();       
                                                  //logErr($result,result,false);  
            foreach($result as $key=>$value)
            {                                  
                $result[$key]['nombre_entidad']=$value['tabla'];
                $result[$key]['campo']=$this->NombresCampo($value['campo']);
                $params=array('Id'=>$value['registro_id']);
                $resgitros=$this->buscarRegistro($value['tabla'],$params);  //logErr($resgitros[0],registros,false); 
                $cadena="";
                if(isset($resgitros[0]))
                {
                    foreach($resgitros[0] as $k=>$val) { // logErr($k,k,false); 
                        $campo=$this->NombresCampo($k);  
                        if($val=="" || is_null($val)) 
                            $val=" - ";
                        if($k=="identificador" )
                        $cadena.="<span style=\"color:#CC3300\"> Maquina:</span> <i>".$val."</i> ";
                        elseif($k=="info")
                        $cadena.="<span style=\"color:#CC3300\"> Tipo:</span> <i>".$this->cargarSelection("MAQUINA_INFOR",$val) ."</i> ";
                        else
                        $cadena.="<strong>".$campo.":</strong> <i>".$val."</i> ";
                    }
                }
                $result[$key]['detalle']=$cadena; 
            }
            
                                
            return $result;
        }

        public function AceptarCambioUpdate($num_pd)
        {
            if(!$num_pd){
             logErr("El valor del num_pd no puede ser:'".$num_pd."'",AceptarCambioUpdate,false) ;
             return;
             }
            $pdc=new GaPDC();

            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
            $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
           // logErr($num_pd, $num_pd, false);

            if ($selIds == null)
                $selIds[] = $id;

            foreach ($selIds as $id) {
                $pdc->aceptarPDCUpdate($id);  
                $pdc->eliminandoRegistros(null,$id,null,2);
            }
            //$this->ActualizarPD($num_pd);
            $this->ProcessPostAction();
        }
        
        
        public function cargarSelection($tag,$value)
    {
            
        $xmlFile = BizSystem::GetXmlFileWithPath ('erp.maquinas.Selection');
        if (!$xmlFile) return;
        $xmlArr = &BizSystem::GetXmlArray($xmlFile);     
        if ($xmlArr) {
          $i=0;
          if (!key_exists($tag, $xmlArr["SELECTION"]))
            return;
          foreach($xmlArr["SELECTION"][$tag] as $node) {
            if($value==$node["ATTRIBUTES"]["VALUE"])
            {
                $list[$i]['val'] = $node["ATTRIBUTES"]["VALUE"];
                if ($node["ATTRIBUTES"]["TEXT"])
                {
                    $list[$i]['txt'] = I18n::getInstance()->translate($node["ATTRIBUTES"]["TEXT"]) ;
                }

                else
                {
                    $list[$i]['txt'] = I18n::getInstance()->translate($list[$i]['val']);
                } 
                return $list[$i]['txt'];     
            }                                                  
            $i++;
          }
        }  
        return "-"; 
    }
      
}