<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg'); 

class PasadasPDCEasyForm extends EasyForm 
{ 
   
     public function FetchDataSet()
     {
		    $this->pdc=new GaPDC();
		    
		    $data=parent::FetchDataSet();
		    $name="epd.pd.dataobj.d_ga_pd_shell";
		    
		    if(!isset($data[0])) return $data;
		    
		    $dataSet=array();
		    $dataSet=$this->pdc->cargarDataObjUpdate($name,$data,$data[0]['pd_id']);
               
		    return $dataSet;
    }
    
    public function FetchData()
	{	
		$this->pdc=new GaPDC();
		
		$data[0]=parent::FetchData();
		$name="epd.pd.dataobj.d_ga_pd_shell";
		
		if(isset($data[0])){ 		
		$dataSet=array();
		$dataSet=$this->pdc->cargarDataObjUpdate($name,$data,$data[0]['pd_id']);
		}
		else{
			$Id=BizSystem::ClientProxy()->GetFormInputs('_selectedId');
			
			if(is_null($Id))
				$Id=BizSystem::ClientProxy()->GetFormInputs('fld_Id');
			
			if(is_null($Id)){
			
			foreach($this->m_SearchRuleBindValues as $k=>$v)
			{
				if(substr_count($this->m_FixSearchRule,$k)>0 && substr_count($this->m_FixSearchRule,'Id')>0)
				{
					$Id=$v;
					break;
				}
			}			
			}

			$data[0]['Id']=$Id;		
			$dataSet=$this->pdc->cargarDataObjUpdate($name,$data);	

		}	
	

		return $dataSet[0];
	}

    public function SaveRecord()
	{
    global $g_BizSystem;
	$this->pdc=new GaPDC();
	$recArr = $this->ReadInputRecord();
	
	$comprobacion=$this->pdc->comprobarPDC($recArr['pd_id']);
	if(!$comprobacion){
        $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
		$g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
		return;
	}
	
	 if ($this->m_FormType != "NEW"){
            $currentRec = $this->FetchData();
			
      }
       
        $this->SetActiveRecord($recArr);
        if (count($recArr) == 0)
            return;
                
        try {
            $this->ValidateForm();
        }
        catch (ValidationException $e) {
			$this->ProcessFormObjError($e->m_Errors);
			return;
        }   
        
      	$name="epd.pd.dataobj.d_ga_pd_shell";
		$dataRec= array();
		if ($this->m_FormType == "EDIT")
		{
			$dataRec['Id']=$currentRec['Id'];
			
			foreach ($recArr as $k => $v){
				
				if($currentRec[$k]!=$v ){
						 if(!($currentRec[$k]==0 && $v=="") ){
						$dataRec[$k]=$v;
                                    }
				}
					
			}			
			
			$this->pdc->registrarCambioUpdate($name,$dataRec,$currentRec['pd_id']);
		 
        }
       
        $this->ProcessPostAction();		
	}

	public function DeleteRecord($id=null)
	{ 	$this->pdc=new GaPDC();
		global $g_BizSystem;

	    if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".delete"))
            return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
        
        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;
        foreach ($selIds as $id) {
            $recArray = $this->GetDataObj()->FetchById($id);

			$comprobacion=$this->pdc->comprobarPDC($recArray['pd_id']);
			if(!$comprobacion){
			    $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
			return;
			}
			
			$name="epd.pd.dataobj.d_ga_pd_shell";
			
			if(is_null($recArray))
			{
			$recArray['Id']=$id;
			//logErr($recArray, 'recArrayNULL', false);
			$this->pdc->registrarCambioDelete($name,$recArray);
			}
			else{
			//logErr($recArray, 'recArrayNONULL', false);
			$this->pdc->registrarCambioDelete($name,$recArray,$recArray['pd_id']);
			}
            
        }
        if ($this->m_FormType == "LIST")
            $this->ReRender();
      
        $this->RunEventLog();
        $this->ProcessPostAction();
	}
    
   

}

?>