<?php 

include_once(MODULE_PATH.'/epd/pd/message/ga_pd_solicitudes_pd_generica.msg');   

class f_ga_pd_list_generica extends EasyForm 
{ 
	private $solicitud_pd_generica_id=null;
	
	function AceptarPDGenerica()
	{
	$this->solicitud_pd_generica_id=$_SESSION['solicitud_pd_generica_id'];
	global $g_BizSystem;
	$PD_ID = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
	
	//Busco el PD del ID Seleccionaddo
	$dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_generica");
	$dataObjPD->ResetRules();
	$dataObjPD->SetSearchRule("[Id]='".$PD_ID."'");
	$resultRecordsPD = $dataObjPD->Fetch();
    $num_pd = $resultRecordsPD[0]['num_pd'];

	if ($PD_ID==null || $PD_ID=='')
		return;
	
	//busco la solicitud de pd generica
	$dataObjGenerico = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_solicitud.dataobj.d_ga_pd_solicitud_g");
	$dataObjGenerico->ResetRules();
	$dataObjGenerico->SetSearchRule("[Id]='".$this->solicitud_pd_generica_id."'");
	$resultRecords = $dataObjGenerico->Fetch();
	$resultRecords=$resultRecords[0];   
	$dataObjGenerico->SetActiveRecordId($resultRecords['Id']);
	
	//logErr($resultRecords, 'resultRecords', false);

	$dataObjPDSolicitud = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_solicitud.dataobj.d_ga_pd_ga_pd_solicitud_generica");

	if(!is_null($resultRecords['num_pd']))
	{
	//Busco el ID del PD asociado
	$dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_generica");
	$dataObjPD->ResetRules();
	$dataObjPD->SetSearchRule("[num_pd]='".$resultRecords['num_pd']."'");
	$resultRecordsPD = $dataObjPD->Fetch();
	
	//BUsco en d_ga_pd_ga_pd_solicitud el registro del PD asociado para cambiartle el tipo de "0"(PD asociado) a "1"(PD candidata)
	
	$dataObjPDSolicitud->ResetRules();
	$dataObjPDSolicitud->SetSearchRule("[pd_id]='".$resultRecordsPD[0]['Id']."'");
	$dataObjPDSolicitud->SetSearchRule("[solicitud_pd_id]='".$this->solicitud_pd_generica_id."'");
	$resultRecordsSolicitud = $dataObjPDSolicitud->Fetch();
		if(isset($resultRecordsSolicitud[0])){
			$resultRecordsSolicitud=$resultRecordsSolicitud[0];
			$resultRecordsSolicitud['tipo']='1';
			//logErr($resultRecordsSolicitud, 'Cambio a Candidata', false);
			$dataObjPDSolicitud->UpdateRecord($resultRecordsSolicitud);	
		}
	}
	
	$resultRecords['num_pd']= $num_pd;
	
	$dataObjPDSolicitud->ResetRules();
	$dataObjPDSolicitud->SetSearchRule("[pd_id]='".$PD_ID."'");
	$dataObjPDSolicitud->SetSearchRule("[solicitud_pd_id]='".$this->solicitud_pd_generica_id."'");
	$resultRecordsSolicitud = $dataObjPDSolicitud->Fetch();
	$resultRecordsSolicitud = $resultRecordsSolicitud[0];
	//logErr($resultRecordsSolicitud, 'Cambio a AProbada', false);
	$resultRecordsSolicitud['tipo']='0';
	//logErr($resultRecordsSolicitud, resultRecordsSolicitud, false);
	
	try {

        $resultRecords['estado']=3;  
		$dataObjGenerico->UpdateRecord($resultRecords);	
		$dataObjPDSolicitud->UpdateRecord($resultRecordsSolicitud);	//logErr("3","3",false);

	    } 
		catch (ValidationException $e) {
	
                $errElements = $this->GetErrorElements($e->m_Errors); 
                $this->ProcessFormObjError($errElements);
                return;
           }
            catch (BDOException $e) {
            	$this->ProcessBDOException($e);	
                return;
            }
	        
	$aprobarPDMessage = $this->GetMessage("MSG_GA_PD_SOLICITUDES_PD_GENERICA_APROBAR_PD", array($num_pd));
    $g_BizSystem->GetClientProxy()->ShowClientAlert($aprobarPDMessage);
	$this->ProcessPostAction();

	
	}
    
    public  function RemoveRecord()
    {
         $rec = $this->GetActiveRecord();  
         if($rec['tipo']===0 || $rec['tipo']==='0' || $rec['tipo']=='0' || $rec['tipo']!=1){
            $dataAceptadaMessage = $this->GetMessage("MSG_GA_PD_SOLICITUDES_PD_GENERICA_DATA_ACEPTADA");
             BizSystem::ClientProxy()->ShowErrorMessage($dataAceptadaMessage);   
            return;    
            $this->actualizarEstado(2);
         }else
         {
         parent::RemoveRecord();
         }
    }
    
    public function actualizarEstado($estado)
    {
            global $g_BizSystem;  
            $dataObjGenerico = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_solicitud.dataobj.d_ga_pd_solicitud_g");
            $asociacion=$this->GetDataObj()->GetAssociation();  
            
            $dataObjGenerico->ResetRules();
            $dataObjGenerico->SetSearchRule("[Id]='".$asociacion['FieldRefVal']."'");
            $resultRecords = $dataObjGenerico->Fetch();
            $resultRecords=$resultRecords[0];   
            
            $resultRecords['estado']=2;  
            $result=$dataObjGenerico->UpdateRecord($resultRecords);    
                  //   logErr($result);   
    }
	
}