<?php 

include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');

class BarnizEasyForm extends EasyFormDinamic 
{ 
    public function SaveRecord()
    {	    
	    global $g_BizSystem;
	    $recArr = $this->ReadInputRecord();
        
        $this->SetActiveRecord($recArr);
        if (count($recArr) == 0)
            return;

      try {
            $this->ValidateForm();
        }
        catch (ValidationException $e) {
            $this->ProcessFormObjError($e->m_Errors);
            return;
        } 

	    //busca si existe en el compuesto esa tinta
	    $dataObjComp = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
	    if(!$dataObjComp) return false;
	    $dataObjComp->ResetRules();     //logErr($recArr['pd_barniz_id']);
        if(!is_null($recArr['pd_barniz_id']) && $recArr['pd_barniz_id']!="")
            $SetSearchRule="[pd_barniz_id]='".$recArr['pd_barniz_id']."'"; 
        else
            $SetSearchRule="[pd_barniz_id]='".$this->m_dependenciaId."'";                
	    $dataObjComp->FetchRecords($SetSearchRule,$recordList,-1,0,true,true); //logErr($recordList);

	    
	    $i=0;
	    //formatear este numero
	    $datoPorciento=0;
	    foreach($recordList as $key=>$val){
		    if($val['barniz_id']==$recArr['barniz_id']){
		    $recordSet[$i++]=$val;
		    }
	       // $datoPorciento=$datoPorciento+$val['porciento'];
	    }		
			    
	    if($this->m_FormType == "NEW"){		  
	       // $ban=($datoPorciento+$recArr['porciento'])>100;

		    if(isset($recordSet[0])){
		        $existeBarnizMessage = $this->GetMessage("MSG_GA_PD_BARNIZ_YA_EXISTE_BARNIZ", array($recArr['barniz_color']));
                BizSystem::ClientProxy()->ShowErrorMessage($existeBarnizMessage);
		    return;
		    }
	    }
     /*   elseif($this->m_FormType == "EDIT"){   
		    $dataObjComp->ResetRules();
		    $searchRuleComp="[Id]='".$recArr['Id']."'"; 
		    $recordListComp = array();
		    $dataObjComp->FetchRecords($searchRuleComp,$recordListComp,-1,0,true,true);   
		    $datoPorcientoComp=$dataObjComp->m_BizRecord->get('porciento')->GetValue();   //logErr($recArr['porciento']);
                             
		    $ban=($datoPorciento-$datoPorcientoComp+$recArr['porciento'])>100.00;
	    }
	    
	    if($ban){
             $porcientoExcedeMessage = $this->GetMessage("MSG_GA_PD_BARNIZ_PORCIENTO_EXCEDE");
		     BizSystem::ClientProxy()->ShowErrorMessage($porcientoExcedeMessage);
		     return;
	    }
      */    
         parent::SaveRecord();
	    
    }

    public function FetchData()   
    {
             if($this->m_Errors)
        {
            return $this->GetActiveRecord();
            
        }
     $result=array();
     if($this->m_FormType == "NEW"){
        $result=parent::FetchData();
     }elseif($this->m_FormType == "EDIT"){
                   
     if ($this->m_FixSearchRule) {
        if ($this->m_SearchRule)
            $searchRule = $this->m_SearchRule . " AND " . $this->m_FixSearchRule;
        else
            $searchRule = $this->m_FixSearchRule;
    }

        $this->GetDataObj()->SetSearchRule($searchRule);
        QueryStringParam::SetBindValues($this->m_SearchRuleBindValues);

         $this->GetDataObj()->FetchRecords($serachRule,$result,-1,0,false,true);    
         
         $this->m_RecordId = $result[0]['Id'];
         $this->SetActiveRecord($result[0]);

         QueryStringParam::ReSet();   
     }

     $result=$result[0];
     if(!isset($result['pd_barniz_id']) || !isset($result['Id'])){
     
         $getKeys = array_keys($_REQUEST);
         $param_flds = null;
         foreach ($getKeys as $key) {
            if (substr($key, 0, 4) == "fld:") {
                $fldName = substr($key, 4);
                $fldValue = $_REQUEST[$key];
                $param_flds[$fldName] = $fldValue;
            }
            }
            
         if(count($param_flds)>=1){
           $result['pd_barniz_id']=$param_flds['pd_barniz_id'];
           $this->m_dependenciaId=$param_flds['pd_barniz_id'];
         }else{
            $result['pd_barniz_id']=$this->m_dependenciaId;
         }
     
     }  
       // $_SESSION['pd_barniz_id_p']= $result['pd_barniz_id'];    //logErr( $_SESSION['pd_barniz_id_p'],pd_barniz_id_p,false);
                
        $dataObjName="epd.pd_barniz.dataobj.d_ga_pd_barniz";
        $srcDataObj=BizSystem::GetObjectFactory()->GetObject($dataObjName);
        $srcDataObj->ResetRules();  
        $srcDataObj->setSearchRule("[Id]='".$result['pd_barniz_id']."'");
        $list=$srcDataObj->Fetch();    
        
       if(isset($list[0]))
            $result['tipo_barniz']=$list[0]['utilizacion'];
        
       return $result;
    }

    public function cargarIds()
    {
    $dataObjName="epd.pd_barniz.dataobj.d_ga_pd_barniz";
    $srcDataObj=BizSystem::GetObjectFactory()->GetObject($dataObjName);
    $recArr = $this->ReadInputRecord(); 
    $searchRule="[Id]=".$recArr['pd_barniz_id'];
    $result=array();
    $srcDataObj->FetchRecords($searchRule,$result);
    return array('pd_id'=>$result[0]['pd_id'],'pd_barniz_id'=>$recArr['pd_barniz_id']);
    }   

    protected function ProcessPostAction()
    {     
    unset($_SESSION['pd_barniz_id_p']);   
    // get the $redirectPage from eventHandler
    list($redirectPage,$target) = $this->GetRedirectPage();    
    if ($redirectPage)
    {
        $ids=$this->cargarIds();    // logErr($redirectPage.$ids['pd_id']."#".$ids['pd_barniz_id']);
        // otherwise, do page redirection
        BizSystem::ClientProxy()->ReDirectPage($redirectPage.$ids['pd_id']."#".$ids['pd_barniz_id']);
    }
    }
}

?>