<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once MODULE_PATH.'/epd/pd_barniz/form/f_ga_pd_barniz_comp_pdc_list.php'; 
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg'); 

class f_ga_pd_barniz_comp_pdc extends f_ga_pd_barniz_comp_pdc_list 
{ 	
    public function FetchData()
    {    
        if($this->m_Errors)
        {
            return $this->GetActiveRecord();
            
        } 
        $result=array();
        $this->pdc=new GaPDC();
        
        if($this->m_FormType == "NEW"){
            $result=parent::FetchData();
        }
        elseif($this->m_FormType == "EDIT")
        {
                       
             if ($this->m_FixSearchRule) {
                if ($this->m_SearchRule)
                    $searchRule = $this->m_SearchRule . " AND " . $this->m_FixSearchRule;
                else
                    $searchRule = $this->m_FixSearchRule;
            }
        
            $this->GetDataObj()->SetSearchRule($searchRule);
            QueryStringParam::SetBindValues($this->m_SearchRuleBindValues);

             $this->GetDataObj()->FetchRecords($serachRule,$result,-1,0,false,true);    
             
             $this->m_RecordId = $result[0]['Id'];
             $this->SetActiveRecord($result[0]);

             QueryStringParam::ReSet();   
         }
             
        $name="epd.pd_barniz.dataobj.d_ga_pd_barniz_comp"; 
        if(isset($result[0]))
        {         
        $result=$this->pdc->cargarDataObjUpdate($name,$result,$result[0]['pd_id']);
        }
        else{
        
            if(isset($_GET['fld:Id']))  
            {
                $result[0]['Id']=$_GET['fld:Id'];        
                $result=$this->pdc->cargarDataObjUpdate($name,$result);    
            }    
        }
            
         $result=$result[0];
         
         if(!isset($result['pd_barniz_id']) || !isset($result['Id']))
         {
         
             $getKeys = array_keys($_REQUEST);
             $param_flds = null;
             foreach ($getKeys as $key) {
                if (substr($key, 0, 4) == "fld:") {
                    $fldName = substr($key, 4);
                    $fldValue = $_REQUEST[$key];
                    $param_flds[$fldName] = $fldValue;
                }
                }
                
             if(count($param_flds)>=1){
               $result['pd_barniz_id']=$param_flds['pd_barniz_id'];
               $this->m_dependenciaId=$param_flds['pd_barniz_id'];
             }else{
                $result['pd_barniz_id']=$this->m_dependenciaId;
             }
         
         }  
                    
            $dataObjName="epd.pd_barniz.dataobj.d_ga_pd_barniz";
            $srcDataObj=BizSystem::GetObjectFactory()->GetObject($dataObjName);
            $srcDataObj->ResetRules();  
            $srcDataObj->setSearchRule("[Id]='".$result['pd_barniz_id']."'");
            $list=$srcDataObj->Fetch();  
            $list=$this->pdc->cargarDataObjUpdate($dataObjName,$list,$list[0]['pd_id']);  
                    
           if(isset($list[0]['utilizacion']))
                $result['tipo_barniz']=$list[0]['utilizacion']; 
           else
           {  
               $result2=$this->pdc->cargardataObjInsert($dataObjName,null,$result['pd_barniz_id']);
               if(isset($result2[0]))
                $result['tipo_barniz']=$result2[0]['utilizacion'];
           }
            
         return $result;
    }
        
    public function FetchDataSet()
    {		
            $Ids=$this->cargarIds();   
            $this->num_pd_dl=$Ids['pd_id'];  	
		    
		    $this->pdc=new GaPDC();
		    
            $this->SetFixSearchRule("[pd_barniz_id]='".$Ids['pd_barniz_id']."'"); 
		    $data=parent::FetchDataSet();
		    $name="epd.pd_barniz.dataobj.d_ga_pd_barniz_comp";
		    
		    $dataSet=array();
		    if(!isset($data[0])){ 
		    $dataSet=$this->pdc->cargarDataObjUpdate($name,$data,$this->num_pd_barniz);
		    }else{
		    $dataSet=$this->pdc->cargarDataObjUpdate($name,$data,$data[0]['pd_id']);
		    }
		    $temp=array(); 
            foreach($dataSet as $item)
            {                      
                if($item['pd_barniz_id']==$Ids['pd_barniz_id'])
                    $temp[]=$item;
            } 
            $dataSet=$temp;
		    //logErr($dataSet, 'FetchDataSet', false);
		    return $dataSet;
    }
    
    public function SaveRecord()
	{
		if(isset($_SESSION['num_pd_barniz']))
			$this->num_pd_barniz=$_SESSION['num_pd_barniz'];
		
		$this->pdc=new GaPDC();
	    $recArr = $this->ReadInputRecord();
		
		//validacion de que ese PD no este siendo modificado por otro operador
		global $g_BizSystem;
		if(!is_null($this->num_pd_barniz))
			$comprobacion=$this->pdc->comprobarPDC($this->num_pd_barniz);
		else
			$comprobacion=false;

		if(!$comprobacion){
				 $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                 $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
				return;
		}
	
		//busca si existe en el compuesto esa tinta
		$recordList = $this->FetchDataSet();
		//logErr($recordList, 'recordList', false);
		
		$i=0;
		$datoPorciento=0;$recordSet=array();
		foreach($recordList as $val){
			if($val['barniz_id']==$recArr['barniz_id']){
			$recordSet[$i++]=$val;
			}
			$datoPorciento+=$val['porciento'];	
            if($recArr['Id']==$val['Id'])
                 $currentRec=$val;
		}
				
		
		if($this->m_FormType == "NEW")
        {		  
			$ban=($datoPorciento+$recArr['porciento'])>100;		
			if(isset($recordSet[0])){
                $existeTintaMessage = $this->GetMessage("MSG_GA_PD_EXISTE_TINTA_COMPUESTO", array($recArr['barniz_color']));
			    BizSystem::ClientProxy()->ShowErrorMessage($existeTintaMessage);
			return;
			}
		}	
		elseif($this->m_FormType == "EDIT")
        {   				
		$dataObjComp = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
		
		if(!$dataObjComp) return false;
		$dataObjComp->ResetRules();
		$searchRule="[pd_barniz_id]='".$recArr['pd_barniz_id']."'";
		$recordList = array();
		$dataObjComp->FetchRecords($searchRule,$recordList);
		//BizSystem::log(LOG_ERR, 'recordList2', var_export($recordList, true));
		
		$name="epd.pd_barniz.dataobj.d_ga_pd_barniz_comp";
		
		$dataSet=array();
		$dataSet=$this->pdc->cargarDataObjUpdate($name,$recordList,$recordList[0]['pd_id']);
		
		//BizSystem::log(LOG_ERR, 'dataSet2', var_export($dataSet, true));
		 
		foreach($dataSet as $da){
		$NewdatoPorciento+=$da['porciento'];
		if($da['Id']==$recArr['Id'])
				$datoPorcientoComp=$da['porciento'];
		}
		
		$ban=($NewdatoPorciento-$datoPorcientoComp+$recArr['porciento'])>100;

		}
		
		//preparacion para insertar o update
		if($ban){
		     $porcientoExcedeMessage = $this->GetMessage("MSG_GA_PD_BARNIZ_PORCIENTO_EXCEDE");
             BizSystem::ClientProxy()->ShowErrorMessage($porcientoExcedeMessage);
		 return;
		}
		
		
        if ($this->m_FormType != "NEW"){
           // $currentRec = $this->FetchData(); 
		
		}
       
        $this->SetActiveRecord($recArr);
        if (count($recArr) == 0)
            return;
                
        try {
            $this->ValidateForm();
        }
        catch (ValidationException $e) {
			$this->ProcessFormObjError($e->m_Errors);
			return;
        }   
         
		$name="epd.pd_barniz.dataobj.d_ga_pd_barniz_comp";
		$dataRec= array();
		if ($this->m_FormType == "EDIT")
		{
			$dataRec['Id']=$currentRec['Id'];
			foreach ($recArr as $k => $v){

				if($currentRec[$k]!=$v ){
						$dataRec[$k]=$v;
				}
					
			}	                             
			//logErr($dataRec, 'dataRec', true);
			$this->pdc->registrarCambioUpdate($name,$dataRec,$currentRec['pd_id']);
		 
        }
        else if($this->m_FormType == "NEW")
		{
			if(!isset($recArr['pd_barniz_id']))return ;
			$doName="epd.pd_barniz.dataobj.d_ga_pd_barniz";
			$doNameregirtro="epd.pdc.dataobj.d_ga_pdc";

			global $g_BizSystem;
			$svcobj = $g_BizSystem->GetService("queryService");
			
			while(true)
			{
			$recArr['Id']=rand(90000,100000);
			$Id=$svcobj->FetchField($doNameregirtro,"[registro_id]=".$recArr['Id'],"Id");
                             //logErr($Id,id,false); 
			if(is_null($Id))
				break;
			}
			
			$svcobj = $g_BizSystem->GetService("queryService");
			$numpd=$svcobj->FetchField($doName,"[Id]=".$recArr['pd_barniz_id'],"pd_id");
            if(!$numpd)                                                          
            {
                $search="[registro_id]='".$recArr['pd_barniz_id']."' and [tabla]='ga_pd_barniz'";
                $busqueda=$svcobj->FetchAll($doNameregirtro,$search); 
                if(is_array($busqueda))
                foreach($busqueda as $valor)
                {
                   if($valor['campo']=='pd_id') 
                        $numpd=$valor['valor'];
                   elseif($valor['campo']=='utilizacion')
                        $pd_barniz['utilizacion']=$valor['valor'];
                   elseif($valor['campo']=='pd_shell_id')
                        $pd_barniz['pd_shell_id']=$valor['valor'];
                }
                
            }
            
			$currentRec['pd_id']=$numpd; 
			// get pdc dataobj
			$DataObjBarniz = $g_BizSystem->GetObjectFactory()->GetObject("erp.barniz.dataobj.d_ga_barniz");
			
			$DataObjBarniz->ResetRules();
			$DataObjBarniz->SetSearchRule("[Id]='".$recArr['barniz_id']."'");
			$Set=$DataObjBarniz->Fetch();
		
			$recArr['barniz_referencia']=$Set[0]['referencia'];
			$recArr['barniz_proveedor']=$Set[0]['proveedor'];
            $vacio="0";
            $recArr['porciento']=(string) $vacio;             
            $recArr['cantidad_aditivo']=(string) $vacio;             
            $recArr['cantidad_aditivo_m2']=(string) $vacio;       
            $recArr['pd_id']=$currentRec['pd_id'];   	

            if(!isset($pd_barniz['utilizacion']))  
            $pd_barniz=$this->buscarPdBarniz($recArr);

            
            if(isset($pd_barniz['pd_shell_id']))
            {
                $recArr['pd_shell_id']=$pd_barniz['pd_shell_id'];
                $recArr['utilizacion']=$pd_barniz['utilizacion']; 
            }			 
			      //logErr($recArr,recArr,true);    
			$this->pdc->registrarCambioInsert($name,$recArr,$numpd); 
		}
            //extraer listado completo
            $listado=$this->extraerListadoCompleto($recArr['pd_barniz_id']); //logErr($listado,listado,false);
            
            //recalcular los valores
            $this->recalcularFormulas($listado);  //logErr($listado,recalculado,false);
            $activo=$this->GetActiveRecord();  
            
            //registroCambioUpdate
            foreach($listado as $value)
            {
                 $cambio['Id']=$value['Id'];
                //$cambio['cantidad_m2_formula']=(string)$value['cantidad_m2_formula'];
                $cambio['porciento']=(string)$value['porciento'];
                $cambio['cantidad_aditivo']=(string) $value['cantidad_aditivo'];
                $cambio['cantidad_aditivo_m2']=(string)$value['cantidad_aditivo_m2'];
                                
                $cambio['estado_cantidad_m2_formula']=$value['estado_cantidad_m2_formula'];    
                                
                $this->pdc->registrarCambioUpdate($name,$cambio,$currentRec['pd_id'],false,true);
             
              /* if($activo['Id']==$cambio['Id'])    
                {
                    $cambio=null;
                    $cambio['Id']=$value['Id'];
                    $cambio['porciento']=(string)$value['porciento'];    
                    $this->pdc->registrarCambioUpdate($name,$cambio,$currentRec['pd_id']);  
                }       */
                // logErr($cambio,cambio,false); //logErr($currentRec['pd_id'], 'pd_id', false);    
                unset($cambio);  
            }
               
        $this->ProcessPostAction();
	}

    protected function ProcessPostAction()
    {
        // get the $redirectPage from eventHandler
        list($redirectPage,$target) = $this->GetRedirectPage();    
        if ($redirectPage)
        {
            $ids=$this->cargarIds();    
            // otherwise, do page redirection
            BizSystem::ClientProxy()->ReDirectPage($redirectPage.$ids['pd_id']."#".$ids['pd_barniz_id']);
        }
    }
    
    public function cargarIds()
    {
        if(isset($_SESSION['num_pd_barniz']))
            $this->num_pd_barniz=$_SESSION['num_pd_barniz']; 
        $recArr = $this->ReadInputRecord(); 
        return array('pd_id'=> $this->num_pd_barniz,'pd_barniz_id'=>$recArr['pd_barniz_id']);
    } 
    
    protected function ValidateForm()
    {
        $this->m_ValidateErrors = array();
        $this->m_DataPanel->rewind();
        
        while($this->m_DataPanel->valid()){                
            $elem=$this->m_DataPanel->current();   
            if($elem->m_Label){
                $elem_name = $elem->m_Label;
            }else{
                $elem_name = $elem->m_Text;
            }
            if($elem->m_BlankOption){ 
                if($elem->m_Value==-1 || ($elem->m_Value=='0' && $elem->CheckRequired() === true)){
                    $errorMessage = $this->GetMessage("DATA_FIELD_REQUIRED",array($elem_name));
                    $this->m_ValidateErrors[$elem->m_Name] = $errorMessage;
                    }
            }
             if ($elem->CheckRequired() === true &&
                 ($elem->m_Value===null || $elem->m_Value === "")) {
                //logErr($elem, 'elem', false);
                $errorMessage = $this->GetMessage("DATA_FIELD_REQUIRED",array($elem_name));
                $this->m_ValidateErrors[$elem->m_Name] = $errorMessage;  
                
             }
             
             if($elem->CheckRequired() === true)
             {                                
                $comp=false;
                $bizField=$this->GetDataObj()->m_BizRecord->get($elem->m_FieldName);
                //logErr($bizField,field,false);  
                //logErr($elem->m_Value,m_Value,false);  
                if($bizField) 
                    $comp=$bizField->CheckValueType($elem->m_Value);  
                   // logErr($comp,comp,false);
                if(!$comp)
                {
                $errorMessage = $this->GetMessage("MSG_GA_PD_TIPO_INCORRECTO_DATO",array($elem_name));
                $this->m_ValidateErrors[$elem->m_Name] = $errorMessage;  
                //logErr($this->m_ValidateErrors,vali,false);
                }
             }         
 
             $this->m_DataPanel->next() ;
        }
               
        if (count($this->m_ValidateErrors) > 0)
        {             
            throw new ValidationException($this->m_ValidateErrors);
            return false;
        }
        return true;
    }
 
}

?>