<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';   
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');

class f_ga_pdc_color_list extends EasyForm 
{ 
    private $pdc;
    public function guardar($value,$order)
    {           
        if($value['pd_num_pd'])
        {
            if($value['tipo']==3)
                $dataobj=BizSystem::GetObjectFactory()->GetObject("epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito_order");   
            else
                $dataobj=BizSystem::GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_order"); 
                
            $newRecord=$value;  
            $newRecord['no_order']=$order; 
        }else
        {
            $tabla="ga_pd_tinta_lito";
            if($value['tipo']==1)
                $tabla="ga_pd_barniz";
            $dataobj=BizSystem::GetObjectFactory()->GetObject("epd.pdc.dataobj.d_ga_pdc");  
            $dataobj->ResetRules();
            $dataobj->SetSearchRule("[accion]='1'");
            $dataobj->SetSearchRule("[tabla]='".$tabla."'");
            $dataobj->SetSearchRule("[registro_id]='".$value['Id']."'");
            $dataobj->SetSearchRule("[pd_id]='".$value['pd_id']."'");     
            $dataobj->SetSearchRule("[campo]='no_order'");  //logErr($value,value1,false);    
            $value=$dataobj->Fetch();   //logErr($value[0],value2,false);
            if(isset($value[0]))
            $value=$value[0];  
            $newRecord=$value;
            $newRecord['valor']=$order; 
        }        
            
        $ok=$dataobj->UpdateRecord($newRecord,$value);
                         
        return $ok;
    }
    
    public function Subir($id=null)
    {                                            //logErr($id);
        $listado=$this->FetchDataSetOrder();        // logErr($listado);  
        if(!is_array($listado)) return ;
        $cant=count($listado);
        if($cant==1 || $cant==0 || !$id) $this->UpdateForm();
                                                    // logErr($cant); 
                                                     
        foreach($listado as $key=>$value)
        {               //  logErr($value,item,false);         
            if($value['Id']==$id)
            {
                
                $ok= $this->guardar($listado[$key],$listado[$key-1]['lugar']);  //logErr($ok,$listado[$key]['Id'],false);    
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
                $ok= $this->guardar($listado[$key-1],$listado[$key]['lugar']); //logErr($ok,$listado[$key-1]['Id'],false);   
               if(!$ok)
               {
                   logErr($listado[$key-1]['Id'],"Se partio intentado subir",false);
               }
                $listado[$key]['no_order']=$listado[$key-1]['lugar'];
                $listado[$key-1]['no_order']=$listado[$key]['lugar'];
                $listado[$key]['lugar']=$listado[$key]['no_order'];
                $listado[$key-1]['lugar']=$listado[$key-1]['no_order'];  // logErr($listado); 
                break;
            }
        }                              //  logErr($listado);  
        foreach($listado as $key=>$value)
        {
            if($value['no_order']!=$value['lugar'])
            {
               $ok= $this->guardar($value,$value['lugar']);
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
            }
        }
        
        $this->UpdateForm();
    }
    
     public function Bajar($id=null)
    {
        $listado=$this->FetchDataSetOrder();        // logErr($listado);  
        if(!is_array($listado)) return ;
        $cant=count($listado);
        if($cant==1 || $cant==0 || !$id) $this->UpdateForm();
                                                    // logErr($cant); 
                                                     
        foreach($listado as $key=>$value)
        {
            if($value['Id']==$id)
            {
                
                $ok= $this->guardar($listado[$key],$listado[$key+1]['lugar']);  //logErr($ok,$listado[$key]['Id'],false);    
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
                $ok= $this->guardar($listado[$key+1],$listado[$key]['lugar']); //logErr($ok,$listado[$key-1]['Id'],false);   
               if(!$ok)
               {
                   logErr($listado[$key-1]['Id'],"Se partio intentado subir",false);
               }
                $listado[$key]['no_order']=$listado[$key+1]['lugar'];
                $listado[$key+1]['no_order']=$listado[$key]['lugar'];
                $listado[$key]['lugar']=$listado[$key]['no_order'];
                $listado[$key+1]['lugar']=$listado[$key+1]['no_order'];  // logErr($listado); 
                break;
            }
        }                              //  logErr($listado);  
        foreach($listado as $key=>$value)
        {
            if($value['no_order']!=$value['lugar'])
            {
               $ok= $this->guardar($value,$value['lugar']);
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
            }
        }
        
        $this->UpdateForm();
    }
    
    public function actualizarOrden()
    {                          
       $listado=$this->FetchDataSetOrder();           
        if(!is_array($listado)) return ;
        $cant=count($listado);
        if($cant==1 || $cant==0 || !$id) $this->UpdateForm();
        
        foreach($listado as $key=>$value)
        {
            if($value['no_order']!=$value['lugar'])
            {
               $ok= $this->guardar($value,$value['lugar']);
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
            }
        }  
        $this->UpdateForm();  
    }
       
    public function GetSessionVars($sessCtxt)  
    {   
		$sessCtxt->GetObjVar($this->m_Name, "CurrentPage", $this->m_CurrentPage);
        parent::GetSessionVars($sessCtxt); 
    }
    public function SetSessionVars($sessCtxt) 
    {   
        $this->m_Name = "epd.pd_barniz.form.f_ga_pd_barniz_list";
        $sessCtxt->SetObjVar($this->m_Name, "CurrentPage", $this->m_CurrentPage); 
        parent::SetSessionVars($sessCtxt);         
        
    } 
    
    public function DeleteRecord($id=null,$tipo=null)
    {
        $this->pdc=new GaPDC();
        global $g_BizSystem; 

        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
                    
        $dataobj=null;   
        if($tipo==3)
            $dataobj=BizSystem::GetObjectFactory()->GetObject("epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito");   
        else
            $dataobj=$this->GetDataObj();
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;            
        foreach ($selIds as $id) {
            $recArray = $this->GetDataObj()->FetchById($id);
            
            $comprobacion=$this->pdc->comprobarPDC($recArray['pd_id']);
            if(!$comprobacion){
                $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
            return;
            }
            if($tipo==3) 
                $name="epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito";
            else
                $name="epd.pd_barniz.dataobj.d_ga_pd_barniz";  
            
            if(is_null($recArray))
            {
            $recArray['Id']=$id;
            //logErr($recArray, 'recArrayNULL', false);
            $this->pdc->registrarCambioDelete($name,$recArray);
            }
            else{
            //logErr($recArray, 'recArrayNONULL', false);
            $this->pdc->registrarCambioDelete($name,$recArray,$recArray['pd_id']);
            }
            
        }             
        $this->actualizarOrden();  
        $redirectPage="controller.php?view=epd.pdc.view.ga_pd_detail&fld:Id=".$_GET['fld:Id'];
        BizSystem::ClientProxy()->ReDirectPage($redirectPage);  
      
        
        $this->RunEventLog();
        $this->ProcessPostAction();
    }
   
   public function FetchDataSetOrder()
   {
       $this->pdc=new GaPDC();
        $i=1;
        $result=parent::FetchDataSet();    
        $AssociationB=$this->GetDataObj()->GetAssociation();
        $FieldRefVal=$AssociationB['FieldRefVal'];
        $name="epd.pd_barniz.dataobj.d_ga_pd_barniz"; 
        
        $nre=$this->GetDataObj()->NewRecord();
         if(isset($nre['pd_shell_id']) && $nre['pd_shell_id']>0)
        {
            $shell_pd=BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
            $data=$shell_pd->FetchById($nre['pd_shell_id']);
            
            if(isset($data['pd_id']) && $data['pd_id']>0)
            $pd_id=$data['pd_id'];
        }
          // logErr($pd_id);
        $result2=$this->pdc->cargardataObjInsert($name,$pd_id); //logErr($result1);
        if(is_array($result2))
        foreach($result2 as $value)
            $result[]=$value;
            
        if(isset($result[0]))
        {                                                                            // logErr($result);
            $result=$this->pdc->cargarDataObjUpdate($name,$result,$result[0]['pd_id']);  
            //$pd_id=$result[0]['pd_id']; 
            if($pd_id) $_SESSION['num_pd_barniz']=$pd_id; 
             
            foreach($result as $key=>$value)
            {           
                $result[$key]['tipo']=1;
            }  
        }     
         // logErr($result);
         //aqui esta la adicion de las Lito
       $formObjLito = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_pdc_list");
       $name="epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito"; 
        
       $AssociationL=$formObjLito->GetDataObj()->GetAssociation(); 
       if($FieldRefVal>0)
       $AssociationL['FieldRefVal']=$FieldRefVal;
       $formObjLito->GetDataObj()->SetCustomAssociation($AssociationL);

       $resultLito=$formObjLito->FetchDataSet();
       
       $nre=$formObjLito->GetDataObj()->NewRecord();
         if(isset($nre['pd_shell_id']) && $nre['pd_shell_id']>0)
        {
            $shell_pd=BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
            $data=$shell_pd->FetchById($nre['pd_shell_id']);
            
            if(isset($data['pd_id']) && $data['pd_id']>0)
            $pd_id=$data['pd_id'];
        }
        $result1=$this->pdc->cargardataObjInsert($name,$pd_id); //logErr($result1);
        
        if(is_array($result1))
        foreach($result1 as $value)
            $resultLito[]=$value;
       
       if(isset($resultLito[0]))
       { 
            $resultLito=$this->pdc->cargarDataObjUpdate($name,$resultLito,$resultLito[0]['pd_id']);
            //$pd_id=$resultLito[0]['pd_id']; 
            if($pd_id) $_SESSION['num_pd_lito']=$pd_id;
                    
            foreach($resultLito as $key=>$value)
            {           
                $resultLito[$key]['tipo']=3;
            } 
            foreach($resultLito as $values)
                $result[]=$values;
       }
       
       return $this->ordenar($result); 
   }
   
    public function FetchDataSet()
    {
        $this->pdc=new GaPDC();
        $i=1;
        $result=parent::FetchDataSet();   
        $AssociationB=$this->GetDataObj()->GetAssociation();
        $FieldRefVal=$AssociationB['FieldRefVal'];  
        $name="epd.pd_barniz.dataobj.d_ga_pd_barniz"; 
                 
        $nre=$this->GetDataObj()->NewRecord();
         if(isset($nre['pd_shell_id']) && $nre['pd_shell_id']>0)
        {
            $shell_pd=BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
            $data=$shell_pd->FetchById($nre['pd_shell_id']);
            
            if(isset($data['pd_id']) && $data['pd_id']>0)
            $pd_id=$data['pd_id'];
        }
        
        $result2=$this->pdc->cargardataObjInsert($name,$pd_id); 
        if(is_array($result2))
        foreach($result2 as $value)
        {     
            if(isset($value[$AssociationB['Column']]) && $value[$AssociationB['Column']]==$AssociationB['FieldRefVal'])
                $result[]=$value;
        }
            
        if(isset($result[0]))
        {                                                                            // logErr($result);
            $result=$this->pdc->cargarDataObjUpdate($name,$result,$result[0]['pd_id']);  
            $pd_id=$result[0]['pd_id']; 
            if($pd_id) $_SESSION['num_pd_barniz']=$pd_id; 
            
            $dataObj = BizSystem::GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
            if (!$dataObj) return false;
            
            foreach($result as $key=>$value)
            {           
                $dataObj->ResetRules();
                $SearchRule="[pd_barniz_id]='".$value['Id']."'";
                $records=array();
                $dataObj->FetchRecords($SearchRule,$records,-1,0,true,true);
             
                //trato especial
                $name="epd.pd_barniz.dataobj.d_ga_pd_barniz_comp";
                $records=$this->pdc->cargarDataObjUpdate($name,$records,$pd_id); 
                $temp=array();
                    foreach($records as $item)
                    {                      
                        if($value['Id']==$item['pd_barniz_id'])
                            $temp[]=$item;
                    } 
                $records=$temp;
                    
                $formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_barniz.form.f_ga_pd_barniz_comp_pdc_list"); 
                $dataPanel = $formObj->m_DataPanel->RenderTable($records);  
                $actionPanel = $formObj->m_ActionPanel->Render(); 
                $navPanel= $formObj->m_NavPanel->Render(); 
                
                $result[$key]['subform']['dataPanel']=$dataPanel;
                $result[$key]['subform']['actionPanel']=$actionPanel;
                $result[$key]['subform']['navPanel']=$navPanel;
                $result[$key]['subform']['name']="epd.pd_barniz.form.f_ga_pd_barniz_comp_pdc_list";
                $result[$key]['subform']['newobj']="\n<script> NewObject('" . $formObj->m_Name."','" . $formObj->m_jsClass . "'); </script>\n";;
                $result[$key]['newobj']="\n<script> NewObject('" . $formObj->m_Name. "','" . $formObj->m_jsClass . "'); </script>\n";;
                $result[$key]['tipo']=1;
                
                
                unset($formObj);
            }  
        }     
   
         //aqui esta la adicion de las Lito
       $formObjLito = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_pdc_list");
       $name="epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito"; 
        
       $AssociationL=$formObjLito->GetDataObj()->GetAssociation(); 
       if($FieldRefVal>0)
       $AssociationL['FieldRefVal']=$FieldRefVal;
       $formObjLito->GetDataObj()->SetCustomAssociation($AssociationL);

       $resultLito=$formObjLito->FetchDataSet();
       
       $nre=$formObjLito->GetDataObj()->NewRecord();
         if(isset($nre['pd_shell_id']) && $nre['pd_shell_id']>0)
        {
            $shell_pd=BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
            $data=$shell_pd->FetchById($nre['pd_shell_id']);
            
            if(isset($data['pd_id']) && $data['pd_id']>0)
            $pd_id=$data['pd_id'];
        }
        $result1=$this->pdc->cargardataObjInsert($name,$pd_id); //logErr($result1);
        
        if(is_array($result1))
        foreach($result1 as $value)
        {
            if(isset($value[$AssociationL['Column']]) && $value[$AssociationL['Column']]==$AssociationL['FieldRefVal'])
            $resultLito[]=$value;
        }
       
       if(isset($resultLito[0]))
       { 
            $resultLito=$this->pdc->cargarDataObjUpdate($name,$resultLito,$resultLito[0]['pd_id']);
            $pd_id=$resultLito[0]['pd_id']; 
            if($pd_id) $_SESSION['num_pd_lito']=$pd_id;
             
            $dataObj = BizSystem::GetObjectFactory()->GetObject("epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito_comp");
            if (!$dataObj) return false;
            
            foreach($resultLito as $key=>$value)
            {           
                if($value['maquina_litografica_tipo']==2)
                {
                    $resultLito[$key]['cuerpo']=$value['maquina_litografica_tipo'];                    
                    $resultLito[$key]['cuerpo_bandera']=-1;                    
                }else{
                    $resultLito[$key]['cuerpo_bandera']=0;
                    $resultLito[$key]['cuerpo']==0;
                }
                $dataObj->ResetRules();
                $SearchRule="[pd_tinta_lito_id]='".$value['Id']."'";
                $records=array();
                $dataObj->FetchRecords($SearchRule,$records,-1,0,true,true); //logErr($records,record,false);   
       
                //trato especial
                $name="epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito_comp";
                $records=$this->pdc->cargarDataObjUpdate($name,$records,$pd_id); 
                $temp=array();
                    foreach($records as $item)
                    {                      
                        if($value['Id']==$item['pd_tinta_lito_id'])
                            $temp[]=$item;
                    } 
                 $records=$temp;
                          
                $formObjLito = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_comp_pdc_list"); 
                $dataPanel = $formObjLito->m_DataPanel->RenderTable($records);  
                $actionPanel = $formObjLito->m_ActionPanel->Render(); 
                $navPanel= $formObjLito->m_NavPanel->Render(); 
                
                $resultLito[$key]['subform']['dataPanel']=$dataPanel;
                $resultLito[$key]['subform']['actionPanel']=$actionPanel;
                $resultLito[$key]['subform']['navPanel']=$navPanel;
                $resultLito[$key]['subform']['name']="epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_comp_pdc_list";
                $resultLito[$key]['subform']['newobj']="\n<script> NewObject('" . $formObjLito->m_Name. "','" . $formObjLito->m_jsClass . "'); </script>\n";;
                $resultLito[$key]['newobj']="\n<script> NewObject('" . $formObjLito->m_Name. "','" . $formObjLito->m_jsClass . "'); </script>\n";;
                $resultLito[$key]['tipo']=3;
                
                
                unset($formObjLito);
            } 
            foreach($resultLito as $values)
            $result[]=$values;
       }
       return $this->ordenar($result);
    }
    
    
    public function ordenar($result,$campo='no_order')
    {
        if(!is_array($result)) return null;
        $cant=count($result);
        if($cant==0) return $result;   
        if($cant==1)
        {
            $result[0]['lugar']=1;
            $result[0]['ultimo']=1;
            return $result;   
        }
        $cont=1;
        for($i=0;$i<$cant-1;$i++)
        {
            for($j=$i;$j<$cant;$j++)
            {
                $temp=array();
                if($result[$i][$campo]>$result[$j][$campo])
                {
                    $temp=$result[$i];
                    $result[$i]=$result[$j];
                    $result[$j]=$temp;
                }
            }
            $result[$i]['lugar']=$cont++; 
            $result[$i]['ultimo']=0; 
        }
        $result[$cant-1]['lugar']=$cont;
        $result[$cant-1]['ultimo']=1;
        return $result;
    }
}

?>