 <?php 

 include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd.msg');
class d_ga_pd_solicitud_edit_pd extends BizDataObj
{
    
    private $dataObjName=null;

 public function UpdateRecord($recArr, $oldRec=null)
 {   
       //  logErr($recArr,recArr,false);
        $result = parent::UpdateRecord($recArr, $oldRec);
        //actualizo los barnices
        if($result)
            $result=$this->UpdateBarnizInteriorPD($recArr, $oldRec);
        
        return $result;
    }
 

    function searchBarnizInterior($params=array())
    {
        global $g_BizSystem;
        //busco si existe barniz Interior
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."]='".$value."'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;
        
    }
    
    function InsertBarnizInteriorPD($params=array(),$data=array())
    {     //$Pd_Shell_id,$color,$utilizacion
        global $g_BizSystem; 
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        $pd_barniz = $params;   
        $result=$dataObj->InsertRecord($pd_barniz);
         
        $pd_barniz_id = $dataObj->m_BizRecord->get('Id')->GetValue();

        if($result && $pd_barniz_id){
                
                //return $pd_barniz_id;  $dataRec,$dataShell,$hoja_m2,$pd_barniz_id
                $cantidad_aditivo_hoja=$data['hoja_m2']*$data['cantidad_maxima'];   //logErr($cantidad_aditivo_hoja,cantidad_aditivo_hoja,false);
               
                if($data['num_tapas']>0)
                    $cantidad_aditivo=($cantidad_aditivo_hoja*1000)/$data['num_tapas'];  
                else
                    $cantidad_aditivo=0;
                                      
                //adiciono el barniz Interior
                $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
                $pd_barniz_com = array("pd_barniz_id"=>$pd_barniz_id, 
                                        "barniz_id"=>$data['barniz_interior_id'], 
                                            "cantidad_aditivo"=>$cantidad_aditivo,
                                                "cantidad_aditivo_m2"=>$data['cantidad_maxima'],
                                                    "porciento"=>100); 
                $result=$dataObj->InsertRecord($pd_barniz_com);
                
                if($result)
                    return true;
                return false;
        }
        else {
            logErr("Pd_Shell_id".$Pd_Shell_id." color".$color. " utiliazcion:".$utilizacion, "No se registro el barniz_PD correctamente", false); 
            return false; 
        }
       
    }
    
    function UpdateBarnizInteriorPD($recArr, $oldRec=null)
    {
        if($recArr['liquido_contiene']==$oldRec['liquido_contiene'] )
        {
            return true;
        } 

        global $g_BizSystem;
                  
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[shell_id]='".$recArr['shell_id']."'");
        $dataObj->setSearchRule("[pd_id]='".$recArr['pd_id']."'");
        $dataPD_SHELL=$dataObj->fetch(); //logErr($dataPD_SHELL,dataPD_SHELL,false); 

        if(!isset($dataPD_SHELL[0]['Id']))
            return false;
            
        $Pd_Shell_id = $dataPD_SHELL[0]['Id'];
        
        //busco la shell
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("erp.shell.dataobj.d_ga_shell");
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[Id]='".$recArr['shell_id']."'");
        $dataShell=$dataObj->fetch(); //logErr($dataShell,dataShell,false); 
        
        if(!isset($dataShell[0]))
            return false;
            
        $hoja_m2=$dataShell[0]['m2'];  
         if(strpos($hoja_m2,",")!==false)
            $hoja_m2=str_replace(",",".",$hoja_m2);

        
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz");
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[pd_shell_id]='".$Pd_Shell_id."'");
        $dataObj->setSearchRule("[utilizacion]='5'");
        $dataPdBarniz=$dataObj->fetch(); // logErr($dataPdBarniz,dataPdBarniz,false); 
        
        foreach($dataPdBarniz as $key=>$value)
        {
        $result=$dataObj->DeleteRecord($value);
        
        if(!$result)
            return false;
        }//logErr();
          
        $params=array('shell_id'=>$recArr['shell_id'],'inserto_id'=>$recArr['inserto'],'liquido_id'=>$recArr['liquido_contiene'] );
        $this->dataObjName="erp.barniz_interior.dataobj.d_ga_erp_barniz_interior";
        $dataRec=$this->searchBarnizInterior($params); //  logErr($dataRec,dataRec,false); 
        unset($params);
         
        if(!isset($dataRec[0])) return false;   
        
        $params=array('pd_shell_id'=>$Pd_Shell_id,'color'=>$dataRec[0]['color'],'utilizacion'=>5 );
        $dataParam=array('cantidad_maxima'=>$dataRec[0]['cantidad_maxima'],'hoja_m2'=>$hoja_m2,
                        'num_tapas'=>$dataShell[0]['num_tapas'],'barniz_interior_id'=>$dataRec[0]['barniz_interior_id']);  
        $this->dataObjName="epd.pd_barniz.dataobj.d_ga_pd_barniz";
        $result=$this->InsertBarnizInteriorPD($params,$dataParam); // logErr($result,result,false);
        
        if($result)
            return true;
        return false;
    }
    
    
    function calcularM2($hoja,$unidad=1000)
    {
        $metro2=1;
        if(strpos($hoja,"*")===false)
        {
         BizSystem::log(LOG_ERR, "Hoja Shell 0",$hoja);   
            return false;
        }
       $dimensiones=explode("*",$hoja);
       if(count($dimensiones)!=3)
        return 0;
       
       foreach($dimensiones as $key=>$valor)
       {  
            
           if(strpos($valor,",")!==false)
            $valor=str_replace(",",".",$valor); 
           
           if(is_numeric($valor) && $valor>1)
             $metro2*=$valor/$unidad;
         //  logErr($metro2,metro,false);  
       }
       
       if($metro2!=1)
        return $metro2;
       else
        return 0;
       
    }

}