 <?php 

 include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd.msg');
 include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd_solicitud.msg');
 
class d_ga_pd_solicitud_p extends BizDataObj
{
        private $dataObjName=null;

        public function UpdateRecord($recArr, $oldRec=null)
        {  
        global $g_BizSystem;    
             //logErr($recArr);
        if($recArr['Id']!=$oldRec['Id'])
        {
            $errorGuardarSolMessage = $this->GetMessage("MSG_GA_PD_ERROR_GUARDAR_DATO"); 
            $g_BizSystem->GetClientProxy()->ShowErrorMessage($errorGuardarSolMessage);
             logErr("Error al intentar modificar la solicitud, por tener dos ID: ID Nuevo".$recArr['Id']." ID viejo:".$oldRec['Id'],ga_pd_solicitud,true);
             return true;
        }
        $array_diff = array_diff_assoc ($recArr, $oldRec); 

        foreach($array_diff as $key=>$value)
        {    
            //logErr($recArr[$key],recArr,false); 
            //logErr($oldRec[$key],oldRec,false); 
 
            
            if(trim($recArr[$key])!=trim($oldRec[$key]))
            {    
                $array_diff[$key]=$value;
            }
            else
            {
                $oldRec[$key]=trim($oldRec[$key]);
            }
              //logErr($oldRec[$key],oldRec,false);  
        }   
        $array_diff = array_diff_assoc ($recArr, $oldRec);   
 
        $result = parent::UpdateRecord($recArr, $oldRec);
       // $result=true;
        $dif=false;
        if(is_array($oldRec))
        foreach($oldRec as $key=>$val)
        {
            if($val!=$recArr[$key])
            {    
                $dif=true; break;
            }    
        }     
        if($result && $recArr!=$oldRec)
        {
              $estado=array(1=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_1'),2=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_2'),
                            3=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_3'),4=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_4'),
                            6=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_6')
                                ,0=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_0'),7=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_7'), 
                                    8=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_8'),10=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_10'),
                                        11=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_11'));   
           // $this->NotificarCambio(array(E_NUM_SOLICITUD=>$recArr['Id'],E_NUM_PD=>$recArr['num_pd'],E_ESTADO_ACTUAL=>$estado[$recArr['estado']]),$array_diff);
            $datos1=array(E_NUM_SOLICITUD=>$recArr['Id'],E_NUM_PD=>$recArr['num_pd'],E_ESTADO_ACTUAL=>$estado[$recArr['estado']]);
            register_shutdown_function(array(d_ga_pd_solicitud_p,NotificarCambio),$datos1,$array_diff,$this);
        }
        
        $this->ActualizarPDItalia($recArr['num_pd'],$recArr['solicitud_pdf'],false);


        $objeto="epd.pd_solicitud.dataobj.d_ga_pd";
        //logErr($objeto);
        $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject($objeto);

        $dataObjPD->setSearchRule("[num_pd]='".$recArr['num_pd']."'");
        $dataRec=$dataObjPD->fetch();  
        $recArr['pd_id']=$dataRec[0]['Id'];

        //actualizar estado en la PD
        if($result && $recArr['estado']!=$oldRec['estado'])
        {             //logErr(pd);
            if(!isset ($dataRec[0]))
            {
               logErr("No se encontro el PD".$oldRec['num_pd']." de la solicitud ".$recArr['Id'], "PD", false);
               return $result;
            }
            $oldRecPd=$dataRec[0];
            $dataRec[0]['estado']=$recArr['estado'];
            $resultPd=$dataObjPD->UpdateRecord($dataRec[0],$oldRecPd);

            if(!$resultPd)
            {
               logErr("No se cambio el estado del PD".$oldRec['num_pd'], "Estado de PD", false);
               return $result;
            }
            
         
        }elseif($result && $recArr['solicitud_pdf']!=$oldRec['solicitud_pdf'] && $dataRec['pdf_italia']!=3)
        {             //logErr(pd);
            if(!isset ($dataRec[0]))
            {
               logErr("No se encontro el PD".$oldRec['num_pd']." de la solicitud ".$recArr['Id'], "PD", false);
               return $result;
            }
            $oldRecPd=$dataRec[0];
            $dataRec[0]['pdf_italia']=$recArr['solicitud_pdf'];
            $resultPd=$dataObjPD->UpdateRecord($dataRec[0],$oldRecPd);

            if(!$resultPd)
            {
               logErr("No se cambio el estado del PD".$oldRec['num_pd'], "Estado de PD", false);
               return $result;
            }
            
         
        }

        //actualizar la shell en la PD: SIEMPRE
        if(!isset($dataRec[0]))
        {
           logErr("No se encontro el PD".$oldRec['num_pd']." de la solicitud ".$recArr['Id'], "PD", false);
            return $result;
        }

        $result=$this->UpdatPD_Shell($recArr);

        //actualizo los barnices
        //TODO: Revisar esto, en principio despues que se crea la solicitud no se deberian tocar esos datos
        $result=$this->UpdateBarnizInteriorPD($recArr, $oldRec);

        return $result;
        }

        public function UpdatPD_Shell($recArr)
        {
            global $g_BizSystem;

            $objeto="epd.pd.dataobj.d_ga_pd_shell";

            $dataObjPD_Shell = $g_BizSystem->GetObjectFactory()->GetObject($objeto);

            $dataObjPD_Shell->setSearchRule("[pd_id]='".$recArr['pd_id']."'");
           
            $dataRecShell=$dataObjPD_Shell->fetch();

            if(!isset ($dataRecShell[0]))
            {
		        //logErr("No se encontro el objeto PD_SHELL con pd_id: ".$recArr['pd_id']." de la solicitud ".$recArr['Id'], "PD", false);
		        $result=$this->InsertarPD_SHELL($recArr['shell_id'],$recArr['pd_id']);
                return $result;
            }

            $oldRec=$dataRecShell[0];
            $dataRecShell[0]['shell_id']=$recArr['shell_id'];

            if(!$resultPd_shell)
            {
               logErr("No se cambio la Shell del PD: ".$oldRec['num_pd'], "Shell de la PD", false);
            $resultPd_shell=$dataObjPD_Shell->UpdateRecord($dataRecShell[0],$oldRec);
               return $result;
            }
        }

        public function filtrarNumPD($num_pd)
        {
        global $g_BizSystem;
        $conn = $this->GetDBConnection();
        $profile = $g_BizSystem->GetUserProfile();  //logErr($profile);
        $clave='';
        $clave = array_search('admin', $profile['roles']);
        $planta_id = $profile['planta_activa'];
        
        if($clave===false){
            $genIdService = $g_BizSystem->GetService(GENID_SERVICE);      
            $tableName = "ga_pd";
            $num_pd = $genIdService->GetNewID('Openbiz', $conn, NULL, $tableName);//,NULL,$planta_id);
        }else{
            if($num_pd)
            {
                $sql = "SELECT     IDBODY
                        FROM         dbo.ob_sysids
                        WHERE     (TABLENAME ='ga_pd')";// AND planta_id='$planta_id'";
                $rs = $this->exec_select($conn,$sql);
                $row = $rs->fetch();
                $fld='num_pd';
                if(!is_numeric($num_pd))
                {
                $this->m_ErrorMessage = $this->GetMessage("MSG_GA_PD_DATA_FIELD_INCORRECT_TYPE",array($num_pd,'Number'));
                $this->m_ErrorFields[$fld] = $this->m_ErrorMessage;
                }elseif($num_pd>$row[0] || $this->buscarNumPd($num_pd))
                {
                $this->m_ErrorMessage = $this->GetMessage("MSG_GA_PD_DATA_NOT_UNIQUE",array($num_pd));
                $this->m_ErrorFields[$fld] = $this->m_ErrorMessage;
                $num_pd='';
                }

            }else{
                $genIdService = $g_BizSystem->GetService(GENID_SERVICE);
                $tableName = "ga_pd";
                $num_pd = $genIdService->GetNewID('Openbiz', $conn, NULL, $tableName);//,null,$planta_id);           
            }

        }

        if (count($this->m_ErrorFields)>0)
        {
        throw new ValidationException($this->m_ErrorFields);
        return false;
        }

        return $num_pd;
        } 

        public function buscarNumPd($num_pd)
        {
            global $g_BizSystem;
            $objeto="epd.pd_solicitud.dataobj.d_ga_pd";
            $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject($objeto);
            $dataObjPD->ResetRules();
            $dataObjPD->setSearchRule("[num_pd]='".$num_pd."'");
            $dataRec=$dataObjPD->fetch();  
            if(count($dataRec)>0 && isset($dataRec[0]['Id']))
                return $dataRec[0]['Id'];
            return false;
            

        }         
        
        public function updatePlantaPD($pd_id,$planta_id)
        {
            global $g_BizSystem;
            $objeto="epd.pd_solicitud.dataobj.d_ga_pd";
            $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject($objeto);
            $dataObjPD->ResetRules();
            $dataObjPD->setSearchRule("[Id]='".$pd_id."'");
            $dataRec=$dataObjPD->fetch();  
            
            if(!isset($dataRec[0]['Id'])) return false;
              
            $dataRec=$dataRec[0];
            $oldRec=$dataRec;
            $dataRec['planta_id']=$planta_id;
            $ok=$dataObjPD->UpdateRecord($dataRec,$oldRec);
            
            if($ok)
                return true;
            return false;
            
            

        }

        public function InsertRecord($recArr)
        { 
        global $g_BizSystem;                     
        $recArr['estado']=1;   

        $recArr['num_pd']=$this->filtrarNumPD($recArr['num_pd']);
       // logErr($recArr['num_pd']);                        
        parent::InsertRecord($recArr);
           
        $solicitud_pd_id = $this->m_BizRecord->get('Id')->GetValue();
          
        if(!$solicitud_pd_id){
          logErr($recArr, "Error al obtener ID la Solicitud", false);
          $this->m_ErrorMessage = $this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_REQUIRED",array());
          BizSystem::ClientProxy()->ShowErrorMessage($this->m_ErrorMessage);
          throw new ValidationException($this->m_ErrorFields);
          return ;

        }
        $pd_id=$this->buscarNumPd($recArr['num_pd']);  
        //logErr($pd_id,pd_id,false);
        
        if(!$pd_id)
        {
            $this->m_ErrorMessage = $this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_REQUIRED",array());
            BizSystem::ClientProxy()->ShowErrorMessage($this->m_ErrorMessage);
            throw new ValidationException($this->m_ErrorFields);
            return ;
        }
        else
        {
            $profile=$g_BizSystem->getUserProfile();
            $planta_id = $profile['planta_activa'];
            if($planta_id>0)
            {
            $this->updatePlantaPD($pd_id,$planta_id);
            }
        }
        //logErr($recArr['shell_id'],shell_id,false);  
        if($recArr['shell_id'] && $pd_id)
        {  
            $this->InsertarPD_SHELL($recArr['shell_id'],$pd_id,$recArr['inserto'],$recArr['liquido_contiene']);

        }else{

          logErr("Solicitud_id".$solicitud_pd_id." num_pd".$recArr['num_pd']." Shell_id:".$recArr['shell_id'], "Error al obtener la SHell_id de la solicitud ", false);

        }
        
        $this->ActualizarPDItalia($recArr['num_pd'],$recArr['solicitud_pdf']); 
                                
        if($solicitud_pd_id && $pd_id){
        //envio de email segun el cambio de estado.

        // $emailObj->generarEmailCambioEstadoPD($this->m_MainTable,'estado',0,1,$solicitud_pd_id,array($solicitud_pd_id),$gestores_PD );

        $estado=array(1=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_1'),2=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_2'),
                    3=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_3'),4=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_4'),
                    6=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_6')
                        ,0=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_0'),7=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_7'), 
                            8=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_8'),10=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_10'),
                                11=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_11'));   
        $filtros=array('entidad'=>'ga_pd','campo'=>'estado','viejo_valor'=>0,'nuevo_valor'=>1);
        $valores=array(E_NUM_PD=>$recArr['num_pd'],E_ESTADO_ACTUAL=>$estado[0],E_ESTADO_NUEVO=>$estado[1]);
             
        //envio de email segun el cambio de estado.
    //    global $g_BizSystem;
    //    $dataObjEnvioEmail = $g_BizSystem->GetObjectFactory()->GetObject("erp.parametrizacion_interna.dataobj.d_ga_erp_plantilla_parametrizacion_envio_email");
    //    $params=$dataObjEnvioEmail->buscarParametrizacionEnvioEmail('CAMBIO_ESTADO_PD',null,true,$filtros,$solicitud_pd_id,$valores);

        //logErr($params,"salida #1 de parametros de creacion PD sin HEX",false); 
    //    if($this->cargarFormaEnvio()!="SMTP")  
    //   {               
    //    $params['subject']=$dataObjEnvioEmail->aplicarBinarioHex($params['subject']); 
    //    $params['body']=$dataObjEnvioEmail->aplicarBinarioHex($params['body']);
        //logErr($params,"salida #2 de parametros de creacion PD CON HEX",false);   
    //   }
      // logErr($params,"parametros de envio de email(PD)",false);
   //     $dataObjEnvioEmail->enviarEmailSql($params);
        register_shutdown_function(array(d_ga_pd_solicitud_p,envioEmail),$filtros,$solicitud_pd_id,$valores,$this);
        $profile = $g_BizSystem->GetUserProfile();
        $gestores_PD=$this->buscarGestorPD();          
        $datos=array('titulo'=>'Creacion de nueva solicitud ('.$solicitud_pd_id.') de la NUM_PD:'.$recArr['num_pd'],
        'fecha_inicio'=>date('d-m-Y'),
            'prioridad'=>2,
                'estado'=>1,
                    'modulo_id'=>2,
                        'descripcion'=>"Se creo la solicitud ".$solicitud_pd_id,
                            'tipo_task'=>3,
                                'notificacion_email'=>1,
                                    'fecha_fin'=>$recArr['fecha_solicitud_entrega'],
                                    'asignada_usuario_id'=>$gestor,
                                        'asignada_rol_id'=>0,
                                        'registro_id'=>$solicitud_pd_id,
                                            'link'=>"controller.php?view=epd.pd.view.ga_pd_detail&fld:Id=".$pd_id,
                                                'entidad'=>$this->m_MainTable,
                                                    'creada_por_id'=>$profile['Id']);   
                                                   // logErr($gestores_PD,gestores_PD,false); 
            if(is_array($gestores_PD))
            {                                        
                foreach($gestores_PD as $key=>$gestor)
                {
                    $teaskService = $g_BizSystem->GetService(TASKS_SERVICE); 
                    if(isset($gestor['Id']))
                    {
                        $datos['asignada_usuario_id']=$gestor['user_id']; 
                        $teaskService->insertTask($datos);
                    }
                }
            }
        }   

        return $recArr['num_pd'];
        }
        
        public function envioEmail($filtros,$solicitud_pd_id,$valores,$form)
        {
            //envio de email segun el cambio de estado.
            global $g_BizSystem;
            $dataObjEnvioEmail = $g_BizSystem->GetObjectFactory()->GetObject("erp.parametrizacion_interna.dataobj.d_ga_erp_plantilla_parametrizacion_envio_email");
            $params=$dataObjEnvioEmail->buscarParametrizacionEnvioEmail('CAMBIO_ESTADO_PD',null,true,$filtros,$solicitud_pd_id,$valores);
                 
            //logErr($params,"salida #1 de parametros de creacion PD sin HEX",false); 
            if($form->cargarFormaEnvio()!="SMTP")  
            {   
                //logErr($params,"salida #2 de parametros de creacion PD CON HEX1",false);             
            $params['subject']=$dataObjEnvioEmail->aplicarBinarioHex($params['subject']); 
            $params['body']=$dataObjEnvioEmail->aplicarBinarioHex($params['body']);
           // logErr($params,"salida #2 de parametros de creacion PD CON HEX",false);   
            }
            // logErr($params,"parametros de envio de email(PD)",false);
            $dataObjEnvioEmail->enviarEmailSql($params);
        }

        public function buscarGestorPD()
        {
            global $g_BizSystem;
            //busco si existe barniz Acabado
            $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("system.user.dataobj.d_user_role_gestor_pd");
            if (!$dataObj) return false;
            $dataObj->ResetRules();

            $dataObj->setSearchRule("[role_name] like '%gestor%'");
            $dataObj->setSearchRule("[role_name] like '%PDs%'");

            $dataRec=$dataObj->fetch();

            if(count($dataRec)>0)
                return $dataRec;
            return false;
        }

        public function IsertarPD($num_pd,$estado)
        {      //implementar aqui estas funciones....
        global $g_BizSystem;
        $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd");
        $pdArr = array("num_pd"=>$num_pd,"estado"=>$estado,"aprobada"=>'0',"anulada"=>'0',"generica"=>'0' ); 
        $var=$dataObjPD->InsertRecord($pdArr); 

        if(!$var){
          logErr("num_pd".$num_pd." estado:".$estado, "Error al registrar la PD", false);
          $taskObj = $g_BizSystem->GetService(TASKS_SERVICE);
          //$datos=array('[titulo]');
          $taskObj->insertTask();

        }
        $pd_id=$dataObjPD->m_BizRecord->get('Id')->GetValue();
        return $pd_id;
        }
        
        public function ActualizarPDItalia($num_pd,$pdf=0,$inicio=true)
        {      //implementar aqui estas funciones....
           if($inicio && !$pdf)  return;
           
           $system_configuration= $_SESSION['system_configuration'];
           $system_define=array();
           $work=null;
           if(is_array($system_configuration))
           {     
               foreach($system_configuration as $key=>$val)
               {
                   if($val['clave']=="PD_WORKFLOW")
                   {
                       $work=$val['valor'];     break ;
                   }
               }
           }
       
            //   if($work!='_it') return;
       
                    global $g_BizSystem; 
                    $objeto="epd.pd_solicitud.dataobj.d_ga_pd";
                    $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject($objeto);
                    $dataObjPD->ResetRules();
                    $dataObjPD->setSearchRule("[num_pd]='".$num_pd."'");
                    $dataRec=$dataObjPD->fetch();  
                    $dataRec=$oldRec=$dataRec[0];
                    if($pdf)
                    $dataRec['pdf_italia']=1;
                    else
                    $dataRec['pdf_italia']=0; 
                      
 
                    $var=$dataObjPD->UpdateRecord($dataRec,$oldRec); 
      
                    if(!$var){
                      logErr("Error al actualizar el campo pdf_italia la PD: ".$dataRec['num_pd'], false);
  
                    }

          

        }

        public function DeletePD($pd_id,$num_pd,$estado)
        {      //implementar aqui estas funciones....
        global $g_BizSystem;
        $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd");
        $pdArr = array("num_pd"=>$num_pd,"estado"=>$estado,"aprobada"=>'0',"anulada"=>'0',"generica"=>'0' ); 
        $var=$dataObjPD->DeleteRecord($pdArr); 

        if(!$var){
          logErr("num_pd".$num_pd." estado:".$estado, "Error al registrar la PD", false);
          //$taskObj = $g_BizSystem->GetService(TASKS_SERVICE);
          //$datos=array('[titulo]');
          //$taskObj->insertTask();

        }
        //$pd_id=$dataObjPD->m_BizRecord->get('Id')->GetValue();
        return $var;
        }

        public function IsertarPDSolicitud($solicitud_pd_id,$pd_id)
        {
        global $g_BizSystem;
        $dataObjPDSolicitud = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_solicitud.dataobj.d_ga_pd_ga_pd_solicitud");
        $pdSolicitudArr = array("solicitud_pd_id"=>$solicitud_pd_id, "pd_id"=>$pd_id,"tipo"=>'0');
        $var=$dataObjPDSolicitud->InsertRecord($pdSolicitudArr);
        if(!$var)
        {
	        logErr("Solicitud_id".$solicitud_pd_id." pd_id".$pd_id, "Error al registrar la PD y la Solicitud en d_ga_pd_ga_pd_solicitud", false);
        }
        return $var;

        }

        public function InsertarPD_SHELL($shell_id,$pd_id,$inserto=null,$liquido=null)
        {      
           // logErr(InsertarPD_SHELL,entro,false);
        global $g_BizSystem;
        $hoja_m2=0;
        $dataObjPD_SHELL = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
        $pdShelldArr = array("shell_id"=>$shell_id, "pd_id"=>$pd_id, "maquina_id"=>6);
        $result=$dataObjPD_SHELL->InsertRecord($pdShelldArr);

        $Pd_Shell_id = $dataObjPD_SHELL->m_BizRecord->get('Id')->GetValue();  
       // logErr($Pd_Shell_id,pd_shell_id,false);
        //busco la shell
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("erp.shell.dataobj.d_ga_shell");
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[Id]='".$shell_id."'");
        $dataShell=$dataObj->fetch();

        if(count($dataShell)>0){
         //   $hoja_m2=$this->calcularM2($dataShell[0]['hoja']);
         $hoja_m2=$dataShell[0]['m2'];
        }
        $cont=1;
        if($shell_id &&  !is_null($inserto) && $result )
        {
            //busco si existe barniz Interior
            $params=array('shell_id'=>$shell_id,'inserto_id'=>$inserto,'liquido_id'=>$liquido );
            //$params=array('shell_id'=>$shell_id,'inserto_id'=>$inserto);
            $this->dataObjName="erp.barniz_interior.dataobj.d_ga_erp_barniz_interior";
            $dataRec=$this->searchBarnizInterior($params); 
            unset($params);
             //logErr($dataRec,dataRec,false); 
            if($dataRec)
            {     
                //registro el barniz interior  array("pd_shell_id"=>$Pd_Shell_id, "color"=>$color, "utilizacion"=>$utilizacion); 
                $params=array('pd_shell_id'=>$Pd_Shell_id,'color'=>$dataRec[0]['color'],'utilizacion'=>5,'no_order'=>$cont );
                $dataParam=array('cantidad_maxima'=>$dataRec[0]['cantidad_maxima'],'hoja_m2'=>$hoja_m2,
                                'num_tapas'=>$dataShell[0]['num_tapas'],'barniz_interior_id'=>$dataRec[0]['barniz_interior_id'],
                                    'cantidad_maxima'=>$dataRec[0]['cantidad_maxima']);  
                $this->dataObjName="epd.pd_barniz.dataobj.d_ga_pd_barniz";
                $result=$this->InsertBarnizInteriorPD($params,$dataParam);

                if(!$result)
                {
                   logErr("shell_id: ".$shell_id." inserto_id: ".$inserto. "pd_barniz_id:".$pd_barniz_id, "No se registro el COMp correctamente", false); 
                }else
                {
                    $cont++;
                }
            
            }else
            {
                  
         
                $texto=$this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_BARNIZ_INTERNO_NO_FOUND",array($shell_id,$inserto,$liquido));
                $g_BizSystem->ClientProxy()->ShowClientAlert($texto); 
                logErr($texto,BarnizInterior,false);
               // return false;
          
            }  
          
             //busco si existe barniz Acabado
            $this->dataObjName="erp.barniz_acabado.dataobj.d_ga_erp_barniz_acabado";   // logErr($this->dataObjName,dataObjName,false);
            $params=array('shell_id'=>$shell_id,'wetwet'=>0);
            $dataRec=$this->searchBarnizAcabado($params); //logErr($dataRec,barniz_acabado,false);  
            unset($params);
                 //  logErr($dataRec,dataRecAcabado,false);  
            if($dataRec)
            {
                
                $params=array('pd_shell_id'=>$Pd_Shell_id,'color'=>$dataRec[0]['color'],'utilizacion'=>3,'no_order'=>$cont );
                $dataParam=array('cantidad_maxima'=>$dataRec[0]['cantidad_maxima'],'hoja_m2'=>$hoja_m2,
                                'num_tapas'=>$dataShell[0]['num_tapas'],'barniz_acabado_id'=>$dataRec[0]['barniz_acabado_id']);  
                $this->dataObjName="epd.pd_barniz.dataobj.d_ga_pd_barniz"; 
               // logErr($params,paramerBarnizAcabado,false);
               // logErr($dataParam,dataparamBarnizAcabado,false);
                $result=$this->InsertbarnizAcabado($params,$dataParam);
               // $result=$this->InsertbarnizEnganche($params,$dataParam);

                    if(!$result)
                    {
                       logErr("shell_id".$shell_id. "pd_barniz_id:".$pd_barniz_id, "No se registro el Comp correctamente de barniz Acabado", false); 
                    }
                
                
            }else
            {
               logErr("shell_id".$shell_id, "No exsite barniz de Acabado", false);    
            }
          
                 

        }


        return $result;

        }

        function exec_select($conn,$sql)
        {
            BizSystem::log(LOG_DEBUG, "Exec Select", "SQL = ".$sql);
        try {
            $rs = $conn->query($sql);
        }
        catch (Exception $e) {
            throw new Exception("Error in query: " . $sql . ". " . $e->getMessage());
        return false;
        }
        return $rs;
        }

        function searchBarnizAcabado($params=array())
        {
        global $g_BizSystem;
        //busco si existe barniz Acabado
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] = '".$value."'");

        $dataRec=$dataObj->fetch();

        if(count($dataRec)>0)
            return $dataRec;
        return false;

        }

        function InsertbarnizAcabado($params=array(),$data=array())
        {     
        //$Pd_Shell_id,$color,$utilizacion
        global $g_BizSystem;                   //  logErr($this->dataObjName,databarnizacaba,false);
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        $pd_barniz = $params;   
        $result=$dataObj->InsertRecord($pd_barniz);
         
        $pd_barniz_id = $dataObj->m_BizRecord->get('Id')->GetValue();  //logErr($pd_barniz_id,pd_barniz_id,false);

        if($result && $pd_barniz_id){
                
                $cantidad_aditivo_hoja=$data['hoja_m2']*$data['cantidad_maxima'];     
                if($data['num_tapas']>0)
                    $cantidad_aditivo=($cantidad_aditivo_hoja*1000)/$data['num_tapas'];  
                else
                    $cantidad_aditivo=0;

                //adiciono el barniz Interior
                $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
                $pd_barniz_com = array("pd_barniz_id"=>$pd_barniz_id, 
                                        "barniz_id"=>$data['barniz_acabado_id'], 
                                            "cantidad_aditivo"=>$cantidad_aditivo,
                                                "cantidad_aditivo_m2"=>$data['cantidad_maxima'],
                                                    "porciento"=>100);
                                           // logErr($pd_barniz_com,pd_barniz_com,false);
                $result=$dataObj->InsertRecord($pd_barniz_com);  // logErr($result,result,false);
                
                if($result)
                    return true;
                return false;
        }
        else {
            logErr("Pd_Shell_id".$Pd_Shell_id, "No se registro el barniz_PD correctamente", false); 
            return false; 
        }

        }

        function searchBarnizEnganche($params=array())
        {
        global $g_BizSystem;
        //busco si existe barniz Engance
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] LIKE '".$value."'");

        $dataRec=$dataObj->fetch();

        if(count($dataRec)>0)
            return $dataRec;
        return false;

        }

        function InsertbarnizEnganche($params=array(),$data=array())
        {     
        //$Pd_Shell_id,$color,$utilizacion
        global $g_BizSystem; 
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        $pd_barniz = $params;   
        $result=$dataObj->InsertRecord($pd_barniz);
         
        $pd_barniz_id = $dataObj->m_BizRecord->get('Id')->GetValue();  //logErr($pd_barniz_id,pd_barniz_id,false);

        if($result && $pd_barniz_id){
                
                $cantidad_aditivo_hoja=$data['hoja_m2']*$data['cantidad_maxima']; //logErr($data['num_tapas'],num_tapas,false);    
                if($data['num_tapas']>0)
                    $cantidad_aditivo=($cantidad_aditivo_hoja*1000)/$data['num_tapas'];  
                else
                    $cantidad_aditivo=0;

                //adiciono el barniz Interior
                $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
                $pd_barniz_com = array("pd_barniz_id"=>$pd_barniz_id, 
                                        "barniz_id"=>$data['barniz_enganche_id'], 
                                            "cantidad_aditivo"=>$cantidad_aditivo,
                                                "cantidad_aditivo_m2"=>$data['cantidad_maxima'],
                                                    "porciento"=>100);     //logErr($pd_barniz_com,pd_barniz_com,false);      
                $result=$dataObj->InsertRecord($pd_barniz_com);   //logErr($result,_Acabado,false);
                
                if($result)
                    return true;
                return false;
        }
        else {
            logErr("Pd_Shell_id".$Pd_Shell_id." color".$color. " utiliazcion:".$utilizacion, "No se registro el barniz_PD correctamente", false); 
            return false; 
        }

        }

        function searchBarnizInterior($params=array())
        {
        global $g_BizSystem;
        //busco si existe barniz Interior
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $search="";    $cant=count($params)-1;  $i=0;
        foreach($params as $k=>$value)
        {
            $search.="[".$k."]='".$value."'";  
            if($cant>$i)
                $search.="  AND "; 
            $i++;
        }      
        $dataRec=$dataObj->DirectFetch($search);

        //$dataRec=$dataObj->fetch();

        if(count($dataRec)>0)
            return $dataRec;
        return false;

        }

        function InsertBarnizInteriorPD($params=array(),$data=array())
        {      
        global $g_BizSystem; 
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        $pd_barniz = $params;   
        $result=$dataObj->InsertRecord($pd_barniz);
         
        $pd_barniz_id = $dataObj->m_BizRecord->get('Id')->GetValue();

        if($result && $pd_barniz_id){
                
                //return $pd_barniz_id;  $dataRec,$dataShell,$hoja_m2,$pd_barniz_id
                $cantidad_aditivo_hoja=$data['hoja_m2']*$data['cantidad_maxima'];     //logErr($cantidad_aditivo_hoja,cantidad_aditivo_hoja,false);
                if($data['num_tapas']>0)
                    $cantidad_aditivo=($cantidad_aditivo_hoja*1000)/$data['num_tapas'];  
                else
                    $cantidad_aditivo=0;

                                      //logErr($cantidad_aditivo_hoja,cantidad_aditivo_hoja,false);
                                     // logErr($cantidad_aditivo,cantidad_aditivo,false);
                                      
                //adiciono el barniz Interior
                $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
                $pd_barniz_com = array("pd_barniz_id"=>$pd_barniz_id, 
                                        "barniz_id"=>$data['barniz_interior_id'], 
                                            "cantidad_aditivo"=>$cantidad_aditivo,
                                                "cantidad_aditivo_m2"=>$data['cantidad_maxima'],
                                                    "porciento"=>100);
                $result=$dataObj->InsertRecord($pd_barniz_com);
                
                if($result)
                    return true;
                return false;
        }
        else {
            logErr("Pd_Shell_id".$Pd_Shell_id." color".$color. " utiliazcion:".$utilizacion, "No se registro el barniz_PD correctamente", false); 
            return false; 
        }

        }

        function UpdateBarnizInteriorPD($recArr, $oldRec=null)
        {
       /* if($recArr['liquido_contiene']==$oldRec['liquido_contiene'] && $recArr['shell_id']==$oldRec['shell_id'] && $recArr['inserto']==$oldRec['inserto'] )
        {
            return true;
        } */   //logErr($recArr);

        global $g_BizSystem;
       
        if(!$recArr['pd_id'])
        {
        //busco PD
            $dataObj= $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd");
            if (!$dataObj) return false;
            $dataObj->ResetRules();
            $dataObj->setSearchRule("[num_pd]='".$recArr['num_pd']."'");
            $dataPD=$dataObj->fetch();// logErr($dataPD,Pd,false);
        }
        else
        {
           $dataPD[0]['Id']=$recArr['pd_id'];   
        }
        if(!isset($dataPD[0]['Id']))
            return false;
            
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[shell_id]='".$recArr['shell_id']."'");
        $dataObj->setSearchRule("[pd_id]='".$dataPD[0]['Id']."'");
        $dataPD_SHELL=$dataObj->fetch(); //logErr($dataPD_SHELL,dataPD_SHELL,false); 

        if(!isset($dataPD_SHELL[0]['Id']))
            return false;
            
        $Pd_Shell_id = $dataPD_SHELL[0]['Id'];

        //busco la shell
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("erp.shell.dataobj.d_ga_shell");
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[Id]='".$recArr['shell_id']."'");
        $dataShell=$dataObj->fetch(); //logErr($dataShell,dataShell,false); 

        if(!isset($dataShell[0]))
            return false;
            
        $hoja_m2=$dataShell[0]['m2'];
        if(strpos($hoja_m2,",")!==false)
            $hoja_m2=str_replace(",",".",$hoja_m2);

        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz");
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[pd_shell_id]='".$Pd_Shell_id."'");
        $dataObj->setSearchRule("[utilizacion]='5'");
        $dataPdBarniz=$dataObj->fetch();  //logErr($dataPdBarniz,dataPdBarniz,false); 

        foreach($dataPdBarniz as $key=>$value)
        {
        $result=$dataObj->DeleteRecord($value);

        if(!$result)
            return false;
        }//logErr();
          
        $params=array('shell_id'=>$recArr['shell_id'],'inserto_id'=>$recArr['inserto'],'liquido_id'=>$recArr['liquido_contiene'] );
        $this->dataObjName="erp.barniz_interior.dataobj.d_ga_erp_barniz_interior";
        $dataRec=$this->searchBarnizInterior($params);   //logErr($dataRec,dataRec,false); 
        unset($params);

        if(!isset($dataRec[0])) 
        {
            $texto=$this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_BARNIZ_INTERNO_NO_FOUND",array($dataShell[0]['shell'],$recArr['inserto'],$recArr['liquido_contiene']));
            $g_BizSystem->ClientProxy()->ShowClientAlert($texto); 
            //logErr($texto,BarnizInterior,false);
            return false;
        }
            
        $params=array('pd_shell_id'=>$Pd_Shell_id,'color'=>$dataRec[0]['color'],'utilizacion'=>5 );
        $dataParam=array('cantidad_maxima'=>$dataRec[0]['cantidad_maxima'],'hoja_m2'=>$hoja_m2,
                        'num_tapas'=>$dataShell[0]['num_tapas'],'barniz_interior_id'=>$dataRec[0]['barniz_interior_id']);  
        $this->dataObjName="epd.pd_barniz.dataobj.d_ga_pd_barniz";
        $result=$this->InsertBarnizInteriorPD($params,$dataParam); // logErr($result,result,false);

        if($result)
            return true;
        return false;
        }

        function calcularM2($hoja,$unidad=1000)   
        {
        $metro2=1;
        if(strpos($hoja,"*")===false)
        {
         BizSystem::log(LOG_ERR, "Hoja Shell 0",$hoja);   
            return false;
        }
        $dimensiones=explode("*",$hoja);
        if(count($dimensiones)!=3)
        return 0;
               
        foreach($dimensiones as $key=>$valor)
        {  
            
           if(strpos($valor,",")!==false)
            $valor=str_replace(",",".",$valor); 
           
           if(is_numeric($valor) && $valor>1)
             $metro2*=$valor/$unidad;
         //  logErr($metro2,metro,false);  
        }

        if($metro2!=1)
        return $metro2;
        else
        return 0;

        }

        function NotificarCambio($values=array(),$array_diff=array(),$form)
        {         
            $params=array();
            global $g_BizSystem;
            $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("erp.parametrizacion_interna.dataobj.d_ga_erp_plantilla_parametrizacion_envio_email");
            $params = $dataObj->buscarParametrizacionEnvioEmail('CAMBIO_DATO_SOLICITUD');  
              // logErr($params,params,false);
              // logErr($array_diff,array_difff,false);
               //qw
                 $formName="epd.pd_solicitud.form.f_ga_pd_solicitud_detail_email";
                 $formObj = BizSystem::ObjectFactory()->GetObject($formName);
                 $dataRender =$formObj->m_DataPanel->RenderRecord($array_diff);
               
            // logErr($dataRender,datarender,false);     
            $datosfinales=array();
            foreach($array_diff as $k=>$v) 
            {   
                foreach($dataRender as $key=>$val)
                {
                    if(stripos($key,$k)!==false)
                    {
                       $datosfinales[$val['label']]=strip_tags($val['element']);
                    }
                }
            }
           //  logErr($datosfinales,datosfinales,false);
            $cadena=$form->GetMessage('MSG_GA_PD_GA_PD_CAMPO_MODIFICADO')."
            ";  //logErr($cadena,cadena1,false);    
            foreach($datosfinales as $key=>$val)
            { 
                $cadena.=$key.":".$val.", ";
            }
            //  logErr($cadena,cadena,false);
            if(is_array($values))
            {
            $params['subject']=$dataObj->aplicarVariables($params['subject'],$values); 
            $params['body']=$dataObj->aplicarVariables($params['body'],$values); 
            }

            if(!isset($params['to']))return;

            // if(count($array_diff)>0)   
            $params['body'].=$cadena;   
          //  logErr($params,"salida #1 de parametros de cambios solicitud sin HEX",false); 
            if($form->cargarFormaEnvio()!="SMTP")  
            {      
            $params['subject']=$dataObj->aplicarBinarioHex($params['subject']); 
            $params['body']=$dataObj->aplicarBinarioHex($params['body']);      
            }
           //logErr($params,"salida #2 de parametros de cambios solicitud CON HEX",false); 
            //validacion de direcciones de email.
            $validObj = $g_BizSystem->GetService(VALIDATE_SERVICE);

                          
            if(($params['to']=='' || is_null($params['to'])) && ($params['cc']=='' || is_null($params['cc']))&& ($params['bcc']=='' || is_null($params['bcc'])))
                return;
            $emails=explode(";", $params['to']);               
            foreach ($emails as $value) {
                  $value=trim($value);  
                $errorMessage=$validObj->email($value);

                if ($errorMessage == false) { //Couldn't get a clear error message so let's try this
                    return;
                }

            }  
             if($params['cc'] && trim($params['cc'])!="")
             {
                $emails=explode(";", $params['cc']);               
                foreach ($emails as $value) {
                      $value=trim($value);  
                    $errorMessage=$validObj->email($value);

                    if ($errorMessage == false) { //Couldn't get a clear error message so let's try this
                        return;
                    }

                } 
             }
             if($params['bcc'] && trim($params['bcc'])!="")
             {
                 $emails=explode(";", $params['bcc']);               
                foreach ($emails as $value) {
                      $value=trim($value);  
                    $errorMessage=$validObj->email($value);

                    if ($errorMessage == false) { //Couldn't get a clear error message so let's try this
                        return;
                    }

                } 
             }   // logErr($params,params,false);  
            //envio del email
             if($form->cargarFormaEnvio()!="SMTP")
            {
                $emailObj = $g_BizSystem->GetService(SEND_MAIL_SERVICE);
                $emailObj->enviarEmailSql($params);   
            }else{                       
                $emailObj = $g_BizSystem->GetService(USER_EMAIL_SERVICE); //logErr("cargo el servicio","",false);
                $emailObj->sendEmailNowSimple($params);   
            }
            // logErr(Notifico,notifico,false)  ;
            return;
        }

         public function cargarFormaEnvio()
        {                   
                $system_configuration= $_SESSION['system_configuration'];
               $system_define=array();
               $work=null;
               if(is_array($system_configuration))
               {     
                   foreach($system_configuration as $key=>$val)
                   {
                       if($val['clave']=="EMAIL")
                       {
                           $work=$val['valor'];     break ;
                       }
                   }
               }
                
               return $work;
        }
  
}