<?php 

class f_ga_pd_solicitud_generica_list_g extends EasyForm 
{ 
    
    public function FetchDataSet()
    {
        $result=parent::FetchDataSet();
        
        foreach($result as $key=>$value)
        {
        if($value['num_pd']==-1 ||$value['num_pd']=="-1")
            $result[$key]['num_pd']="";
        }
            
        return $result;
    }
    
     public function RunSearch()
    {
        include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";$cadena=array();
        foreach ($this->m_SearchPanel as $elem)
        {
           
            if (!$elem->m_FieldName )
                continue;
              
             $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);
             $bizField = $this->GetDataObj()->GetField($elem->m_FieldName);     
              
             $check=$bizField->CheckValueType($value);  
             if(!$check)
              continue; 

             $cadena[$elem->m_FieldName]=$value;
             $activo=true;
             if($elem->m_Name=="qry_shell" && $value==-1)
                    $activo=false;
             if($elem->m_Name=="qry_estado" && $value==-1)
                    $activo=false;

            if($elem->m_FuzzySearch=="Y" && $value!=""){
                $value="*$value*";
            }
            if ($value && $activo ) {

               $searchStr = InputValToRule($elem->m_FieldName, $value, $this); 
           
                if ($searchRule == "")
                   $searchRule .= $searchStr;
                else
                   $searchRule .= " AND " . $searchStr;
                 
            }
        }  
        $this->m_SearchRule = $searchRule;
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;

        $this->m_CurrentPage = 1;
        $this->guardarCurrentPage();

        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);

        $this->RunEventLog();
        $this->ReRender();
    }
}