<?php 

 include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd_solicitud.msg');    
 
class f_ga_pd_solicitud_new extends EasyForm
{
    public function SaveRecord()
    {

     
    $recArr = $this->ReadInputRecord();
    $this->SetActiveRecord($recArr);   
    if (count($recArr) == 0)
    return;
    
    try {
    $this->validarSustiyeA($recArr);  
    }
    catch (ValidationException $e) {
    $this->ProcessFormObjError($e->m_Errors);
    return;
    }   
    
    //$recArr = $this->CargarEstadoInicial($recArr);
    
    if ($this->m_FormType == "NEW")
    {
    // check access, if deny, redirect to access deny page
    if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".create"))
        return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
    $dataRec = new DataRecord(null, $this->GetDataObj());
    }


    foreach ($recArr as $k => $v)
    $dataRec[$k] = $v; // or $dataRec->$k = $v;
     
       try {
      $ok=$dataRec->Save();  
      //$this->aplicarSustitucionPD($recArr);   
     // logErr("terminotry",try_try,false);  
    } 
    catch (ValidationException $e) {
        $errElements = $this->GetErrorElements($e->m_Errors); 
        $this->ProcessFormObjError($errElements);
        return;
    }
    catch (BDOException $e) {
        $this->ProcessBDOException($e);    
        return;
    }
                            
    $this->GetActiveRecord($dataRec["Id"]);   
   // logErr($dataRec["Id"],GetActiveRecord,false);  

    $this->RunEventLog();

    if($dataRec['num_pd'] && $dataRec['num_pd']>1)
    {
        $texto=$this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_SAVE_CORRECT",array($ok)); 
        BizSystem::ClientProxy()->ShowClientAlert($texto);
    }
        //logErr(ProcessPostAction,ProcessPostAction,false); 
    
    list($redirectPage,$target) = $this->GetRedirectPage();  
    $redirectPage.=$dataRec["Id"]; //logErr($redirectPage,redirec,false);
    BizSystem::ClientProxy()->ReDirectPage($redirectPage);   


    }

    public function aplicarSustitucionPD($recArr=array())
    {
        
    if(isset($recArr['sustituye_num_pd']) && $recArr['sustituye_num_pd']!="" && $recArr['sustituye_num_pd']>0)
    { 
    $dataObjPD = BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd");   
    $dataObjPD->setSearchRule("[num_pd]='".$recArr['sustituye_num_pd']."'");  
    $dataRec=$dataObjPD->fetch();
                                                
    if(isset($dataRec[0]['Id']) )
        {
            $oldDataRec=$dataRec=$dataRec[0];
                                                       
            $dataRec['estado']=4;
            $dataRec['fecha_anulacion']=date("d-m-Y");
            $dataRec['anulada']=1;
                                                  
            $result=$dataObjPD->UpdateRecord($dataRec,$oldDataRec);
             
        }
    }

    return;

    }

    public function validarSustiyeA($recArr=array())
    {       
    $this->ValidateForm();      
    
    if($recArr['sustituye_num_pd']=="") return ;
    
    $bizFld = $this->GetDataObj()->m_BizRecord->get('sustituye_num_pd');                    
    if(isset($recArr['sustituye_num_pd']) && $recArr['sustituye_num_pd']>0)
    { 



        if($recArr['sustituye_num_pd']!==null && $bizFld->CheckValueType($recArr['sustituye_num_pd']) === false)
        {
            $this->m_ErrorMessage = $this->GetMessage("DATA_FIELD_INCORRECT_TYPE",array($bizFld->m_label, $bizFld->m_Type));
            $this->m_ValidateErrors["fld_sustituye_num_pd"] = $this->m_ErrorMessage; 
    
        }else
        {
 
            $dataObjPD = BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd");   
            $dataObjPD->setSearchRule("[num_pd]='".$recArr['sustituye_num_pd']."'");  
            $dataRec=$dataObjPD->fetch();

            if( $recArr['num_pd']==$recArr['sustituye_num_pd'])
            {
              $errorMessage = $this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_MISMO_NUM_PD_SUSTITUYE",array($bizFld->m_label));  
              $this->m_ValidateErrors["fld_sustituye_num_pd"] = $errorMessage;
            }
            elseif(!isset($dataRec[0]['Id']) || $dataRec[0]['num_pd']!=$recArr['sustituye_num_pd'])
            {
              $errorMessage = $this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_NOT_NUM_PD_SUSTITUYE",array($bizFld->m_label));  
              $this->m_ValidateErrors["fld_sustituye_num_pd"] = $errorMessage;
            }
        }
    }
    else
    {
         $errorMessage = $this->GetMessage("DATA_FIELD_INCORRECT_TYPE",array($bizFld->m_label, $bizFld->m_Type));  
         $this->m_ValidateErrors["fld_sustituye_num_pd"] = $errorMessage;
    }


    if (count($this->m_ValidateErrors) > 0)
    {             
    throw new ValidationException($this->m_ValidateErrors);
    return false;
    }

    
    return true;  
    }
  
    protected function ValidateForm()
    {
    $this->m_ValidateErrors = array();
    $this->m_DataPanel->rewind();

    while($this->m_DataPanel->valid()){                
        $elem=$this->m_DataPanel->current();
        if($elem->m_Label){
            $elem_name = $elem->m_Label;
        }else{
            $elem_name = $elem->m_Text;
        }   
        if($elem->m_BlankOption){  
            if($elem->m_Value==-1 && $elem->CheckRequired() === true){
                $errorMessage = $this->GetMessage("DATA_FIELD_REQUIRED",array($elem_name));
                $this->m_ValidateErrors[$elem->m_Name] = $errorMessage;
               
                }
        }
         if ($elem->CheckRequired() === true &&
             ($elem->m_Value===null || $elem->m_Value === "")) {
            //logErr($elem, 'elem', false);
            $errorMessage = $this->GetMessage("DATA_FIELD_REQUIRED",array($elem_name));
            $this->m_ValidateErrors[$elem->m_Name] = $errorMessage;  
            
         }         
         else if ($elem->m_Value!==null && $elem->Validate() === false) {
            GLOBAL $g_BizSystem;            
            $srvcObj = $g_BizSystem->GetService(VALIDATE_SERVICE);
            $errorMessage = $srvcObj->GetErrorMessage($elem->m_Validator, $elem_name);            
            if ($errorMessage == false) { //Couldn't get a clear error message so let's try this
               $errorMessage = $this->GetMessage("FORM_ELEMENT_INVALID_INPUT",array($elem_name));
            } 
            $this->m_ValidateErrors[$elem->m_Name] = $errorMessage; 
            //return false;
         } 
         $this->m_DataPanel->next() ;
    }

    if (count($this->m_ValidateErrors) > 0)
    {             
        throw new ValidationException($this->m_ValidateErrors);
        return false;
    }
    return true;
    }
    
    public function CargarEstadoInicial($recArr=array())
    {
         global $g_BizSystem; 
             //  logErr($recArr,recArr,false);
       $system_configuration= $_SESSION['system_configuration'];
       $system_define=array();
       if(is_array($system_configuration))
       {     
           foreach($system_configuration as $key=>$val)
           {
               if($val['clave']=="PD_WORKFLOW")
               {
                   $work=$val['valor'];     break ;
               }
           }
              // logErr($work,work,false);   
         if($work=='_it') 
         {
             if($recArr['solicitud_pdf'])
             {
                 $recArr['estado']=9;
             }
             else
             {
                  $recArr['estado']=9;
             }
         }
         else
         {
            $recArr['estado']=1;  
         }
       }
 
       return $recArr;
    }
 
}