<?php 
class f_ga_pd_tinta_dl_comp_list extends EasyFormDinamic 
{ 
 
    public function DeleteRecord($id=null)
    {                                   
        if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".delete"))
            return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
        
        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;
        foreach ($selIds as $id) {
            $searchRule="[Id]='".$id."'"; 
            $recArray=array();
            $this->GetDataObj()->FetchRecords($searchRule,$recArray ,-1,0,true,true); 
            $recArray=$recArray[0];
            $this->GetDataObj()->SetActiveRecord($recArray);
            $dataRec = new DataRecord($recArray, $this->GetDataObj());
            // take care of exception
            try {
                $dataRec->Delete();
            } catch (BDOException $e) {
                // call $this->ProcessBDOException($e);
                $this->ProcessBDOException($e);
                return;
            }
        }
       //version vieja 
       $formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_list");  
       //$formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_comp_list");  
       //$formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_colores.form.f_ga_pd_color_list");  
       BizSystem::ClientProxy()->ReDrawForm($formObj->m_Name,  $formObj->Render());  
       
        $this->RunEventLog();
        $this->ProcessPostAction();
    }
    
    public function FetchDataSet2()
    {
        $result=parent::FetchDataSet();   //logErr($result);
        
        foreach($result as $key=>$value)
        {
            if(isset($value['esmalte_color']) && !isset($value['tinta_color']))
            {
                $result[$key]['tinta_color']=$value['esmalte_color'];
                $result[$key]['tinta_referencia']=$value['esmalte_referencia'];
                $result[$key]['tinta_proveedor']=$value['esmalte_proveedor'];
            }
        }
        
        return $result;
    }
    
   
}

?>