<?php 
class f_ga_pd_tinta_dl_list_articulo extends EasyForm 
{          
    public function GetSessionVars($sessCtxt)  
    {   
        $sessCtxt->GetObjVar($this->m_Name, "CurrentPage", $this->m_CurrentPage);
        parent::GetSessionVars($sessCtxt); 
    }

    public function SetSessionVars($sessCtxt) 
    {   
        $this->m_Name = "epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_list";
        $sessCtxt->SetObjVar($this->m_Name, "CurrentPage", $this->m_CurrentPage);   
        parent::SetSessionVars($sessCtxt);   
    }

    public function DeleteRecord($id=null)
    {
         if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".delete"))
            return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
        
        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;
        foreach ($selIds as $id) {
            $recArray = $this->GetDataObj()->FetchById($id);
            $this->GetDataObj()->SetActiveRecord($recArray);
            $dataRec = new DataRecord($recArray, $this->GetDataObj());
            // take care of exception
            try {
                $dataRec->Delete();
            } catch (BDOException $e) {
                // call $this->ProcessBDOException($e);
                $this->ProcessBDOException($e);
                return;
            }
        }
        
     //   if ($this->m_FormType == "LIST" || $this->m_FormType="GRIDBOX")
            $this->ReRender();
       $this->actualizarOrden();  
        //$this->RunEventLog();
       // $this->ProcessPostAction();
    }
    public function SelectRecord($recId)
    {
        if ($recId==null || $recId=='')
            $recId = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
             
        $this->m_RecordId = $recId;     
        $this->GetDataObj()->SetActiveRecordId($this->m_RecordId);
        $this->ReRender(false); // not redraw the this form, but draw the subforms
        
    }

    public function FetchDataSet()
    {
        $result=parent::FetchDataSet(); 
        //logErr($this->GetDataObj()->GetAssociation());
        $dataObj = BizSystem::GetObjectFactory()->GetObject("epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl_comp");
        if (!$dataObj) return false;
        
        foreach($result as $key=>$value)
        {          
            $dataObj->ResetRules();
            $SearchRule="[pd_tinta_dl_id]='".$value['Id']."'";
            $records=array();
            $dataObj->FetchRecords($SearchRule,$records,-1,0,true,true);   //logErr($records);
                                            
            //tratamiento para los esmaltes
            foreach($records as $k=>$v)
            {
                if(isset($v['esmalte_color']) && !isset($v['tinta_color']))
                {
                    $records[$k]['tinta_color']=$v['esmalte_color'];
                    $records[$k]['tinta_referencia']=$v['esmalte_referencia'];
                    $records[$k]['tinta_proveedor']=$v['esmalte_proveedor'];
                }
            }    
            
            $formObjDl = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_comp_list_articulo"); 
            $dataPanel = $formObjDl->m_DataPanel->RenderTable($records);  
            $actionPanel = $formObjDl->m_ActionPanel->Render(); 
            $navPanel= $formObjDl->m_NavPanel->Render(); 
            
            $result[$key]['subform']['dataPanel']=$dataPanel;
            $result[$key]['subform']['actionPanel']=$actionPanel;
            $result[$key]['subform']['navPanel']=$navPanel;
            $result[$key]['subform']['name']="epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_comp_list";
            $result[$key]['subform']['newobj']="\n<script> NewObject('".$formObjDl->m_Name."','" .$formObjDl->m_jsClass. "'); </script>\n";
            $result[$key]['newobj']="\n<script> NewObject('".$formObjDl->m_Name."','".$formObjDl->m_jsClass."'); </script>\n";
            $result[$key]['tipo']=2; 
             
            unset($formObjDl);
        }
            
        return $this->ordenar($result);  
    }

    public function ordenar($result,$campo='no_order')
    {
        if(!is_array($result)) return null;
        $cant=count($result);
        if($cant==0) return $result;   
        if($cant==1)
        {
            $result[0]['lugar']=1;
            $result[0]['ultimo']=1;
            return $result;   
        }
        $cont=1;
        for($i=0;$i<$cant-1;$i++)
        {
            for($j=$i;$j<$cant;$j++)
            {
                $temp=array();
                if($result[$i][$campo]>$result[$j][$campo])
                {
                    $temp=$result[$i];
                    $result[$i]=$result[$j];
                    $result[$j]=$temp;
                }
            }
            $result[$i]['lugar']=$cont++; 
            $result[$i]['ultimo']=0; 
        }
        $result[$cant-1]['lugar']=$cont;
        $result[$cant-1]['ultimo']=1;
        return $result;
    }
}

?>