<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg'); 

class f_ga_pd_tinta_dl_pdc_edit extends PickerForm 
{ 
	public function FetchData()
	{	
		$this->pdc=new GaPDC();
		
		$data[0]=parent::FetchData();
		$name="epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl";
		
		if(isset($data[0])){ 		
		$dataSet=array();
		$dataSet=$this->pdc->cargarDataObjUpdate($name,$data,$data[0]['pd_id']);
		}
		else{
			$Id=BizSystem::ClientProxy()->GetFormInputs('_selectedId');
		
			if(is_null($Id))
				$Id=BizSystem::ClientProxy()->GetFormInputs('fld_Id');
		
			if(is_null($Id)){
			
			foreach($this->m_SearchRuleBindValues as $k=>$v)
			{
				if(substr_count($this->m_FixSearchRule,$k)>0 && substr_count($this->m_FixSearchRule,'Id')>0)
				{
					$Id=$v;
					break;
				}
			}			
			}

			$data[0]['Id']=$Id;		
			$dataSet=$this->pdc->cargarDataObjUpdate($name,$data);	

		}	

		return $dataSet[0];
	}

    public function SaveRecord()
	{
        global $g_BizSystem;
	    $this->pdc=new GaPDC();
	    $recArr = $this->ReadInputRecord();
	
	    $comprobacion=$this->pdc->comprobarPDC($recArr['pd_id']);
	    if(!$comprobacion){
				    $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                    $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
				    return;
	    }

	    if ($this->m_FormType != "NEW")
        {
            $currentRec = $this->FetchData();
			//logErr($currentRec, 'currentRec', false);
        }
       
        $this->SetActiveRecord($recArr);
        if (count($recArr) == 0)
            return;
                
        try {
            $this->ValidateForm();
        }
        catch (ValidationException $e) {
			$this->ProcessFormObjError($e->m_Errors);
			return;
        }   
        
      	$name="epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl";
		$dataRec= array();
		if ($this->m_FormType == "EDIT")
		{
			$dataRec['Id']=$currentRec['Id'];
			foreach ($recArr as $k => $v){
				
				if($currentRec[$k]!=$v ){
					 if(!($currentRec[$k]==0 && $v=="") ){
						$dataRec[$k]=$v;
                                    }
				}
					
			}			
			//logErr($dataRec, 'dataRec', false);
			$this->pdc->registrarCambioUpdate($name,$dataRec,$currentRec['pd_id']);
		 
        }
		 if ($this->m_ParentFormName)
        {
            $this->Close();
        
            $this->RenderParent();
        }
       
        $this->ProcessPostAction();		
	}
}

?>