<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg'); 

class f_ga_pd_tinta_dl_pdc_list extends EasyForm 
{ 
    private $pdc;
    public function guardar($value,$order)
    {           
        if($value['pd_num_pd'])
        {
            $dataobj=BizSystem::GetObjectFactory()->GetObject("epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl_order");    
            $newRecord=$value;  
            $newRecord['no_order']=$order; 
        }else
        {
            $dataobj=BizSystem::GetObjectFactory()->GetObject("epd.pdc.dataobj.d_ga_pdc");  
            $dataobj->ResetRules();
            $dataobj->SetSearchRule("[accion]='1'");
            $dataobj->SetSearchRule("[tabla]='ga_pd_tinta_dl'");
            $dataobj->SetSearchRule("[registro_id]='".$value['Id']."'");
            $dataobj->SetSearchRule("[pd_id]='".$value['pd_id']."'");     
            $dataobj->SetSearchRule("[campo]='no_order'");  //logErr($value,value1,false);    
            $value=$dataobj->Fetch();   //logErr($value,value2,false);
            if(isset($value[0]))
            $value=$value[0];  
            $newRecord=$value;
            $newRecord['valor']=$order; 
        }
               
        $ok=$dataobj->UpdateRecord($newRecord,$value);
                          
        return $ok;
    }
    
    public function Subir($id=null)
    {                                           // logErr($id,id,false);
        $listado=$this->FetchDataSetOrder();       // logErr($listado,listado,true);  
        if(!is_array($listado)) return ;
        $cant=count($listado);
        if($cant==1 || $cant==0 || !$id) $this->UpdateForm();
                                                    // logErr($cant); 
                                                     
        foreach($listado as $key=>$value)
        {             // logErr($value,item,false);
            if($value['Id']==$id)
            {
                                                                  //logErr($listado[$key-1]['lugar'],order,false);
                $ok= $this->guardar($listado[$key],$listado[$key-1]['lugar']); // logErr($ok,$listado[$key]['Id'],true);    
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
                $ok= $this->guardar($listado[$key-1],$listado[$key]['lugar']); //logErr($ok,$listado[$key-1]['Id'],false);   
               if(!$ok)
               {
                   logErr($listado[$key-1]['Id'],"Se partio intentado subir",false);
               }
                $listado[$key]['no_order']=$listado[$key-1]['lugar'];
                $listado[$key-1]['no_order']=$listado[$key]['lugar'];
                $listado[$key]['lugar']=$listado[$key]['no_order'];
                $listado[$key-1]['lugar']=$listado[$key-1]['no_order'];   //logErr($listado); 
                break;
            }
        }                              //  logErr($listado);  
        foreach($listado as $key=>$value)
        {
            if($value['no_order']!=$value['lugar'])
            {
               $ok= $this->guardar($value,$value['lugar']);
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
            }
        }
        
        $this->UpdateForm();
    }
    
    public function Bajar($id=null)
    {
        $listado=$this->FetchDataSetOrder();        // logErr($listado);  
        if(!is_array($listado)) return ;
        $cant=count($listado);
        if($cant==1 || $cant==0 || !$id) $this->UpdateForm();
                                                    
                                                     
        foreach($listado as $key=>$value)
        {
            if($value['Id']==$id)
            {
                
                $ok= $this->guardar($listado[$key],$listado[$key+1]['lugar']);  //logErr($ok,$listado[$key]['Id'],false);    
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
                $ok= $this->guardar($listado[$key+1],$listado[$key]['lugar']); //logErr($ok,$listado[$key-1]['Id'],false);   
               if(!$ok)
               {
                   logErr($listado[$key-1]['Id'],"Se partio intentado subir",false);
               }
                $listado[$key]['no_order']=$listado[$key+1]['lugar'];
                $listado[$key+1]['no_order']=$listado[$key]['lugar'];
                $listado[$key]['lugar']=$listado[$key]['no_order'];
                $listado[$key+1]['lugar']=$listado[$key+1]['no_order'];  // logErr($listado); 
                break;
            }
        }                              //  logErr($listado);  
        foreach($listado as $key=>$value)
        {
            if($value['no_order']!=$value['lugar'])
            {
               $ok= $this->guardar($value,$value['lugar']);
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
            }
        }
        
        $this->UpdateForm();
    }
    
    public function FetchDataSetOrder()
    {
        $pd_id=0;
        $this->pdc=new GaPDC(); 
        $result=parent::FetchDataSet();  // logErr($result);
        $name="epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl";   
        
                                         
        $nre=$this->GetDataObj()->NewRecord(); 
         if(isset($nre['pd_shell_id']) && $nre['pd_shell_id']>0)
        {
            $shell_pd=BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
            $data=$shell_pd->FetchById($nre['pd_shell_id']);
            
            if(isset($data['pd_id']) && $data['pd_id']>0)
            $pd_id=$data['pd_id'];
        }
             
        
        $result1=$this->pdc->cargardataObjInsert($name,$pd_id); //logErr($result1);
        if(is_array($result1))
        foreach($result1 as $value)
            $result[]=$value;
       
        $result=$this->pdc->cargarDataObjUpdate($name,$result,$pd_id);
        
        if($pd_id) $_SESSION['num_pd_dl']=$pd_id;
      
        if(!is_array($result)) return;
        foreach($result as $key=>$value)
        {                          
            $result[$key]['tipo']=2;    
        }
            
        return $this->ordenar($result);  
    }
    
    public function FetchDataSet()
    {
        $pd_id=0;
        $this->pdc=new GaPDC(); 
        $result=parent::FetchDataSet();  // logErr($result);
        $AssociationDL=$this->GetDataObj()->GetAssociation();
        $name="epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl";   
        
                                         
        $nre=$this->GetDataObj()->NewRecord();
         if(isset($nre['pd_shell_id']) && $nre['pd_shell_id']>0)
        {
            $shell_pd=BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
            $data=$shell_pd->FetchById($nre['pd_shell_id']);
            
            if(isset($data['pd_id']) && $data['pd_id']>0)
            $pd_id=$data['pd_id'];
        }
        
        
        $result1=$this->pdc->cargardataObjInsert($name,$pd_id); //logErr($result1);
        if(is_array($result1))
        foreach($result1 as $value)
        {
            if(isset($value[$AssociationDL['Column']]) && $value[$AssociationDL['Column']]==$AssociationDL['FieldRefVal'])
                $result[]=$value;
        }
        
        $result=$this->pdc->cargarDataObjUpdate($name,$result,$pd_id);
        
        if(isset($result[0]['pd_id']))
        {
        $pd_id=$result[0]['pd_id']; 
        if($pd_id) $_SESSION['num_pd_dl']=$pd_id;
        }
        $dataObj = BizSystem::GetObjectFactory()->GetObject("epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl_comp");
        if (!$dataObj) return false;
        
        if(!is_array($result)) return;
        foreach($result as $key=>$value)
        {                          
            $dataObj->ResetRules();
            $SearchRule="[pd_tinta_dl_id]='".$value['Id']."'";
            $records=array();
            $dataObj->FetchRecords($SearchRule,$records,-1,0,true,true);      
            
            //trato especial
            $name="epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl_comp";
            $records=$this->pdc->cargarDataObjUpdate($name,$records,$pd_id); 
            $temp=array();
                foreach($records as $item)
                {                      
                    if($value['Id']==$item['pd_tinta_dl_id'])
                        $temp[]=$item;
                } 
             $records=$temp;            
             //tratamiento para los esmaltes
            foreach($records as $k=>$v)
            {
                if(isset($v['esmalte_color']) && !isset($v['tinta_color']))
                {
                    $records[$k]['tinta_color']=$v['esmalte_color'];
                    $records[$k]['tinta_referencia']=$v['esmalte_referencia'];
                    $records[$k]['tinta_proveedor']=$v['esmalte_proveedor'];
                }
            }  
         
            $formObjDl = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_comp_pdc_list"); 
            $dataPanel = $formObjDl->m_DataPanel->RenderTable($records);  
            $actionPanel = $formObjDl->m_ActionPanel->Render(); 
            $navPanel= $formObjDl->m_NavPanel->Render(); 
            
            $result[$key]['subform']['dataPanel']=$dataPanel;
            $result[$key]['subform']['actionPanel']=$actionPanel;
            $result[$key]['subform']['navPanel']=$navPanel;
            $result[$key]['subform']['name']="epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_comp_pdc_list";
            $result[$key]['subform']['newobj']="\n<script> NewObject('".$formObjDl->m_Name."','" .$formObjDl->m_jsClass. "'); </script>\n";
            $result[$key]['newobj']="\n<script> NewObject('".$formObjDl->m_Name."','".$formObjDl->m_jsClass."'); </script>\n";
            $result[$key]['tipo']=2;    
             
            unset($formObjDl);
        }
            
        return $this->ordenar($result);  
    }    
    
    public function ordenar($result,$campo='no_order')
    {
        if(!is_array($result)) return null;
        $cant=count($result);
        if($cant==0) return $result;   
        if($cant==1)
        {
            $result[0]['lugar']=1;
            $result[0]['ultimo']=1;
            return $result;   
        }
        $cont=1;
        for($i=0;$i<$cant-1;$i++)
        {
            for($j=$i;$j<$cant;$j++)
            {
                $temp=array();
                if($result[$i][$campo]>$result[$j][$campo])
                {
                    $temp=$result[$i];
                    $result[$i]=$result[$j];
                    $result[$j]=$temp;
                }
            }
            $result[$i]['lugar']=$cont++; 
            $result[$i]['ultimo']=0; 
        }
        $result[$cant-1]['lugar']=$cont;
        $result[$cant-1]['ultimo']=1;
        return $result;
    }
    
    public function actualizarOrden()
    {                          
       $listado=$this->FetchDataSetOrder();           
        if(!is_array($listado)) return ;
        $cant=count($listado);
        if($cant==1 || $cant==0 || !$id) $this->UpdateForm();
        
        foreach($listado as $key=>$value)
        {
            if($value['no_order']!=$value['lugar'])
            {
               $ok= $this->guardar($value,$value['lugar']);
               if(!$ok)
               {
                   logErr($value['Id'],"Se partio intentado subir",false);
               }
            }
        }  
        $this->UpdateForm();  
    }
    
	public function DeleteRecord($id=null)
	{ 	
        $this->pdc=new GaPDC();
		global $g_BizSystem;
	    $comprobacion=-1;
	    if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".delete"))
            return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
        
        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;
        foreach ($selIds as $id) {
            $recArray = $this->GetDataObj()->FetchById($id);
			
            if($comprobacion==-1)
			    $comprobacion=$this->pdc->comprobarPDC($recArray['pd_id']);
			if(!$comprobacion){
			    $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
			    return;
			}
			
			$name="epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl";
			
			if(is_null($recArray))
			{
			$recArray['Id']=$id;
			//logErr($recArray, 'recArrayNULL', false);
			$this->pdc->registrarCambioDelete($name,$recArray);
			}
			else{
			//logErr($recArray, 'recArrayNONULL', false);
			$this->pdc->registrarCambioDelete($name,$recArray,$recArray['pd_id']);
			}
            
        }
        $this->actualizarOrden();
        //$this->ReRender();
        $redirectPage="controller.php?view=epd.pdc.view.ga_pd_detail&fld:Id=".$_GET['fld:Id'];
        BizSystem::ClientProxy()->ReDirectPage($redirectPage);   
      
        $this->RunEventLog();
        $this->ProcessPostAction();
	}
}

?>