<?php 
require_once APP_HOME.'/bin/guala/gualaPDF.php';
include_once(MODULE_PATH.'/common/message/ga_attachment.msg'); 
//require_once APP_HOME.'/bin/pdc/GaPDC.php';

class f_ga_pd_detail_menu extends EasyForm 
{ 
    private $pdf; 
 //   private $pdc;
  
    private function getImagenPath()
    {
    $data = $this->getDataRow();
    
    return "../files/sec_upload/pd_imagen/".$data['fld_Id']['data'].".jpg";
  }
  
    public function aprobacionPDPDF()
    {
        require_once('AprobacionPD.php');
        $data = $this->getDataRow();

        global $g_BizSystem;
        $dataObjPDShell= $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
        $dataRec=$dataObjPDShell->fetch();

        if(count($dataRec)==1)
            $data['fld_shell']=array ('label' => 'shell','data'=>$dataRec[0]['shell']);

        $pdf = new AprobacionPD($data);
         ob_end_clean();
        $pdf->Output('example_013.pdf', 'I');

        return;
    
  
          $pdf = new gualaPDF('', false);

          $pdf->setPrintHeader(false);
          $pdf->setPrintFooter(false);

          $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

          $pdf->SetDrawColor(0);
          $pdf->SetTextColor(0);
          $pdf->Rect(50, 20, 40, 10, 'D');
          $pdf->Text(50, 19, 'Scale');

          $pdf->Output('example_013.pdf', 'I');

      return;
    $data = $this->getDataRow();
    
    $imagen = $this->getImagenPath();
    
    $this->pdf = new gualaPDF('título 1', false); 
    
    $string = $this->pdf->Render($this, 'aprobacion_pd_pdf.tpl', 
                                        array('data'           => $data,
                                              'file_exists'    => file_exists($imagen),
                                              'imagen'         => $imagen
                                            )
                                );
    
    $this->pdf->writeHTML($string, true, false, false, false, '');
    
    $this->pdf->Output($recordSet[0]['Id']."_".date('Y-m-d').'.pdf'); 
  }
  
    private function GetTargetPath()
    {
      return SECURE_UPLOAD_PATH.DIRECTORY_SEPARATOR."pd_imagen";
    }
     
    private function getDataRow()
    {
    $recordSet[0] = $this->FetchData();
        $dataSet = $this->m_DataPanel->RenderTable($recordSet);
    $data = array();

    foreach ($dataSet['elems'] as $key => $elem)
    {
        $data[$key]['label'] = $elem['label'];
        $data[$key]['data']  = strip_tags($dataSet['data'][0][$key]);
    }

    return $data;
  }
    
    public function CambiarImagen()
    {
        global $g_BizSystem;
        $image= $g_BizSystem->GetClientProxy()->GetFormInputs("fld_image");    
        
        $PD_Id= $this->m_RecordId;
        
        $filedir = SECURE_UPLOAD_PATH.DIRECTORY_SEPARATOR."pd_attachment".DIRECTORY_SEPARATOR.$PD_Id;
        $filepath = $filedir.DIRECTORY_SEPARATOR.$image;    
        $newfilepath = $filedir.DIRECTORY_SEPARATOR.$PD_Id."_".$image;    
        
        $filepathImage = SECURE_UPLOAD_PATH.DIRECTORY_SEPARATOR."pd_imagen".DIRECTORY_SEPARATOR.$PD_Id.".jpg";        
         
        if(!copy($filepath,$filepathImage ))
        {
            $cargarArchivoErrorMessage = $this->GetMessage("MSG_GA_ATTACHMENT_SOLICITUD_ERROR_SUBIR_ARCHIVO");
            $g_BizSystem->GetClientProxy()->ShowErrorMessage($cargarArchivoErrorMessage);
            return false;
        }
         
        if($gestor= opendir($filedir)){
         
         while (false !== ($archivo = readdir($gestor))) {
            
           if(substr_count($archivo,$PD_Id)>=1){
           $dir1=$filedir.DIRECTORY_SEPARATOR.$archivo;
           $cad=$PD_Id."_";
            
           $archivo=ereg_replace($cad, "", $archivo);
           
           
           $dir2=$filedir.DIRECTORY_SEPARATOR.$archivo;
          
           if(!rename($dir1,$dir2)){
                $cargarArchivoErrorMessage = $this->GetMessage("MSG_GA_ATTACHMENT_SOLICITUD_ERROR_SUBIR_ARCHIVO");
                $g_BizSystem->GetClientProxy()->ShowErrorMessage($cargarArchivoErrorMessage);
            return false;
            }
           break;
           }
        
        }
        closedir($gestor);
        }
         
        if(!rename($filepath,$newfilepath)){
            $cargarArchivoErrorMessage = $this->GetMessage("MSG_GA_ATTACHMENT_SOLICITUD_ERROR_SUBIR_ARCHIVO");
            $g_BizSystem->GetClientProxy()->ShowErrorMessage($cargarArchivoErrorMessage);
        return false;
        }
        //BizSystem::log(LOG_ERR, 'filepath', $filepath.$newfilepath);
        
        //$this->ProcessPostAction();
        $this->UpdateForm();
         
    }
        
    public function VerCambiosSolicitados()
    {
        $_SESSION['solicitud_cambio_pd_id']=$this->m_RecordId;
        $this->ProcessPostAction();
    }
    
    public function FetchData()
    {    
        $data[0]=parent::FetchData();     
        $name="epd.pd.dataobj.d_ga_pd";

        $result=$this->BuscarPosibleCambio($data[0]['Id']);  
        
        if($result>0)
            $data[0]['borrador']=1;
        else
             $data[0]['borrador']=""; 
             
        $data=$data[0];
        return $data;
    }
    
    public function BuscarPosibleCambio($pd_id)
    {
        global $g_BizSystem;
        $dataObjName="epd.pdc.dataobj.d_ga_pdc_estado";
        $srcDataObj = $g_BizSystem->GetObjectFactory()->GetObject($dataObjName);
        if (!$srcDataObj) return false;
        
        $srcDataObj->ResetRules();
        $srcDataObj->SetSearchRule("[pd_id]='".$pd_id."'");
        $srcDataObj->SetSearchRule("([estado]='0' OR [estado]='1')");
        $currentRec=$srcDataObj->Fetch();
        
        return count($currentRec);
    }
    
    public function PostAction()
    {
        list($redirectPage,$target) = $this->GetRedirectPage();
        $redirectPage.="&fld:Id=".$_GET['fld:Id'];
        // otherwise, do page redirection
        BizSystem::ClientProxy()->ReDirectPage($redirectPage);
          
    }
    
}