<?php 

require_once('f_ga_pd_detail.php');
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');

class f_ga_pd_edit extends f_ga_pd_detail 
{ 

	public function SaveRecord()
	{
	$this->pdc=new GaPDC();
	global $g_BizSystem;
	
        if ($this->m_FormType != "NEW")
            $currentRec = $this->FetchData(); 
      
       
	   $recArr = $this->ReadInputRecord();
        $this->SetActiveRecord($recArr);
        if (count($recArr) == 0)
            return;
                
        try {
            $this->ValidateForm();

			$comprobacion=$this->pdc->comprobarPDC($recArr['Id']);// revisar esta comprobacion
			if(!$comprobacion){
				    $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                    $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
				return;
			}
        }
        catch (ValidationException $e) {
			$this->ProcessFormObjError($e->m_Errors);
			return;
        }   		 
		$dataRec= array();
		$dataRec['Id']=$recArr['Id'];
	// logErr($recArr,"recArr",false); 
        foreach ($recArr as $k => $v){
			
			if($currentRec[$k]!=$v && ($v!="")){
					$dataRec[$k]=$v;
			}
				
		}
//logErr($dataRec,"dataRec",false); return;
		$name="epd.pdc.dataobj.d_ga_pd";
        $this->pdc->registrarCambioUpdate($name,$dataRec,$dataRec['Id']);
	       
        $this->ProcessPostAction();
	}
	
}