<?php 

require_once APP_HOME.'/bin/pdc/GaPDC.php';

class f_ga_pdc_list extends EasyForm 
{ 
	public function ActivarPeticionesCambios($pd_id,$usuario_id)
	{
	$pdc=new GaPDC();

	if($pd_id && $usuario_id)
	{
        $pdc->cambiarEstado($pd_id,$usuario_id,0,1);
		$pdc->cambiarEstado($pd_id,$usuario_id,-1,1);
		
		global $g_BizSystem;
		// get the source dataobj
		$dataObjName="epd.pd.dataobj.d_ga_pd";
		$srcDataObj = $g_BizSystem->GetObjectFactory()->GetObject($dataObjName);
		if (!$srcDataObj) return false;
		
		$srcDataObj->ResetRules();
		$srcDataObj->SetSearchRule("[Id]='".$pd_id."'");
		$currentRec=$srcDataObj->Fetch();
		
		$dataRec = new DataRecord($currentRec[0], $srcDataObj);
		$dataRec['estado']='5';
		
		try {
					$dataRec->Save();
				} 
				catch (ValidationException $e) {
					$errElements = $this->GetErrorElements($e->m_Errors); 
					$this->ProcessFormObjError($errElements);
					return;
				}
				catch (BDOException $e) {
					$this->ProcessBDOException($e);	
					return;
				}
		unset( $_SESSION['solicitud_cambio_pd_id']);
		$this->ProcessPostAction();
		}
		else
		{
		$this->UpdateForm();
		}
	
	}
	
	public function CancelarPeticionCambios($num_pd,$usuario_id)
	{	$pdc=new GaPDC();
	    //logErr($num_pd, 'pd', true);
	    //logErr($usuario_id, 'usuario_id', false);
		if($num_pd && $usuario_id)
		{
        $pdc->cancelarPeticionCambios($num_pd,$usuario_id,0);
		$pdc->cancelarPeticionCambios($num_pd,$usuario_id,-1);
		unset( $_SESSION['solicitud_cambio_pd_id']);
        
		list($redirectPage,$target) = $this->GetRedirectPage(); 
        $redirectPage.="&fld:Id=".$num_pd;  
        BizSystem::ClientProxy()->ReDirectPage($redirectPage);   
		}else{
		$this->UpdateForm();
		}
	}
    
    public function FetchDataSet()
    {
        if(isset( $_SESSION['solicitud_cambio_pd_id']) &&  $_SESSION['solicitud_cambio_pd_id']!="")
            $this->SetFixSearchRule("[pd_id]='".$_SESSION['solicitud_cambio_pd_id']."'");

        $result =  parent::FetchDataSet();   
                 
        return $result;
    } 
}