<?php 

include_once(MODULE_PATH.'/epd/cambio_masivo/message/ga_pd_cambio_masivo.msg');

abstract class F_CambioMasivo extends EasyForm
{
	protected $mensajes = array();
	protected $id_relacion;
	protected $id_pd_aditivo;
	protected $dataObjComp;
    public $IdsCambios=array();
	
	public function getMensaje($id)
	{
		return $this->mensajes[$id];
	}
      public function CargarIds($name) 
    {   
         
        $Idsinicial=array();  
        $seccion=BizSystem::SessionContext(); 
        $Idsinicial=$seccion->GetVar($name);    
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        //$this->IdsCambios = $selIds;     
           // logErr($Idsinicial,inicial,false);
        if(is_array($Idsinicial))
        {
            if(is_array($selIds))
           foreach($selIds as $id)
           {
               if(array_search($id,$Idsinicial)===false)
                $Idsinicial[]=$id;
           } 
        } 
        else
        {
            $Idsinicial=$selIds;
        }       
        $seccion->SetVar($name,$Idsinicial);
        
       return $Idsinicial;
    
    }	
	public function CambioMasivo($idAditivoNuevo=null,$name="")
	{
		settype($idAditivoNuevo, "string");
		
		global $g_BizSystem;
		
		if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".cambio_masivo"))
                return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
				
		//$idComp = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
		
        //$selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
		$selIds=$this->CargarIds($name);
		  logErr($selIds,seleccionmultiple,false);      
        if ($selIds == null) {
            $pdSeleccionarMessage = $this->GetMessage("MSG_GA_PD_CAMBIO_MASIVO_NO_PD_SELECCIONADA");
            $g_BizSystem->GetClientProxy()->ShowErrorMessage($pdSeleccionarMessage);
            return;
        }
          
		$fechaCambio=date('d-m-Y H:i:s');	
        $no_cambio=uniqid();
		foreach ($selIds as $id) {
		         logErr($id,id,false);
			$recArray = $this->GetDataObj()->FetchById($id);
                    logErr($recArray,recArray,false);                                
             $dataRec = new DataRecord($recArray, $this->GetDataObj());
                
			if ($dataRec[$this->id_relacion] == $idAditivoNuevo) {
				$g_BizSystem->GetClientProxy()->ShowErrorMessage($this->getMensaje(0));
				return;
			}
			
			//$sql = "[".$this->id_pd_aditivo."] = '".$dataRec->get($this->id_pd_aditivo)."' AND [".$this->id_relacion."] = '".$idAditivoNuevo."'";
              
			$dataObjComp = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjComp);
 
			///$arrFech = $dataObjComp->SetSearchRule($sql, true);
			//$arrFech = $dataObjComp->Fetch();
                 
			$arrCompViejo = $dataObjComp->FetchById($dataRec->get('Id'));			
                logErr($arrCompViejo,arrCompViejo,false);
			$dataRecCompViejo = new DataRecord($arrCompViejo, $dataObjComp);
 
			try {
				
                    $formula_anterior_id=$dataRecCompViejo[$this->id_relacion];
                       logErr($formula_anterior_id,formula_anterior_id,false);
					$dataRecCompViejo[$this->id_relacion] = $idAditivoNuevo;
                    logErr($dataRecCompViejo->get('Id'),capoviejo,false);
 
					$dataObjComp->SetActiveRecordId($dataRecCompViejo->get('Id'));
          
 
					$ok=$dataRecCompViejo->Save();   logErr($ok,ok,false);  
                    if($ok)
                    {
                        $data=array('fecha'=>$fechaCambio,'tabla'=>$this->dataObjComp,'formula_id'=>$dataRecCompViejo->get('Id'),
                        'formula_anterior_id'=>$formula_anterior_id,'no_cambio'=>$no_cambio);
                        $this->registrarSalva($data);   
                    }
                    
				//}
            } 
            catch (ValidationException $e) {
            	//logErr($e->m_Errors);
                $errElements = $this->GetErrorElements($e->m_Errors); 
                $this->ProcessFormObjError($errElements);
                return;
            }
            catch (BDOException $e) {
            	$this->ProcessBDOException($e);	
                return;
            }
		}
		
		if ($this->m_ParentFormName)
        {
            $this->Close();

            $this->RenderParent();
        }
		$this->ProcessPostAction();
		
		$g_BizSystem->GetClientProxy()->ShowErrorMessage($this->getMensaje(1));
	}
    
    public function registrarSalva($dataRec=array())
    {
        ///$dataObjLog=new BizDataObj();
        $dataObjLog=BizSystem::GetObjectFactory()->GetObject("epd.cambio_masivo.dataobj.d_ga_pd_cambio_masivo_log");
        $newRecord=$dataObjLog->NewRecord();
        foreach($dataRec as $key=>$val)
        {
            if(isset($newRecord[$key]))
            $newRecord[$key]=$val;
        }
              
        $dataObjLog->InsertRecord($newRecord);
        
    }
}