<?php 
require 'F_CambioMasivo.php'; 
include_once(MODULE_PATH.'/epd/cambio_masivo/message/ga_pd_cambio_masivo.msg'); 

class f_ga_pd_barniz_cm_list extends F_CambioMasivo
{
	public function __construct(&$XmlArr)
	{
		parent::__construct($XmlArr);
		
		$this->mensajes = array(
			'Ha selecionado el mismo barniz',
			'Se ha realizado el cambio de barniz'
		  );
		  
		$this->id_relacion   = 'barniz_id';
		$this->id_pd_aditivo = 'pd_barniz_id';
		$this->dataObjComp   = 'epd.pd_barniz.dataobj.d_ga_pd_barniz_comp';
	}
    
     public function RunSearch()
    {
        include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";$cadena=array();
        foreach ($this->m_SearchPanel as $elem)
        {

            if (!$elem->m_FieldName)
                continue;
            
             $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);  
             $cadena[$elem->m_FieldName]=$value;
             $activo=true;
             if($elem->m_Name=="qry_shell" && $value==-1)
                    $activo=false;
             
         

            if($elem->m_FuzzySearch=="Y" && $value!=''){
                $value="*$value*";
            }
            if (($value && $activo) || ($elem->m_Name=="qry_num_pd" && $value!="")) {

               $searchStr = InputValToRule($elem->m_FieldName, $value, $this); 
               
                if ($searchRule == "")
                   $searchRule .= $searchStr;
                else
                   $searchRule .= " AND " . $searchStr;
                   
            }
        }  
        $this->m_SearchRule = $searchRule; 
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;
           
        $this->m_CurrentPage = 1;
        $this->guardarCurrentPage();

        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);

        $this->RunEventLog();
        $this->ReRender();
    }
        
      public function GotoPage($page=1)
    {               
        $tgtPage = intval($page);
        if ($tgtPage == 0) $tgtPage = 1;
        $this->m_CurrentPage = $tgtPage;  
        $this->guardarCurrentPage(); 
        $this->CargarIds("f_ga_pd_barniz_cm_list"); 
        $this->ReRender();
         
    }
    
     public function Render()
    {                   
       $seccion=BizSystem::SessionContext(); 
       $seccion->ClearVar("f_ga_pd_barniz_cm_list");  
       return parent::Render();
    }
    
    public function CambioMasivo()
    {
        $sessCtxt=BizSystem::SessionContext();  
        $record="";

        $record=$sessCtxt->GetVar("f_ga_barniz_list_camb_por_RecordId");   
       
        if($record)
        {
            parent::CambioMasivo($record,"f_ga_pd_barniz_cm_list");
        }
        else
            $seleccionarBarnizMessage = $this->GetMessage("MSG_GA_PD_CAMBIO_MASIVO_SELECCIONAR_BARNIZ_DESTINO");
            BizSystem::ClientProxy()->ShowErrorMessage($seleccionarBarnizMessage);
    }
}