<?php 
 
include_once(MODULE_PATH.'/epd/cambio_masivo/message/ga_pd_cambio_masivo_log.msg');  
 
class f_ga_pd_cambio_masivo_log_barniz_list extends EasyForm
{
    public $dataObjComp   = 'epd.pd_barniz.dataobj.d_ga_pd_barniz_comp'; 
    public $id_relacion   = 'barniz_id'; 
	public function FetchDataSet_old()
    {
        $result=$this->cargarAgrupadas();

        $fecha=null;
        $no_cambio=null;
        $usuario=null;
        if(isset($result[0]) && isset($result[0]['fecha']))
        {
            $fecha=$result[0]['fecha']; 
            $usuario = $result[0]['usuario']; 
            $no_cambio = $result[0]['no_cambio']; 
            
        
        
        $this->SetFixSearchRule("[estado]=1 and [no_cambio]='".$no_cambio."' and [usuario]='".$usuario."'");
       return parent::FetchDataSet();
       }
       else
       return array();
    }
    
    public function cargarAgrupadas()
    {
        global $g_BizSystem;
        $dataObjAgrupados=$g_BizSystem->GetObjectFactory()->GetObject("epd.cambio_masivo.dataobj.d_ga_pd_cambio_masivo_log_agrupados");
        $dataObjAgrupados->ClearSearchRule();
        $dataObjAgrupados->SetSearchRule("[tabla]='".$this->dataObjComp."'");
        $result=$dataObjAgrupados->Fetch(); 
        
        return $result;
    }
    
    public function RestaurarMovimiento()
    {        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        
        if ($selIds == null)
            $selIds[] = $id;    
        foreach ($selIds as $id) {     //logErr($id,id,false);
           $this->GetDataObj()->ResetRules();
           $data= $this->GetDataObj()->DirectFetch("[Id]='".$id."'");
           if(isset($data[0]))
            $data=$data[0];
                          // logErr($data,data,false);
           if(is_array($data))
           {
           global $g_BizSystem; 
            $dataObj=$g_BizSystem->GetObjectFactory()->GetObject($data['tabla']);
            $dataOldTemp=$dataTemp=$dataObj->FetchById($data['formula_id']);
            $dataTemp[$this->id_relacion] = $data['formula_anterior_id'];  //logErr($dataTemp); 
            
            $ok=$dataObj->UpdateRecord($dataTemp,$dataOldTemp);
                           // logErr($ok,ok1,false);
            if($ok)
            {
                $ok=$this->GetDataObj()->DeleteRecord($data);   // logErr($ok,ok1,false);
            }
                
           }  
        }
           $correctRestoreMessage = $this->GetMessage("MSG_GA_PD_CAMBIO_MASIVO_LOG_RESTAURAR_CORRECTAMENTE");
           $g_BizSystem->ClientProxy()->ShowClientAlert($correctRestoreMessage);
           
           $this->ProcessPostAction();
        
    }
    
    public function RestaurarUltimoMovimiento1()
    {     return;          
        $result=$this->cargarAgrupadas();
                     
        if(isset($result[0]['no_cambio']) && count($result)>=1)
        {    $no_cambio=$result[0]['no_cambio']; 
        
           $data= $this->GetDataObj()->DirectFetch("[no_cambio]='".$no_cambio."'");
                           //logErr($data);
           if(is_array($data))
           foreach($data as $key=>$val)
           {
                global $g_BizSystem;
                $dataObj=$g_BizSystem->GetObjectFactory()->GetObject($val['tabla']);
                $dataOldTemp=$dataTemp=$dataObj->FetchById($val['formula_id']);
                $dataTemp[$this->id_relacion] = $val['formula_anterior_id'];  //logErr($dataTemp); 
                $ok=$dataObj->UpdateRecord($dataTemp,$dataOldTemp);
                                //logErr($ok);
                if($ok)
                {
                    $ok=$this->DeleteRecord($val['id']);    //logErr($ok);
                }
                
           }
           $lastChangeRestoreMessage = $this->GetMessage("MSG_GA_PD_CAMBIO_MASIVO_LOG_RESTAURAR_ULTIMO_CAMBIO");
           $g_BizSystem->ClientProxy()->ShowClientAlert($lastChangeRestoreMessage);
           
           $this->ProcessPostAction();
        }
    }
    
    public function RunSearch()
    {
       include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";$cadena=array();
        
        foreach ($this->m_SearchPanel as $k=>$elem) 
        {
            $check=true;
            if (!$elem->m_FieldName)
                continue;
            
            $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);
            $bizField = $this->GetDataObj()->GetField($elem->m_FieldName);     
             
             if($value)   
             $check=$bizField->CheckValueType($value);  
             
             if(!$check)
             {
                 // BizSystem::ClientProxy()->ShowClientAlert("Tipo de Dato incorrecto:".$elem->m_Label);
                 continue;
             }
             $cadena[$elem->m_FieldName]=$value;   
            
             if($elem->m_Name=="qry_fecha" && $value){
                   $fecha_desde=split("-",$value);       
                   if(count($fecha_desde))
                   $value=$fecha_desde[2]."-".$fecha_desde[1]."-".$fecha_desde[0] ;
                   $fecha_desde = "CONVERT(datetime, '".$value." 00 :00 :00"."', 102)";     
                   $fecha_hasta = "CONVERT(datetime, '".$value." 23 :59 :59.997"."', 102)";     
                   continue;  
             } 

           
        }
         if($fecha_desde && $fecha_hasta)
        {
          if($searchRule)
            $searchRule.=" AND [fecha] BETWEEN ".$fecha_desde." AND ".$fecha_hasta;
          else
            $searchRule.="[fecha] BETWEEN ".$fecha_desde." AND ".$fecha_hasta;  
        }        
        $this->m_SearchRule = $searchRule;
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;

        $this->m_CurrentPage = 1;
        $this->guardarCurrentPage();
        
        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);
        
        $this->RunEventLog();
        $this->ReRender();
    }
     
}