<?php 
 
include_once(MODULE_PATH.'/epd/cambio_masivo/message/ga_pd_cambio_masivo_log.msg'); 
 
class f_ga_pd_cambio_masivo_log_tinta_dl_list extends EasyForm
{
    public $dataObjComp   = 'epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl_comp'; 
    public $id_relacion   = 'tinta_id'; 
	public function FetchDataSet_old()
    {
        $result=$this->cargarAgrupadas();

        $fecha=null;
        $no_cambio=null;
        $usuario=null;
        if(isset($result[0]) && isset($result[0]['fecha']))
        {
            $fecha=$result[0]['fecha']; 
            $usuario = $result[0]['usuario']; 
            $no_cambio = $result[0]['no_cambio']; 
            
               
        $this->SetFixSearchRule("[estado]=1 and [no_cambio]='".$no_cambio."' and [usuario]='".$usuario."'");
        return parent::FetchDataSet();
        }else
        return array();
    }
    
    public function cargarAgrupadas()
    {
        global $g_BizSystem;
        $dataObjAgrupados=$g_BizSystem->GetObjectFactory()->GetObject("epd.cambio_masivo.dataobj.d_ga_pd_cambio_masivo_log_agrupados");
        $dataObjAgrupados->ClearSearchRule();
        $dataObjAgrupados->SetSearchRule("[tabla]='".$this->dataObjComp."'");
        $result=$dataObjAgrupados->Fetch(); 
        
        return $result;
    }
    
     public function RestaurarMovimiento()
    {        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        
        if ($selIds == null)
            $selIds[] = $id;    
        foreach ($selIds as $id) {     //logErr($id,id,false);
           $this->GetDataObj()->ResetRules();
           $data= $this->GetDataObj()->DirectFetch("[Id]='".$id."'");
           if(isset($data[0]))
            $data=$data[0];
                          // logErr($data,data,false);
           if(is_array($data))
           {
           global $g_BizSystem; 
            $dataObj=$g_BizSystem->GetObjectFactory()->GetObject($data['tabla']);
            $dataOldTemp=$dataTemp=$dataObj->FetchById($data['formula_id']);
            $dataTemp[$this->id_relacion] = $data['formula_anterior_id'];  //logErr($dataTemp); 
            //logErr($dataTemp,dataTemp,false); 
            //logErr($dataOldTemp,dataOldTemp,false); 
            $ok=$dataObj->UpdateRecord($dataTemp,$dataOldTemp);
                           // logErr($ok,ok1,false);
            if($ok)
            {
                $ok=$this->GetDataObj()->DeleteRecord($data);   // logErr($ok,ok1,false);
            }
                
           }  
        }
           $correctRestoreMessage = $this->GetMessage("MSG_GA_PD_CAMBIO_MASIVO_LOG_RESTAURAR_CORRECTAMENTE");
           $g_BizSystem->ClientProxy()->ShowClientAlert($correctRestoreMessage);
           
           $this->ProcessPostAction();
        
    }
    
    public function RestaurarUltimoMovimiento()
    {               
        $result=$this->cargarAgrupadas();
                 
        if(isset($result[0]['no_cambio']))
        {    $no_cambio=$result[0]['no_cambio']; 
        
       $data= $this->GetDataObj()->DirectFetch("[no_cambio]='".$no_cambio."'");
                       //logErr($data);
       if(is_array($data))
       foreach($data as $key=>$val)
       {
            global $g_BizSystem;
            $dataObj=$g_BizSystem->GetObjectFactory()->GetObject($val['tabla']);
            $dataOldTemp=$dataTemp=$dataObj->FetchById($val['formula_id']);
            $dataTemp[$this->id_relacion] = $val['formula_anterior_id'];  //logErr($dataTemp); 
            $ok=$dataObj->UpdateRecord($dataTemp,$dataOldTemp);
                            //logErr($ok);
            if($ok)
            {
                $this->DeleteRecord($val['Id']);  
                
            }
           
       }
       $lastChangeRestoreMessage = $this->GetMessage("MSG_GA_PD_CAMBIO_MASIVO_LOG_RESTAURAR_ULTIMO_CAMBIO");
       $g_BizSystem->ClientProxy()->ShowClientAlert($lastChangeRestoreMessage);
       
       $this->ProcessPostAction();
       }
    }
     
}