<?php 
require 'F_CambioMasivo.php';
include_once(MODULE_PATH.'/epd/cambio_masivo/message/ga_pd_tinta_dl_comp.msg');      

class f_ga_pd_tinta_lito_comp_cm_list extends F_CambioMasivo
{
	public function __construct(&$XmlArr)
	{
		parent::__construct($XmlArr);
		
		$this->mensajes = array(
			'Ha selecionado la misma tinta',
			'Se ha realizado el cambio de tinta'
		  );
		  
		$this->id_relacion   = 'tinta_id';
		$this->id_pd_aditivo = 'pd_tinta_lito_id';
		$this->dataObjComp   = 'epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito_comp';
	}
    
    public function GotoPage($page=1)
    {               
        $tgtPage = intval($page);
        if ($tgtPage == 0) $tgtPage = 1;
        $this->m_CurrentPage = $tgtPage;  
        $this->guardarCurrentPage(); 
        $this->CargarIds("f_ga_pd_tinta_comp_list_cm"); 
        $this->ReRender();
         
    }
    
     public function Render()
    {                   
       $seccion=BizSystem::SessionContext(); 
       $seccion->ClearVar("f_ga_pd_tinta_comp_list_cm");  
        return parent::Render();
    }
    
    public function CambioMasivo()
    {
        $sessCtxt1=BizSystem::SessionContext();  
        $record="";
        $record=$sessCtxt1->GetVar("f_ga_tintas_list_camb_por_RecordId");      
        if($record)
        {       
            parent::CambioMasivo($record,"f_ga_pd_tinta_comp_list_cm");
        }
        else
            $seleccionarTintaMessage = $this->getMensaje("MSG_GA_PD_TINTA_DL_COMP_SELECCIONAR_TINTA_DESTINO");
            BizSystem::ClientProxy()->ShowErrorMessage($seleccionarTintaMessage);
        
    }
}