<?php 

class d_ga_pdc_cambiado_update extends BizDataObj
{ 
   public function Fetch()
   {
      global $g_BizSystem;
      $resultRecords = parent::Fetch();
            $registro_id = -1;
       foreach ($resultRecords as $key => $value) {
            $raiz=substr($value['tabla'],3);
            if($raiz=="pd")
            {
            $cadenaObj="epd.cambios.dataobj.d_ga_pd_cambiado";
            }
            elseif(substr_count($value['tabla'],"_comp")>=1 )
            {
                $raiz=str_replace("_comp","",$raiz);
                $cadenaObj="epd.".$raiz.".dataobj.d_".$value['tabla'];
            }
            elseif(substr_count($value['tabla'],"pd_shell")>=1)
            {
                 $cadenaObj="epd.pd.dataobj.d_".$value['tabla'];
            }
             else 
            {
                $cadenaObj="epd.".$raiz.".dataobj.d_".$value['tabla'];
            }
            if($registro_id != $value['registro_id'])
            {
            if(!$cadenaObj) continue;
            $dataObjUpdate= $g_BizSystem->GetObjectFactory()->GetObject($cadenaObj);
            if(!$dataObjUpdate)  continue;

            $dataObjUpdate->ResetRules();
            $dataObjUpdate->SetSearchRule("[Id]='".$value['registro_id']."'");
            $recordSetUpdate=$dataObjUpdate->Fetch();
            $registro_id = $value['registro_id'];
            }
            
            
             $resultRecords[$key]['valor_actual']=$recordSetUpdate[0][$value['campo']];
            if(isset($recordSetUpdate[0]['barniz_color']))
                $resultRecords[$key]['dependencia']=$recordSetUpdate[0]['barniz_color'];
            elseif(isset($recordSetUpdate[0]['tinta_color']))
                $resultRecords[$key]['dependencia']=$recordSetUpdate[0]['tinta_color'];


         }
         
                      
        foreach ($resultRecords as $key => $value) 
        {

            $tabla=$this->Nombres($value['tabla']);
            $resultRecords[$key]['nombre_entidad1']=$tabla;
            
            if($value['accion']==1)continue;   
            
            $campo=$this->Nombres($value['tabla'], $value['campo']);
            $resultRecords[$key]['campo']=$campo;
            if(isset($value['dependencia']))
            $resultRecords[$key]['campo']=$campo." de (".$value['dependencia'].")";
           
        }   //logErr($resultRecords);          
         $band=false; $registro_id=0; $nuevo_registro=null;
         $resorset=array();
         
         
    // logErr($resultRecords,result,false);
      return $resultRecords;
   }
   
  
    protected function Nombres($nombreTabla,$NombreCampo=null)
    {
    if(!is_null($NombreCampo)){
        if($NombreCampo=='cantidad_m2_formula')
        {
            $NombreCampo="Aditivos (Fórmula)";
            
        }
        elseif($NombreCampo =='cantidad_aditivo')
        {
            $NombreCampo="Aditivos/1000 Tapas";  
        }
        elseif($NombreCampo=='cantidad_aditivo_m2')
        {
            $NombreCampo="Aditivos/m2";
            
        }
       
     $textoCom .= str_replace("_"," ",$NombreCampo) ;
    }
    $textoCom .=" ";
    if ($nombreTabla=="ga_pd"){
     $textoCom.="de la PD";
     $texto = "PD";
    }else if ($nombreTabla=="ga_pd_shell"){
     $textoCom.="";
     $texto = "Pasadas de la SHELL-PD";
    }else if ($nombreTabla=="ga_pd_barniz"){
     $textoCom.="de Barniz de la PD";
     $texto = "Barniz de la PD";
    }
    else if ($nombreTabla=="ga_pd_barniz_comp"){
       $textoCom.="de Barniz de la PD";
     $texto = "Formula de Barniz de la PD";
    }
    else if ($nombreTabla=="ga_pd_tinta_dl"){
       $textoCom.="de Tinta DL de la PD";
     $texto = "Tinta DL de la PD";
    }
    else if ($nombreTabla=="ga_pd_tinta_dl_comp"){
       $textoCom.="de Tinta DL de la PD";
     $texto = "Formula de Tinta DL de la PD";
    }
    else if ($nombreTabla=="ga_pd_tinta_lito"){
       $textoCom.="de Tinta Lito de la PD";
     $texto = "Tinta Lito de la PD";
    }
    else if ($nombreTabla=="ga_pd_tinta_lito_comp"){
        $textoCom.="de Tinta Lito de la PD";
     $texto = "Formula  Tinta Lito de la PD";
    }

    if(!is_null($NombreCampo))
    return $textoCom;
    return $texto;
    }
    
}