<?php 

require_once APP_HOME.'/bin/pdc/GaPDC.php';
class PDCEasyForm extends EasyForm 
{ 
      
        
        public function agruparPorRegistro($num_pd,$selIds=array())
        {
           global $g_BizSystem;
           $m_pdcCambiadoDataObj="epd.pdc.dataobj.d_ga_pdc_cambiado";
		   $dataObj= $g_BizSystem->GetObjectFactory()->GetObject($m_pdcCambiadoDataObj);
		   if(!$dataObj) return false;

            $dataObj->ResetRules();
            $dataObj->SetSearchRule("[pd_id]='".$num_pd."'");
            $dataObj->SetSearchRule("[accion]='1'");
            $recordSet=$dataObj->Fetch();


            $registros=array();
            foreach ($recordSet as $value) {
                    foreach ($selIds as $valId){
                        if($value['Id']==$valId)
                        {
                            $registros[$value['registro_id']]=1;
                        }
                    }
            }


            return $registros;
		
        }

	    public function AceptarTodoCambio($usuario_id)
	    {	      
            
            $num_pd= BizSystem::ClientProxy()->GetFormInputs('_selectedId');     
		    $pdc=new GaPDC();
                     
		    if($num_pd && $usuario_id)
		    {
			    $pdc->aceptarPDC($num_pd);   
			    $pdc->eliminandoRegistros($num_pd,null,null,2);   
                $this->ActualizarPD($num_pd);    
			    $this->ProcessPostAction();
		    }
	    }
	
	    public function CerrarCambios()
	    {	
	        $pdc=new GaPDC();
            global $g_BizSystem;
	        $profile = $g_BizSystem->GetUserProfile();
            $usuario_id=$profile['Id'];
            $num_pd = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
		    if($num_pd && $usuario_id)
		    {
			    $pdc->eliminandoRegistros($num_pd,null,null,3);
                $this->ActualizarPD($num_pd);
		    }
	        $this->ProcessPostAction();
	    }

        public function ActualizarPD($num_pd)
        {
            // get the source dataobj
		    global $g_BizSystem;
		    $dataObjName="epd.cambios.dataobj.d_ga_pd_cambiado";
		    $srcDataObj = $g_BizSystem->GetObjectFactory()->GetObject($dataObjName);
		    if (!$srcDataObj) return false;

		    $srcDataObj->ResetRules();
		    $srcDataObj->SetSearchRule("[Id]='".$num_pd."'");
		    $currentRec=$srcDataObj->Fetch();


		    $dataRec = new DataRecord($currentRec[0], $srcDataObj);
		    $dataRec['estado']='3';
		    logErr($currentRec, "dataRec", false);
		    try {
			    $dataRec->Save();
                            }
		    catch (ValidationException $e) {
				    $errElements = $this->GetErrorElements($e->m_Errors);
				    $this->ProcessFormObjError($errElements);
				    return;
			    }
			    catch (BDOException $e) {
				    $this->ProcessBDOException($e);
				    return;
			    }
			    
        
        }
        
	
}