 <?php  
   include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd_solicitud.msg');    
     
class d_ga_pd extends BizDataObj
{
    const
        CAMBIO_FECHA_PD  = CAMBIO_FECHA_PD,
        CAMBIO_ESTADO_PD  = CAMBIO_ESTADO_PD;

 
   
 public function UpdateRecord($recArr, $oldRec=null)
 {                
      global $g_BizSystem; 
             
       $system_configuration= $_SESSION['system_configuration'];
       $system_define=array();
       $work='';
       if(is_array($system_configuration))
       {     
           foreach($system_configuration as $key=>$val)
           {
               if($val['clave']=="PD_WORKFLOW")
               {
                   $work=$val['valor'];     break ;
               }
           }
       }     
       $tipo_muestra_fisica=null;

        global $g_BizSystem;
        $dataObjSolicitud = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_solicitud");
        $dataObjSolicitud->setSearchRule("[num_pd]='".$recArr['num_pd']."'");
        $dataRec=$dataObjSolicitud->fetch();
            
         if($recArr['estado']==11)
         {                  // logErr($recArr);
            $recArr['pdf_italia'] = 3;
            $result = parent::UpdateRecord($recArr, $oldRec);
            if($work=='_it')
            {
                if($recArr['solicitud_muestra_requerida']==1 && $recArr['tipo_muestra_fisica']>=1)
                {
                    $tipo_muestra_fisica=$recArr['tipo_muestra_fisica'];
                    $recArr['estado'] = 1;
                }
                elseif($recArr['solicitud_muestra_requerida']==0 || $recArr['solicitud_muestra_requerida']=='0')
                {
                    $recArr['estado'] = 3;
                }
                //$recArr['estado'] = 1;  
            }else
            {
                $recArr['estado'] = 1;
            }
               
         }
         elseif($recArr['estado']==7)
         {
             $recArr['pdf_italia'] = 2; 
         }
          elseif($recArr['estado']==4)
         {   
             if($dataRec['solicitud_pdf']==1)
                $recArr['pdf_italia'] = 1; 
             else
                $recArr['pdf_italia'] = 0; 
             
         } 
         elseif($recArr['estado']==10)
         {
             $recArr['pdf_italia'] = 1; 
             $result = parent::UpdateRecord($recArr, $oldRec);
             $recArr['estado'] = 1;  
         }
       
       $result = parent::UpdateRecord($recArr, $oldRec);

        if($result)
        {
   
			if(!isset ($dataRec[0]))
			  {
				logErr("No se encuentra la solicitud", "PD", false);
				return $result;
			}

			$oldRecSolicitud=$dataRec[0];

			if($dataRec[0]['estado']!=$recArr['estado'])
			{
				$dataRec[0]['estado']=$recArr['estado'];
                
                if($recArr['estado']==1 && $recArr['fecha_solicitud'])
                {
                    $dataRec[0]['fecha_solicitud']=$recArr['fecha_solicitud'];
                }
                if($tipo_muestra_fisica)
                {
                    $dataRec[0]['tipo_muestra_fisica']=$tipo_muestra_fisica;
                    $dataRec[0]['solicitud_muestra_requerida']=1;
                }
          
				$resultSolicitud=$dataObjSolicitud->UpdateRecord($dataRec[0],$oldRecSolicitud);

				if(!$resultSolicitud)
				{
					logErr("No se cambio el estado de lsolicitud", "Estado de la Solicitud", false);
					return $result;
				}
                //se carga la info del cliente
                $dataObjSolicitudC = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_solicitud.dataobj.d_ga_pd_solicitud_p");
                $dataRecC=$dataObjSolicitudC->FetchById($dataRec[0]['Id']);
                if(isset($dataRecC['cliente']))
                    $cliente=$dataRecC['cliente'];
                else 
                    $cliente="CLIENTE"; 
                
                //se carga el profile
                 $profile=$g_BizSystem->GetUserProfile();
                 
                 $estado=array(1=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_1'),2=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_2'),
                    3=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_3'),4=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_4'),5=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_5'),
                    6=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_6')
                        ,0=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_0'),7=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_7'), 
                            8=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_8'),10=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_10'),
                                11=>$this->GetMessage('MSG_GA_PD_GA_PD_estado_pd_11'));  
                $filtros=array('entidad'=>$this->m_MainTable,'campo'=>'estado','viejo_valor'=>$oldRecSolicitud['estado'],'nuevo_valor'=>$dataRec[0]['estado']);
                $valores=array(E_NUM_PD=>$recArr['num_pd'],E_ESTADO_ACTUAL=>$estado[$oldRecSolicitud['estado']],E_ESTADO_NUEVO=>$estado[$dataRec[0]['estado']],E_USUARIO=>$profile['name'],E_CLIENTE=>$cliente);

                $entidad_id=array('entidad_id'=>$dataRec[0]['Id']);
                
                register_shutdown_function(array(d_ga_pd,enviarEmail),$filtros,$dataRec,$valores,$this);
                
			}

        }
        return $result;
    }
    
    public function enviarEmail($filtros,$dataRec,$valores,$form)
    {
        
        //envio de email segun el cambio de estado.
                global $g_BizSystem;
                $dataObjEnvioEmail = $g_BizSystem->GetObjectFactory()->GetObject("erp.parametrizacion_interna.dataobj.d_ga_erp_plantilla_parametrizacion_envio_email");
                $params=$dataObjEnvioEmail->buscarParametrizacionEnvioEmail('CAMBIO_ESTADO_PD',null,true,$filtros,$dataRec[0]['Id'],$valores);
                 //TODO: Si no hay parametrizacion no hay que hacer nada...
                //if($params['Found']==1)
                  //{            
                    //logErr($params,"salida #1 de parametros de cambios estado sin HEX",false);      
                   if($form->cargarFormaEnvio()!="SMTP")  
                   {           
                    $params['subject']=$dataObjEnvioEmail->aplicarBinarioHex($params['subject']); 
                    $params['body']=$dataObjEnvioEmail->aplicarBinarioHex($params['body']);
                   }
                   else 
                   {           
                    $params['subject'] = utf8_encode($params['subject']); 
                    $params['body'] = utf8_encode($params['body']);
                   }
                   
                   
                   
                   
                   
                     foreach($params as $k=>$v)
                    {
                       $params[$k]=trim($v); 
                    } 
                   
                    
                    if($form->cargarFormaEnvio()!="SMTP")
                    {
                        $emailObj = $g_BizSystem->GetService(SEND_MAIL_SERVICE);
                        $emailObj->enviarEmailSql($params);   
                    }else{                       
                        $emailObj = $g_BizSystem->GetService(USER_EMAIL_SERVICE);
                        $emailObj->sendEmailNowSimple($params);   
                    }
                    
                  //}
    }
    
      public function cargarFormaEnvio()
    {
        $system_configuration= $_SESSION['system_configuration'];
           $system_define=array();
           $work='';
           if(is_array($system_configuration))
           {     
               foreach($system_configuration as $key=>$val)
               {
                   if($val['clave']=="EMAIL")
                   {
                       $work=$val['valor'];     break ;
                   }
               }
           }
             
           return $work;
    }
      

}