 <?php 

include_once(MODULE_PATH.'/epd/pd/message/ga_pd_shell.msg'); 
 
class d_ga_pd_shell extends BizDataObj
{
 

  public function InsertRecord($recArr)
  {
	global $g_BizSystem;
	$dataObjPD_Shell = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
	$dataObjPD_Shell->ResetRules();
	$dataObjPD_Shell->SetSearchRule("[pd_id]='".$recArr['pd_id']."'");
    $dataObjPD_Shell->SetSearchRule("[shell_id]='".$recArr['shell_id']."'");
	$dataObjPD_Shell->SetSearchRule("[maquina_id]='".$recArr['maquina_id']."'");
	$resultRecords = $dataObjPD_Shell->Fetch();  //logErr($resultRecords,resultRecords,false);          
	if(isset($resultRecords[0]))
	{
        $existeShellMaquinaMessage = $this->GetMessage("MSG_GA_PD_SHELL_YA_EXISTE_MAQUINA_SHELL");
        $g_BizSystem->GetClientProxy()->ShowErrorMessage($existeShellMaquinaMessage);
		return;
	}

	$result = parent::InsertRecord($recArr); 

    if($result)
    {
    $nuevopdshell=$this->m_BizRecord->get('Id')->GetValue();  
    return $nuevopdshell;
    }     
    return null;
  }
  
  public function UpdateRecord($recArr,$oldRec=null)
  {
      
    if($oldRec!=null && $recArr['maquina_id'] != $oldRec['maquina_id'])
    {  
    global $g_BizSystem;
    $dataObjPD_Shell = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
    $dataObjPD_Shell->ResetRules();
    $dataObjPD_Shell->SetSearchRule("[pd_id]='".$recArr['pd_id']."'");
    $dataObjPD_Shell->SetSearchRule("[shell_id]='".$recArr['shell_id']."'");
    $dataObjPD_Shell->SetSearchRule("[maquina_id]='".$recArr['maquina_id']."'");
    $resultRecords = $dataObjPD_Shell->Fetch();  //logErr($resultRecords,resultRecords,false);          
       
       if(isset($resultRecords[0]))
        {
            $existeShellMaquinaMessage = $this->GetMessage("MSG_GA_PD_SHELL_YA_EXISTE_MAQUINA_SHELL");
            $g_BizSystem->GetClientProxy()->ShowErrorMessage($existeShellMaquinaMessage);
            return null;
        }
    }

    $result = parent::UpdateRecord($recArr,$oldRec); 
    
    return $result;
  }
  

  

}