<?php 
require_once APP_HOME.'/bin/guala/gualaPDF.php';

class AprobacionPD extends gualaPDF
{
    private $xImg  = 90;
    private $yImg  = 50;
	private $alto  = 100;
	private $ancho = 190;
	
	public function __construct($pd)
	{
		parent::__construct('', false);
		
		$this->pd = $pd;
		
		$this->setPageFormat('A4');
		
		$this->setPageOrientation('LANDSCAPE');
		
		$this->crear();
	}
    
	public function Footer(){}
	
	private function crear()
	{	$fileTemplate="../modules/epd/pd/form/aprobacionImg.jpg";
		$sizeTemplate=getimagesize($fileTemplate);
		//logErr($sizeTemplate);
		$anchoPlantillaNuevo = intval($sizeTemplate[0] * 205 / $sizeTemplate[1]);
		
		$this->Image($fileTemplate, 3, 1, $anchoPlantillaNuevo, 188);
		
		$imagPD = "../files/sec_upload/pd_imagen/".trim($this->pd['fld_Id']['data']).".jpg";
		if(file_exists($imagPD)){
		$size   = getimagesize($imagPD);
		$width  = $size[0];
		$height = $size[1];
		
		//BizSystem::log(LOG_ERR, 'size', var_export($size, true));
		
		$nuevoAncho = 0;
		$nuevoAlto  = 0;
		
		if ($width < $this->ancho && $height < $this->alto) {//No transformo la imagen		
			$nuevoAncho = $width;
			$nuevoAlto  = $height;
		} else {
			$proporsion = $width / $height;
		
			$nuevoAlto = $this->alto;
			$nuevoAncho = $proporsion * $nuevoAlto;

			if ($nuevoAncho > $this->ancho) {
			
				$nuevoAncho = $this->ancho;
				
				$nuevoAlto = $nuevoAncho / $proporsion;
			}
		}

		
		$this->Image($imagPD,  $this->xImg, $this->yImg, $nuevoAncho, $nuevoAlto);
		
		}
		$this->SetTextColor(0);
		$this->ScaleXY(85, 0, 0);

	    $this->Text(135, 16, $this->pd['fld_Cliente']['data']);
		$this->ScaleXY(95, 0, 0);
	    $this->Text(130, 25, $this->pd['fld_fecha_solicitud']['data']);
	    $this->Text(205, 25, $this->pd['fld_shell']['data']);
	    $this->Text(140, 32, $this->pd['fld_num_pd']['data']);
	}
}