<?php 
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');
 
class f_ga_pd_list extends EasyForm
{
    protected function ReadMetadata(&$xmlArr)
   {
      parent::ReadMetaData($xmlArr);
                    
      $nameCookie=$this->m_Name.'m_CurrentPage';  
      $nameCookie=str_replace(".","_",$nameCookie);   
      if (isset($_COOKIE[$nameCookie])){// && $this->m_CurrentPage!==0)
        $CurrentPage = str_replace( "'"," ",$_COOKIE[$nameCookie]);
        $this->m_CurrentPage =$CurrentPage * 1;
      }
      else
        $this->m_CurrentPage = 1;
     
        
    }
    
    public function RunSearch()
	{
        include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";$cadena=array();
        foreach ($this->m_SearchPanel as $elem)
        {
            $check=true;  
            if (!$elem->m_FieldName)
                continue;
			
             $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);  
             $bizField = $this->GetDataObj()->GetField($elem->m_FieldName);     
                  
             if($value)
             $check=$bizField->CheckValueType($value); 

             if(($elem->m_FieldName=='num_pd' || $elem->m_FieldName=='Id') && $value)
             {
                 $check = is_numeric($value);
             }
             if(!$check)
             {    
                 $incorrectDataTipe = $this->GetMessage("MSG_GA_PD_TIPO_INCORRECTO_DATO", array($elem->m_Label));
                 BizSystem::ClientProxy()->ShowClientAlert($incorrectDataTipe);
                 continue;
             }
             $cadena[$elem->m_FieldName]=$value;
             $activo=true;
             if($elem->m_Name=="qry_shell" && $value==-1)
                    $activo=false;
             
             if($elem->m_Name=="qry_estado" && $value==-1)
                    $activo=false;

            if($elem->m_FuzzySearch=="Y" && $value!=''){
            	$value="*$value*";
            }
            if (($value && $activo) || ($elem->m_Name=="qry_num_pd" && $value!="")) {

               $searchStr = InputValToRule($elem->m_FieldName, $value, $this); 
               
                if ($searchRule == "")
                   $searchRule .= $searchStr;
                else
                   $searchRule .= " AND " . $searchStr;
				   
            }
        }  
        $this->m_SearchRule = $searchRule;
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;
           
        $this->m_CurrentPage = 1;
        $this->guardarCurrentPage();

        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);

        $this->RunEventLog();
        $this->ReRender();
	}
    
        public function GotoPage($page=1)
    {    
        $tgtPage = intval($page);
        if ($tgtPage == 0) $tgtPage = 1;
        $this->m_CurrentPage = $tgtPage;  
        $this->guardarCurrentPage();
        $this->ReRender();
    }

       
}