<?php 

class f_ga_pd_list_articulo_picker extends PickerForm
{

    public function PickToParent($recId=null)
    {
        global $g_BizSystem;
        $sessionC=$g_BizSystem->GetSessionContext();
        $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');

        $sessionC->SetVar('articulo:pd_id',$id);
       $rec = $this->GetActiveRecord($recId);
        
        
        if (!$this->m_ParentFormElemName)
        {
            $this->AddToParent($recId);
        }
        
        
        if ($this->m_ParentFormElemName && $this->m_PickerMap)
        {    
            $this->JoinToParent($recId);
        };
        
    }
    
    
    public function JoinToParent($recId=null)
    {
        $rec = $this->GetActiveRecord($recId);
        
        $prtForm = BizSystem::ObjectFactory()->GetObject($this->m_ParentFormName);
        $updArray = array();
            
        // get the picker map of the control
        if ($this->m_PickerMap) {     
            $pickerList = $this->parsePickerMap($this->m_PickerMap);      
            foreach ($pickerList as $ctrlPair) {    
                $this_ctrl = $this->GetElement($ctrlPair[1]);  
                if($this_ctrl)  
                    $this_ctrl_val = $this_ctrl->GetValue(); 
                if (!$this_ctrl) 
                {
                    $this_ctrl_val=$this->GetDataElement($ctrlPair[1]);  
                    $this_ctrl=true;
                }   
                if (!$this_ctrl)
                    continue;
                
                $other_ctrl = $prtForm->GetElement($ctrlPair[0]);//logErr($other_ctrl,crt,false);
                if ($other_ctrl)
                $updArray[$other_ctrl->m_Name] = $this_ctrl_val;
            }
        }
        else
            return;
               
        $this->Close();
        if(isset($updArray['fld_ID_Cliente1']))
        {
            BizSystem::SessionContext()->SetVar('articulo_fld_ID_Cliente1',$updArray['fld_ID_Cliente1']);
           // logErr(BizSystem::SessionContext()->GetVar('articulo_fld_ID_Cliente1')); 
        }
        BizSystem::ClientProxy()->UpdateFormElements($prtForm->m_Name, $updArray);
                      
        // rerender the parent form
        //$this->UpdateForm()
        //$prtForm->UpdateForm($updArray); 
    }
    
    private function parsePickerMap($pickerMap)
   {
      $returnList = array();
      $pickerList = explode(",", $pickerMap);
      foreach ($pickerList as $pair)
      {
         $ctrlMap = explode(":", $pair);
         $ctrlMap[0] = trim($ctrlMap[0]);
         $ctrlMap[1] = trim($ctrlMap[1]);
         $returnList[] = $ctrlMap;
      }
      return $returnList;
   }
	

	
}
