<?php 
class f_ga_pd_barniz_list extends EasyForm 
{ 
       
    public function GetSessionVars($sessCtxt)  
    {   
		$sessCtxt->GetObjVar($this->m_Name, "CurrentPage", $this->m_CurrentPage);
        parent::GetSessionVars($sessCtxt); 
    }
    
    public function SetSessionVars($sessCtxt) 
    {   
        $this->m_Name = "epd.pd_barniz.form.f_ga_pd_barniz_list";
        $sessCtxt->SetObjVar($this->m_Name, "CurrentPage", $this->m_CurrentPage); 
        parent::SetSessionVars($sessCtxt);         
        
    }
    public function SelectRecord($recId)
    {
        if ($recId==null || $recId=='')
            $recId = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
             
        $this->m_RecordId = $recId;     
        $this->GetDataObj()->SetActiveRecordId($this->m_RecordId);
        $this->ReRender(false); 
        
    }
    public function ReRender($redrawForm=true, $hasRecordChange=true)
    {            
        if ($redrawForm) {
            BizSystem::ClientProxy()->ReDrawForm($this->m_Name,$this->RenderHTML());
        }
        
        if ($hasRecordChange) {
            $this->ReRenderSubForms();
        }
    }
    

    protected function ReRenderSubForms ()
    {   
        if (! $this->m_SubForms)
            return;
        foreach ($this->m_SubForms as $subForm) 
        {
            $formObj = BizSystem::ObjectFactory()->GetObject($subForm);
            $dataObj = $this->GetDataObj()->GetRefObject($formObj->m_DataObjName);
            if ($dataObj)
                $formObj->SetDataObj($dataObj);
            $formObj->ReRender();
        }
        return;
    }  
 

    public function Close()
    {
        BizSystem::ClientProxy()->ClosePopup();
    }
   
     public function FetchDataSet()
    {
        $result=parent::FetchDataSet(); 
        
        $dataObj = BizSystem::GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
        if (!$dataObj) return false;
        
        foreach($result as $key=>$value)
        {           
            $dataObj->ResetRules();
            $SearchRule="[pd_barniz_id]='".$value['Id']."'";
            $records=array();
            $dataObj->FetchRecords($SearchRule,$records,-1,0,true,true);
            
            $formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_barniz.form.f_ga_pd_barniz_comp_list"); 
            $dataPanel = $formObj->m_DataPanel->RenderTable($records);  
            $actionPanel = $formObj->m_ActionPanel->Render(); 
            $navPanel= $formObj->m_NavPanel->Render(); 
            
            $result[$key]['subform']['dataPanel']=$dataPanel;
            $result[$key]['subform']['actionPanel']=$actionPanel;
            $result[$key]['subform']['navPanel']=$navPanel;
            $result[$key]['subform']['name']="epd.pd_barniz.form.f_ga_pd_barniz_comp_list";
            $result[$key]['subform']['newobj']="\n<script> NewObject('" . $formObj->m_Name."','" . $formObj->m_jsClass . "'); </script>\n";;
            $result[$key]['newobj']="\n<script> NewObject('" . $formObj->m_Name. "','" . $formObj->m_jsClass . "'); </script>\n";;
            
            unset($formObj);
        }  
        
      
       return $result;
    }
}

?>