<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');

class f_ga_pd_barniz_pdc_list extends EasyForm 
{ 
    public function FetchDataSet()
    {
        $this->pdc=new GaPDC();   
	    $result=parent::FetchDataSet();
        $name="epd.pd_barniz.dataobj.d_ga_pd_barniz";   
        
        if(!isset($result[0])) return $result;
        
        $result=$this->pdc->cargarDataObjUpdate($name,$result,$result[0]['pd_id']);
        $pd_id=$result[0]['pd_id']; 
        if($pd_id) $_SESSION['num_pd_barniz']=$pd_id; 
        
        $dataObj = BizSystem::GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
        if (!$dataObj) return false;
             //logErr($result);
        foreach($result as $key=>$value)
        {
            $dataObj->ResetRules();
            $SearchRule="[pd_barniz_id]='".$value['Id']."'";
            $records=array();
            $dataObj->FetchRecords($SearchRule,$records,-1,0,true,true);
            
            //trato especial
            $name="epd.pd_barniz.dataobj.d_ga_pd_barniz_comp";
            $records=$this->pdc->cargarDataObjUpdate($name,$records,$pd_id); 
            $temp=array();
                foreach($records as $item)
                {                      
                    if($value['Id']==$item['pd_barniz_id'])
                        $temp[]=$item;
                } 
             $records=$temp;  
            
            $formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_barniz.form.f_ga_pd_barniz_comp_pdc_list"); 
            $dataPanel = $formObj->m_DataPanel->RenderTable($records);  
            $actionPanel = $formObj->m_ActionPanel->Render(); 
            $navPanel= $formObj->m_NavPanel->Render(); 
            
            $result[$key]['subform']['dataPanel']=$dataPanel;
            $result[$key]['subform']['actionPanel']=$actionPanel;
            $result[$key]['subform']['navPanel']=$navPanel;
            $result[$key]['subform']['name']="epd.pd_barniz.form.f_ga_pd_barniz_comp_pdc_list";
            $result[$key]['subform']['newobj']="\n<script> NewObject('" . $formObj->m_Name."','" . $formObj->m_jsClass . "'); </script>\n";;
            $result[$key]['newobj']="\n<script> NewObject('" . $formObj->m_Name. "','" . $formObj->m_jsClass . "'); </script>\n";;
            
            unset($formObj);
        }
      
        return $result;
    }

    public function DeleteRecord($id=null)
	{ 	$this->pdc=new GaPDC();
		global $g_BizSystem;

	    if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".delete"))
            return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
        
        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;
        foreach ($selIds as $id) {
            $recArray = $this->GetDataObj()->FetchById($id);

			$comprobacion=$this->pdc->comprobarPDC($recArray['pd_id']);
			if(!$comprobacion){
			    $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
			return;
			}
			
			$name="epd.pd_barniz.dataobj.d_ga_pd_barniz";
			
			if(is_null($recArray))
			{
			$recArray['Id']=$id;
			//logErr($recArray, 'recArrayNULL', false);
			$this->pdc->registrarCambioDelete($name,$recArray);
			}
			else{
			//logErr($recArray, 'recArrayNONULL', false);
			$this->pdc->registrarCambioDelete($name,$recArray,$recArray['pd_id']);
			}
            
        }
        if ($this->m_FormType == "LIST")
            $this->ReRender();
      
        $this->RunEventLog();
        $this->ProcessPostAction();
	}
}

?>