<?php 
class f_ga_pd_color_list_articulo extends EasyForm 
{ 

    public function GetSessionVars($sessCtxt)  
    {   
		$sessCtxt->GetObjVar($this->m_Name, "CurrentPage", $this->m_CurrentPage);
        parent::GetSessionVars($sessCtxt); 
    }
    public function SetSessionVars($sessCtxt) 
    {   
        $this->m_Name = "epd.pd_barniz.form.f_ga_pd_barniz_list";
        $sessCtxt->SetObjVar($this->m_Name, "CurrentPage", $this->m_CurrentPage); 
        parent::SetSessionVars($sessCtxt);         
        
    }
    

   
    public function FetchDataSet()
    {
        $i=1;
        $result=parent::FetchDataSet(); //logErr($result);   
        $AssociationB=$this->GetDataObj()->GetAssociation();    
        $FieldRefVal=$AssociationB['FieldRefVal'];

        $dataObj = BizSystem::GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz_comp");
        if (!$dataObj) return false;
        
        foreach($result as $key=>$value)
        {           
            $dataObj->ResetRules();
            $SearchRule="[pd_barniz_id]='".$value['Id']."'";
            $records=array();
            $dataObj->FetchRecords($SearchRule,$records,-1,0,true,true);
            
            $formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_barniz.form.f_ga_pd_barniz_comp_list_articulo"); 
            $dataPanel = $formObj->m_DataPanel->RenderTable($records);  
            $actionPanel = $formObj->m_ActionPanel->Render(); 
            $navPanel= $formObj->m_NavPanel->Render(); 
            
            $result[$key]['subform']['dataPanel']=$dataPanel;
            $result[$key]['subform']['actionPanel']=$actionPanel;
            $result[$key]['subform']['navPanel']=$navPanel;
            $result[$key]['subform']['name']="epd.pd_barniz.form.f_ga_pd_barniz_comp_list";
            $result[$key]['subform']['newobj']="\n<script> NewObject('" . $formObj->m_Name."','" . $formObj->m_jsClass . "'); </script>\n";;
            $result[$key]['newobj']="\n<script> NewObject('" . $formObj->m_Name. "','" . $formObj->m_jsClass . "'); </script>\n";;
            $result[$key]['tipo']=1;
            
            
            unset($formObj);
        }  
             
  
        
         //aqui esta la adicion de las Lito
       $formObjLito = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_list");
       $AssociationL=$formObjLito->GetDataObj()->GetAssociation(); 
       if($FieldRefVal>0)
       $AssociationL=$AssociationB;    
       $AssociationL['Table']='ga_pd_tinta_lito';    
       $AssociationL['FieldRefVal']=$FieldRefVal; //logErr($AssociationL);   
       $formObjLito->GetDataObj()->SetCustomAssociation($AssociationL);

       $resultLito=$formObjLito->FetchDataSet();   
        $dataObj = BizSystem::GetObjectFactory()->GetObject("epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito_comp");
        if (!$dataObj) return false;
        
        foreach($resultLito as $key=>$value)
        {           
            if($value['maquina_litografica_tipo']==2)
            {
                $resultLito[$key]['cuerpo']=$value['maquina_litografica_tipo'];                    
                $resultLito[$key]['cuerpo_bandera']=-1;                    
            }else{
                $resultLito[$key]['cuerpo_bandera']=0;
                $resultLito[$key]['cuerpo']==0;
            }
            $dataObj->ResetRules();
            $SearchRule="[pd_tinta_lito_id]='".$value['Id']."'";
            $records=array();
            $dataObj->FetchRecords($SearchRule,$records,-1,0,true,true); //logErr($records,record,false);   
            
            $formObjLito = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_comp_list_articulo"); 
            $dataPanel = $formObjLito->m_DataPanel->RenderTable($records);  
            $actionPanel = $formObjLito->m_ActionPanel->Render(); 
            $navPanel= $formObjLito->m_NavPanel->Render(); 
            
            $resultLito[$key]['subform']['dataPanel']=$dataPanel;
            $resultLito[$key]['subform']['actionPanel']=$actionPanel;
            $resultLito[$key]['subform']['navPanel']=$navPanel;
            $resultLito[$key]['subform']['name']="epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_comp_list";
            $resultLito[$key]['subform']['newobj']="\n<script> NewObject('" . $formObjLito->m_Name. "','" . $formObjLito->m_jsClass . "'); </script>\n";;
            $resultLito[$key]['newobj']="\n<script> NewObject('" . $formObjLito->m_Name. "','" . $formObjLito->m_jsClass . "'); </script>\n";;
            $resultLito[$key]['tipo']=3;
            
            
            unset($formObjLito);
        } 
        foreach($resultLito as $values)
        $result[]=$values;
        
       return $this->ordenar($result);
    }
 
    
    public function ordenar($result,$campo='no_order')
    {
        if(!is_array($result)) return null;
        $cant=count($result);
        if($cant==0) return $result;   
        if($cant==1)
        {
            $result[0]['lugar']=1;
            $result[0]['ultimo']=1;
            return $result;   
        }
        $cont=1;
        for($i=0;$i<$cant-1;$i++)
        {
            for($j=$i;$j<$cant;$j++)
            {
                $temp=array();
                if($result[$i][$campo]>$result[$j][$campo])
                {
                    $temp=$result[$i];
                    $result[$i]=$result[$j];
                    $result[$j]=$temp;
                }
            }
            $result[$i]['lugar']=$cont++; 
            $result[$i]['ultimo']=0; 
        }
        $result[$cant-1]['lugar']=$cont;
        $result[$cant-1]['ultimo']=1;
        return $result;
    }
}

?>