 <?php 

class d_ga_pd_log extends BizDataObj
{
    
   public function ValidateInput()
   {
      $this->m_ErrorFields = array();
      foreach($this->m_BizRecord->m_InputFields as $fld) 
      {
         $bizFld = $this->m_BizRecord->get($fld);                     
         if ($bizFld->CheckRequired() === true &&
             ($bizFld->m_Value===null || $bizFld->m_Value === "")) {
            $this->m_ErrorMessage = $this->GetMessage("DATA_FIELD_REQUIRED",array($fld));
            $this->m_ErrorFields[$bizFld->m_Name] = $this->m_ErrorMessage;            
         } 
        else if ($bizFld->m_Value!==null && $bizFld->CheckValueType() === false && $bizFld->m_Type!='Text') {
            $this->m_ErrorMessage = $this->GetMessage("DATA_FIELD_INCORRECT_TYPE",array($fld, $bizFld->m_Type));
            $this->m_ErrorFields[$bizFld->m_Name] = $this->m_ErrorMessage;            
         }                  
         else if ($bizFld->m_Value!==null && $bizFld->Validate() === false) {
            GLOBAL $g_BizSystem;            
            $srvcObj = $g_BizSystem->GetService(VALIDATE_SERVICE);
            $this->m_ErrorMessage = $srvcObj->GetErrorMessage($bizFld->m_Validator, $bizFld->m_Name);
            if ($this->m_ErrorMessage == false) { //Couldn't get a clear error message so let's try this
               $this->m_ErrorMessage = $this->GetMessage("DATA_FIELD_INVALID_INPUT",array($fld,$value,$bizFld->m_Validator));                //
            }
            $this->m_ErrorFields[$bizFld->m_Name] = $this->m_ErrorMessage;
         }         
      }    
      
     // logErr($this->m_ErrorFields,m_ErrorFields,false);  
      if (count($this->m_ErrorFields)>0)
      {
        throw new ValidationException($this->m_ErrorFields);
        return false;
      }
                                    
      
      return true;
   }
 
  
}