 <?php 

 include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd.msg');
 include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd_solicitud.msg');
class d_ga_pd_solicitud_g extends BizDataObj
{
    
    private $dataObjName=null;


  public function UpdateRecord($recArr, $oldRec=null)
  {   
        $result = parent::UpdateRecord($recArr, $oldRec);
        
        if($result && $recArr!=$oldRec )
        {
         $this->NotificarCambio();
        }
        
        return $result;
  }

  public function InsertRecord($recArr)
  { 
    global $g_BizSystem;                   
    $result=parent::InsertRecord($recArr);   
    $solicitud_pd_id = $this->m_BizRecord->get('Id')->GetValue();    

   if($solicitud_pd_id)
   {
        //envio de email segun el cambio de estado.
        $emailObj = $g_BizSystem->GetService(SEND_MAIL_SERVICE);  
        $gestores_PD=$this->buscarGestorPD();     
        $emailObj->generarEmailCambioEstadoPD($this->m_MainTable,'estado',0,1,$solicitud_pd_id,array($solicitud_pd_id),$gestores_PD);
        
        $profile = $g_BizSystem->GetUserProfile(); 
        $role_id=$gestores_PD['role_id'];
        
        $datos=array('titulo'=>'Creacion de nueva Solicitud de PD Generica ('.$solicitud_pd_id.')',
            'fecha_inicio'=>date('d-m-Y'),
                'prioridad'=>2,
                    'estado'=>1,
                        'modulo_id'=>2,
                            'descripcion'=>"Se creo la solicitud ".$solicitud_pd_id,
                                'tipo_task'=>3,
                                    'notificacion_email'=>1,
                                        'asignada_usuario_id'=>$gestor,
                                       // 'asignada_rol_id'=>9,
                                            'registro_id'=>$solicitud_pd_id,
                                                'link'=>"controller.php?view=epd.pd_solicitud.view.ga_pd_solicitud_generica_detail&fld:Id=".$solicitud_pd_id,
                                                    'entidad'=>$this->m_MainTable,
                                                        'creada_por_id'=>$profile['Id']);      
       
        foreach($gestores_PD as $key=>$gestor)
        {
            $teaskService = $g_BizSystem->GetService(TASKS_SERVICE); 
            if(isset($gestor['Id']))
            {
                $datos['asignada_usuario_id']=$gestor['user_id']; 
                $teaskService->insertTask($datos);
            }
        } 
        
    }   

    return $result;
  }
  
  public function buscarGestorPD()
  {
      global $g_BizSystem;
        //busco si existe barniz Acabado
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("system.user.dataobj.d_user_role_gestor_pd");
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        $dataObj->setSearchRule("[role_name] like '%gestor%'");
        $dataObj->setSearchRule("[role_name] like '%PDs%'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;
  }
  
   function NotificarCambio($params=array())
    {
        global $g_BizSystem;
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("erp.parametrizacion_interna.dataobj.d_ga_erp_tipo_parametrizacion_interna");
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[tipo_parametrizacion_interno]='CAMBIO_DATO_SOLICITUD'");
        $params = $dataObj->fetch();  
        if(!isset($params[0]))return;
        
        $params = $params[0];
        
           
        if($params['subject']=='' || is_null($params['subject']))
            $params['subject'] = "Mensaje de GualaERP";
        
        if($params['body']=='' || is_null($params['body']))
            $params['body'] = "Mensaje de GualaERP";

       
        //validacion de direcciones de email.
        $validObj = $g_BizSystem->GetService(VALIDATE_SERVICE);
        $emails=explode(";", $params['para']);
                      
        if(($params['para']=='' || is_null($params['para'])) && ($params['cc']=='' || is_null($params['cc']))&& ($params['bcc']=='' || is_null($params['bcc'])))
            return;
                     
        foreach ($emails as $value) {
            $errorMessage=$validObj->email($value);

            if ($errorMessage == false) { //Couldn't get a clear error message so let's try this
                return;
            }

        }        
        //envio del email
        $emailObj = $g_BizSystem->GetService(SEND_MAIL_SERVICE);
        $emailObj->enviarEmailNotificacion($params);
       // logErr("texto",k,false);
    }
  
 
  
}