<?php 

include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');  

class DlEasyForm extends EasyFormDinamic 
{ 
   
   
   public function SaveRecord()
   {	    
	    global $g_BizSystem;
		$recArr = $this->ReadInputRecord();

         $this->SetActiveRecord($recArr);
            if (count($recArr) == 0)
                return;
     
          try {
                $this->ValidateForm();
            }
            catch (ValidationException $e) {
                $this->ProcessFormObjError($e->m_Errors);
                return;
            }
            
		//busca si existe en el compuesto esa tinta
		$dataObjComp = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl_comp");
		if(!$dataObjComp) return false;
		$dataObjComp->ResetRules();
        if(!is_null($recArr['pd_tinta_dl_id']) && $recArr['pd_tinta_dl_id']!="")
                $SetSearchRule="[pd_tinta_dl_id]='".$recArr['pd_tinta_dl_id']."'"; 
            else
                $SetSearchRule="[pd_tinta_dl_id]='".$this->m_dependenciaId."'";                
        $dataObjComp->FetchRecords($SetSearchRule,$recordList,-1,0,true,true);
            
		
		$i=0;
		//formatear este numero
		$datoPorciento=0;
		foreach($recordList as $key=>$val){
			if($val['tinta_id']==$recArr['tinta_id']){
			$recordSet[$i++]=$val;
			}
			//$datoPorciento=$datoPorciento+$val['porciento'];
		}
				
		if($this->m_FormType == "NEW"){		  
			//$ban=($datoPorciento+$recArr['porciento'])>100;

			if(isset($recordSet[0])){
                $existeTintaMessage = $this->GetMessage("MSG_GA_PD_EXISTE_TINTA_COMPUESTO", array($recArr['tinta_color']));
                BizSystem::ClientProxy()->ShowErrorMessage($existeTintaMessage);
			return;
			}
		}	
	/*	elseif($this->m_FormType == "EDIT"){   
			$dataObjComp->ResetRules();
			$searchRuleComp="[Id]=".$recArr['Id'];
			$recordListComp = array();
			$dataObjComp->FetchRecords($searchRuleComp,$recordListComp,-1,0,true,true); 
			$datoPorcientoComp=$dataObjComp->m_BizRecord->get('porciento')->GetValue();
				
			$ban=($datoPorciento-$datoPorcientoComp+$recArr['porciento'])>100.00;
		}  
		
		if($ban){
		     $porcientoExcedeMessage = $this->GetMessage("MSG_GA_PD_BARNIZ_PORCIENTO_EXCEDE");
             BizSystem::ClientProxy()->ShowErrorMessage($porcientoExcedeMessage);
		 return;
		}
		  */
         parent::SaveRecord();

   }
   /*
   function cargarTablaGramos($recordList)
   {    
        global $g_BizSystem;  
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("erp.barniz_interior.dataobj.d_ga_erp_barniz_interior");
        if (!$dataObj) return false;
        $dataObj->ResetRules();
        $dataObj->setSearchRule("[barniz_enganche_id] LIKE '%1020006%'");
        $dataRec=$dataObj->fetch();
   }
     */

    public function FetchData()   
     {
     if($this->m_Errors)
        {
            return $this->GetActiveRecord();
            
        }
         $result=array();
         if($this->m_FormType == "NEW"){
            $result=parent::FetchData();
         }elseif($this->m_FormType == "EDIT"){
                       
         if ($this->m_FixSearchRule) {
            if ($this->m_SearchRule)
                $searchRule = $this->m_SearchRule . " AND " . $this->m_FixSearchRule;
            else
                $searchRule = $this->m_FixSearchRule;
        }
        
            $this->GetDataObj()->SetSearchRule($searchRule);
            QueryStringParam::SetBindValues($this->m_SearchRuleBindValues);

             $this->GetDataObj()->FetchRecords($serachRule,$result,-1,0,false,true);    
             
             $this->m_RecordId = $result[0]['Id'];
             $this->SetActiveRecord($result[0]);

             QueryStringParam::ReSet();   
         }
  
         $result=$result[0];
         if(!isset($result['pd_tinta_dl_id']) || !isset($result['Id'])){
         
             $getKeys = array_keys($_REQUEST);
             $param_flds = null;
             foreach ($getKeys as $key) {
                if (substr($key, 0, 4) == "fld:") {
                    $fldName = substr($key, 4);
                    $fldValue = $_REQUEST[$key];
                    $param_flds[$fldName] = $fldValue;
                }
                }
                
             if(count($param_flds)>=1){
               $result['pd_tinta_dl_id']=$param_flds['pd_tinta_dl_id'];
               $this->m_dependenciaId=$param_flds['pd_tinta_dl_id'];
             }else{
                $result['pd_tinta_dl_id']=$this->m_dependenciaId;
             }
         
         }
        
       $fld_tinta_offset_tipo = BizSystem::ClientProxy()->GetFormInputs("fld_tinta_offset_tipo");   
      
       if($fld_tinta_offset_tipo)
       {
            $dataRec=$this->buscarGramos($result['pd_tinta_dl_id'],$fld_tinta_offset_tipo);
            if(count($dataRec)==2)
            {
               $result['cantidad_aditivo']=$dataRec['cantidad_aditivo']; 
               $result['cantidad_aditivo_m2']=$dataRec['cantidad_aditivo_m2']; 
            }else
            {
               $result['cantidad_aditivo']=0; 
               $result['cantidad_aditivo_m2']=0; 
            }   
       }
         
        $dataObjName="epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl";
        $srcDataObj=BizSystem::GetObjectFactory()->GetObject($dataObjName);
        $srcDataObj->ResetRules();  
        $srcDataObj->setSearchRule("[Id]='".$result['pd_tinta_dl_id']."'");
        $list=$srcDataObj->Fetch();  
            
        if(isset($list[0]) && $list[0]['utilizacion']==2)
           $result['offset']=1;
        if(isset($list[0]) && $list[0]['utilizacion']==3)
           $result['esmalte']=1;
                           
           return $result;
     }
  
     public function cargarIds()
    {
        $dataObjName="epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl";
        $srcDataObj=BizSystem::GetObjectFactory()->GetObject($dataObjName);
        $recArr = $this->ReadInputRecord(); 
        $searchRule="[Id]=".$recArr['pd_tinta_dl_id'];
        $result=array();
        $srcDataObj->FetchRecords($searchRule,$result);
        return array('pd_id'=>$result[0]['pd_id'],'pd_tinta_dl_id'=>$recArr['pd_tinta_dl_id']);
    }   
   
   protected function ProcessPostAction()
    {
        // get the $redirectPage from eventHandler
        list($redirectPage,$target) = $this->GetRedirectPage();    
        if ($redirectPage)
        {
            $ids=$this->cargarIds();    // logErr($redirectPage.$ids['pd_id']."#".$ids['pd_barniz_id']);
            // otherwise, do page redirection
            BizSystem::ClientProxy()->ReDirectPage($redirectPage.$ids['pd_id']."#".$ids['pd_tinta_dl_id']);
        }
    }
    
    public function buscarGramos($pd_tinta_dl_id,$tipo_offset)
    {
        $pd_shell_id=$this->buscarPdTintaDL($pd_tinta_dl_id); 
        
        if(!isset($pd_shell_id['pd_shell_id'])) return ;
        
        $this->dataObjName="epd.pd.dataobj.d_ga_pd_shell";  
        $params=array('Id'=>$pd_shell_id['pd_shell_id']); 
        $data_pd_shell=$this->buscarObjetos($params);    //logErr($data_pd_shell);      
        $dataRec=array(); 
        
        $this->dataObjName="erp.tinta_dl_offset.dataobj.d_ga_erp_tinta_offset"; 
        $params=array('shell_id'=>$data_pd_shell[0]['shell_id'],'utilizacion'=>$tipo_offset);   
        $dataRec=$this->buscarObjetos($params);    
        if(!isset($dataRec[0])) logErr("para la shell:".$data_pd_shell[0]['shell_id']." y utilizacion=>".$tipo_offset."No encontro d_ga_erp_tinta_offset", errord_ga_erp_tinta_offse,false);
   
        if(isset($dataRec[0]))
        {
          $cantidad_aditivo=$dataRec[0]['cantidad'];       
             
          $value['cantidad_aditivo']=$cantidad_aditivo > 0 ? $cantidad_aditivo :  $value['cantidad_aditivo'];

          $calculo=$value['cantidad_aditivo'] * $data_pd_shell[0]['num_tapas'] / 1000; 
          
          $hoja_m2=$data_pd_shell[0]['m2'];
          if(strpos($hoja_m2,",")!==false)
               $hoja_m2=str_replace(",",".",$hoja_m2); 
               
          if($calculo>0 && $hoja_m2 >0){                      
            $value['cantidad_aditivo_m2']= $calculo/$hoja_m2; 
          }
        }
        
        return $value;  
    }

    public function buscarObjetos($params=array())
    {
        global $g_BizSystem;
        //busco si existe barniz Engance
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] = '".$value."'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;

    }
    
     public function buscarPdTintaDL($pd_tinta_dl_id)
    {
        global $g_BizSystem;
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl");
        $pd_tinta_lito = $dataObj->FetchById($pd_tinta_dl_id);
        
        if(count($pd_tinta_lito)>0)
            return $pd_tinta_lito;
        return false;
      }
   
}

?>