<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');  

class f_ga_pd_tinta_lito_comp_pdc_list extends EasyForm 
{ 	
    protected $num_pd_lito;
    protected $dataObjName;
 
    public function DeleteRecord($id=null)
	{ 	
		if(isset($_SESSION['num_pd_lito']))
			$this->num_pd_lito=$_SESSION['num_pd_lito'];
			
		$this->pdc=new GaPDC();
		global $g_BizSystem;

	    if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".delete"))
            return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
        
        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;
        foreach ($selIds as $id) {
             $recArr = $this->GetDataObj()->FetchById($id);
            
            if(!is_null($recArr))
                $comprobacion=$this->pdc->comprobarPDC($recArr['pd_id']);
            elseif(!is_null($this->num_pd_lito))
                $comprobacion=$this->pdc->comprobarPDC($this->num_pd_lito);
                
            if(!$comprobacion){
                $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
            return;
            }
            
            $name="epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito_comp";
            
            if(is_null($recArr))
            {
                $recArr['Id']=$id;
                $srcDataObj = $g_BizSystem->GetObjectFactory()->GetObject($name); 
                $searchRule="[tabla]='".$srcDataObj->m_MainTable."' 
                    AND [registro_id]='".$recArr['Id']."'";

                $recArray= $this->pdc->BuscarRegistroModificacion($searchRule);  //logErr($recArray, recArray, true);   
                
                if(isset($recArray[0]['pd_id'])) $recArr['pd_id']=$recArray[0]['pd_id']; 
                
                foreach($recArray as $val)
                {
                    if($val['campo']=='pd_tinta_lito_id')
                    {
                    $recArr['pd_tinta_lito_id']=$val['valor'];
                    break;
                    }
                }
                 
                $this->pdc->registrarCambioDelete($name,$recArr,$recArr['pd_id']);
            }
            else{
            
                $this->pdc->registrarCambioDelete($name,$recArr,$recArr['pd_id']);
            }
           // logErr($recArr, recARr, false);  
            //logErr($this->num_pd_lito, num_pd_lito, false);  
             //extraer listado completo
            $listado=$this->extraerListadoCompleto($recArr['pd_tinta_lito_id']); //logErr($listado,listado,true);
            
            //recalcular los valores
            $this->recalcularFormulas($listado); // logErr($listado,recalculado,false);
            
            //registroCambioUpdate
            foreach($listado as $value)
            {
                $cambio['Id']=$value['Id'];
                $cambio['cantidad_aditivo']=(string) $value['cantidad_aditivo'];
                $cambio['cantidad_aditivo_m2']=(string)$value['cantidad_aditivo_m2'];
              //  $cambio['cantidad_m2_formula']=(string)$value['cantidad_m2_formula'];
                $cambio['porciento']=(string)$value['porciento'];
                
               // logErr($cambio,cambio,false); //logErr($currentRec['pd_id'], 'pd_id', false);   
               $cambio['estado_cantidad_m2_formula']=$value['estado_cantidad_m2_formula'];     
                $this->pdc->registrarCambioUpdate($name,$cambio,$recArr['pd_id'],false,true);  
                unset($cambio); 
            }
            
        }
        //$formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_pdc_list");  
        $formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_colores.form.f_ga_pdc_color_list");  
        BizSystem::ClientProxy()->ReDrawForm($formObj->m_Name,  $formObj->Render()); 
      
        $this->RunEventLog();
        $this->ProcessPostAction();
	}
    
     ///actualizacion de los datos
    
    public function extraerListadoCompleto($compuesto_id)
    {
            $SearchRule="[pd_tinta_lito_id]='".$compuesto_id."'";
            $records=array();
            $this->GetDataObj()->FetchRecords($SearchRule,$records,-1,0,true,true); //logErr($records,record,false);   
            
                        //trato especial
            $name="epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito_comp";
            $records=$this->pdc->cargarDataObjUpdate($name,$records,$this->num_pd_lito); 
            $temp=array();
            
            foreach($records as $item)
            {                      
                if($compuesto_id==$item['pd_tinta_lito_id'])
                    $temp[]=$item;
            } 
             $records=$temp;
             
             unset($temp); 
             
        return $records;
    }  
    
    public function recalcularFormulas(&$formulas)
    {
          if(isset($formulas[0]['pd_shell_id']))
            {    
            
            $this->dataObjName="epd.pd.dataobj.d_ga_pd_shell";  
            $params=array('Id'=>$formulas[0]['pd_shell_id']); 
            $data_pd_shell=$this->buscarObjetos($params);   // logErr($data_pd_shell,shell,false);
            $dataRec=array();  
                        
            $this->dataObjName="erp.tinta_lito_cantidad_tipo.dataobj.d_ga_erp_tinta_lito_catidad_tipo"; 
            $params=array('utilizacion'=>$formulas[0]['utilizacion'],'shell_id'=>$data_pd_shell[0]['shell_id']); 
            $dataRec=$this->buscarObjetos($params);          //logErr($dataRec,catidad_tipo,false); 
             if(!isset($dataRec[0])) logErr("para la shell:".$data_pd_shell[0]['shell_id']." y utilizacion :".$recArr['utilizacion']."No encontro d_ga_erp_tinta_lito_catidad_tipo", d_ga_erp_tinta_lito_catidad_tipo,false);   
            
            $total=0; 
            if(!isset($formulas[0]['Id'])) $formulas=array();  

                foreach($formulas as $value)
                   $total+=$value['cantidad_m2_formula'];
                
                foreach($formulas as $key=>$value)
                {     // logErr($formulas[$key],antes,false); 
                    $OldRec=$value;                    
                    if($total>0)
                        $formulas[$key]['porciento']=round($value['cantidad_m2_formula']*100/$total,2);    
                    else
                       $formulas[$key]['porciento']=100; 
                     
                    if(isset($dataRec[0]))
                    {                            
                            //logErr($dataRec[0],catidad_tipo,false);
                        $calculo =round(($formulas[$key]['porciento']/100)*$dataRec[0]['cantidad_m2'],2);
                        
                        $formulas[$key]['cantidad_aditivo_m2']=$calculo;  
                         
                        $formulas[$key]['cantidad_aditivo']= round($dataRec[0]['cantidad_1000_tapas']*($formulas[$key]['porciento']/100),2) ;
                    } 
                    
                    //logErr($formulas[$key],despues,false); 
                } 
            }
        
    }
    
     public function buscarObjetos($params=array())
    {
        global $g_BizSystem;
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] = '".$value."'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;

    }
    
    
 
 
}

?>