<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');

class f_ga_pd_tinta_lito_pdc_new extends PickerForm 
{ 
    private $pdc;
    
    public function FetchData()
    {
        $result=parent::FetchData();   
         
         if(isset($result['maquina_litografica_tipo']) && $result['maquina_litografica_tipo']=="" || !$result['maquina_litografica_tipo'])
         {
             $maquina_lito_tipo=$this->buscarMaquinaTipo($result['pd_shell_id']);
             if($maquina_lito_tipo)
                $result['maquina_litografica_tipo']=$maquina_lito_tipo;
             else
                $result['maquina_litografica_tipo']=1;
             
           // logErr($maquina_lito_tipo); 
         } 
         
         if($result['maquina_litografica_tipo']==2)
                $result['cuerpo']=-1;
             else
                $result['cuerpo']=0;
          
        $data=array();
        if(isset($result['pd_shell_id']) && $result['pd_shell_id']>0)
        {
            $shell_pd=BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");
            $data=$shell_pd->FetchById($result['pd_shell_id']);
            
            if(isset($data['pd_id']) && $data['pd_id']>0)
            $result['pd_id']=$data['pd_id'];
        }
                
        return $result;
    }
    
    public function buscarMaquinaTipo($pd_shell_id)
    {
        $dataObjComp = BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell_maquina_lito");
        if(!$dataObjComp) return false;
        $dataObjComp->ResetRules();
        $result=array();
        $searchRule="[Id]='".$pd_shell_id."'";
        $dataObjComp->FetchRecords($searchRule,$result);  // logErr($result);
        
        if(isset($result[0]['maquina_litografica_tipo']))  
        return $result[0]['maquina_litografica_tipo'];
        return false;
    }
    
    public function SaveRecord()
	{
        global $g_BizSystem;
	    $this->pdc=new GaPDC();
	    $recArr = $this->ReadInputRecord();
        $recArr['cliche']='0';       
	    //$recArr['no_order']='1';     
	    $comprobacion=$this->pdc->comprobarPDC($recArr['pd_id']);     
	    if(!$comprobacion){
			    $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
			return;
	    }

        $this->SetActiveRecord($recArr);
        if (count($recArr) == 0)
            return;
                              
        try {
            $this->ValidateForm();
        }
        catch (ValidationException $e) {
			$this->ProcessFormObjError($e->m_Errors);
			return;
        }   
        
      	$name="epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito";
		//$dataRec= array();
		if ($this->m_FormType == "NEW")
		{
           // $svcobj = $g_BizSystem->GetService("queryService");
            global $g_BizSystem;
            $svcobj = $g_BizSystem->GetService("queryService");
            $doNameregirtro="epd.pdc.dataobj.d_ga_pdc";  //logErr($doNameregirtro); 
            while(true)
            {
            $recArr['Id']=rand(90000,100000); 
            $Id=$svcobj->FetchField($doNameregirtro,"[registro_id]=".$recArr['Id'],"Id");
                                  
            if(is_null($Id))
                break;
            }     
			$this->pdc->registrarCambioInsert($name,$recArr,$recArr['pd_id']);
		 
        }
		 if ($this->m_ParentFormName)
        {
            $this->Close();
        
            $this->RenderParent();
        }
       
        $this->ProcessPostAction();		
	}
    
     public function  ReadInputRecord()
    {
      $recArr=parent::ReadInputRecord(); 
         if(isset($recArr['pd_shell_id']) && $recArr['pd_shell_id']>0)
        $recArr['no_order']=$this->calcularOrden($recArr['pd_shell_id']);
        
        return $recArr; 
    }
       
    public function calcularOrden($id)
    {                        
        $dataRec=0;             
        $formObjColores = BizSystem::ObjectFactory()->GetObject("epd.pd_colores.form.f_ga_pdc_color_list");   
        $data=$formObjColores->FetchDataSetOrder();
        
        return  count($data)+1;

    }
}

?>