<?php 
class f_enviar_informe_solicitud_cambio extends EasyForm
{  
     
   public function EnviarEmail()
   {

    try {
            $this->ValidateForm();
        }
        catch (ValidationException $e) {
        $this->ProcessFormObjError($e->m_Errors);
        return;
        }   
        global $g_BizSystem;

        $svcobj = $g_BizSystem->GetService(EXCEL_SERVICE); 
        $propiedades=array('ORIENTACION'=>LANDSCAPE,'MARGIN-LEFT'=>1,'MARGIN-RIGHT'=>1,'AJUSTAR'=>1,'NOMBRE_DOCUMENTO'=>'Informe_de_PDs_con_solicitudes_de_cambio');  
        $name=$svcobj->renderXSL('epd.reporte.form.f_ga_pd_list_report_cambiado_historico',false,true,false,$propiedades);

        $params['to']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_destinatario");
        $params['cc']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_CC");
        $params['bcc']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_BCC");
        $params['subject']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_subject");
        $params['body']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_body");

        global $g_BizSystem; 
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("erp.parametrizacion_interna.dataobj.d_ga_erp_plantilla_parametrizacion_envio_email");
        //logErr($params,"salida #1 de parametros de cambios estado sin HEX",false);  
        if($this->cargarFormaEnvio()!="SMTP")  
      {              
        $params['subject']=$dataObj->aplicarBinarioHex($params['subject']); 
        $params['body']=$dataObj->aplicarBinarioHex($params['body']);
      }
        //logErr($params,"salida #2 de parametros de cambios estado CON HEX",false);     

        $file=$this->buscarFile($name);
        
        if(is_file($file))
            $params['files']=$file;
        
        foreach($params as $k=>$v)
        {
           $params[$k]=trim($v); 
        }      
           //logErr($params,params,false);
        //envio del email
        if($this->cargarFormaEnvio()!="SMTP")
        {
            $emailObj = $g_BizSystem->GetService(SEND_MAIL_SERVICE);
            $emailObj->enviarEmailSql($params);   
        }else{                       
            $emailObj = $g_BizSystem->GetService(USER_EMAIL_SERVICE); //logErr("cargo el servicio","",false);
            $emailObj->sendEmailNowSimple($params);   
        }
		$this->Close();

   }

    protected function ValidateForm ()
    {

    global $g_BizSystem;
        $params['fld_email_destinatario']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_destinatario");
        $params['fld_email_CC']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_CC");
        $params['fld_email_BCC']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_BCC");


        //validacion de direcciones de email.
        $validObj = $g_BizSystem->GetService(VALIDATE_SERVICE);
         foreach($params as $key=>$tipos)
        {
            if(!$tipos || trim($tipos)=="") continue;
            $emails=explode(";", $tipos);     
                                        // logErr($emails,email,false);
            foreach ($emails as $value) 
            {
            $value=trim($value);          //  logErr($value,value,false);

            $errorMessage=$validObj->email($value);

            if ($errorMessage == false) { //Couldn't get a clear error message so let's try this

                $elem_name=str_replace('fld_','',$key);
               $errorMessage = $this->GetMessage("VALIDATESVC_EMAIL_INVALID",array($elem_name));
               $this->m_ValidateErrors[$key] = $errorMessage;
            }

            }
        }
        
         $params['subject']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_subject");
        $params['body']          = $g_BizSystem->GetClientProxy()->GetFormInputs("fld_email_body");   
    
        if (count($this->m_ValidateErrors) > 0)
        {
            throw new ValidationException($this->m_ValidateErrors);
            return false;
        }
    	return true;
    }
    
    public function FetchData()
    {
       $params= $this->GetDataObj()->buscarParametrizacionEnvioEmail('ENVIO_INFORME_PD_SOLICITUD_CAMBIOS'); 
       
       $values=array(date("d-m-Y"));     
       if(strripos($params['body'],'%s') && isset($values[0])) 
            $this->params['body']=vsprintf($params['body'],$values);
                
        if(strripos($params['subject'],'%s') && isset($values[0])) 
            $params['subject']=vsprintf($params['subject'],$values); 
  
            
       return $params;
    }
    
    public function buscarFile($name)
    {
        $separadores=array("//", "\\", "\ ");  
        $filepath=APP_FILE_PATH."/tmpfiles/";
        $file=$filepath.$name;
        $file=str_replace($separadores,"/",$file);
        
        return $file;
    }
    
      public function cargarFormaEnvio()
    {
        $system_configuration= $_SESSION['system_configuration'];
           $system_define=array();
           $work=null;
           if(is_array($system_configuration))
           {     
               foreach($system_configuration as $key=>$val)
               {
                   if($val['clave']=="EMAIL")
                   {
                       $work=$val['valor'];     break ;
                   }
               }
           }
           
           return $work;
    }
}

?>