<?php 

class f_ga_pd_list_informe_no_escaneadas extends EasyForm
{
	private $sumaDias = 0;
	private $cantidad = 1;
    
	public function OutputAttrs()
	{
        global $g_BizSystem;        

		$output = parent::OutputAttrs();
		 $serachRule="";
             $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.reporte.dataobj.d_ga_pd_report_calculo"); 
        $result = $dataObj->DirectFetch($serachRule);   
        
        if(!isset($result[0])) return $output;
        
        $output['count']=$result[0]['cantidad']; 
        $output['plazo_medio'] = number_format($result[0]['plazomedio'], 2, '.', '');
        $output['sumaDias'] = $result[0]['dias'] ;
        
		return $output;
	}
      
	public function FetchDataSet1()
    {             
        global $g_BizSystem;        
        $dateService = $g_BizSystem->GetService('dateService');
                    
        QueryStringParam::SetBindValues($this->m_SearchRuleBindValues);
        
        $dataobj = $this->GetDataObj();
        if (!$dataobj) return null;  
        if ($this->m_RefreshData)   $dataobj->ResetRules();  
        else $dataobj->ClearSearchRule();
 
        if ($this->m_FixSearchRule) {
            if ($this->m_SearchRule)
                $searchRule = $this->m_SearchRule . " AND " . $this->m_FixSearchRule;
            else
                $searchRule = $this->m_FixSearchRule;
        }
        else
            $searchRule = $this->m_SearchRule;

        $dataobj->SetSearchRule($searchRule);
         
        $dataobj->setLimit($this->m_Range, ($this->m_CurrentPage-1)*$this->m_Range);
                 
        $resultRecords = $dataobj->Fetch();
        $this->m_TotalRecords = $dataobj->Count();
        if ($this->m_Range && $this->m_Range > 0)
            $this->m_TotalPages = ceil($this->m_TotalRecords/$this->m_Range);
        $selectedIndex = 0;
        $this->GetDataObj()->SetActiveRecord($resultRecords[$selectedIndex]);
        
        QueryStringParam::ReSet();
        
      // return $resultRecords;
                                   // logErr($resultRecords);
       $dataSet=array(); 
       foreach($resultRecords as $value)
        {                logErr($value);        
            $filename="../files/sec_upload/pd_imagen/".$value['Id'].".jpg";

            if(!file_exists($filename) )
            {
                $value['image']="";
                $dataSet[]=$value;
            }
            //$difDias = $dateService->restaFechas($value['fecha_solicitud'], date('d-m-Y'));
            //$value['dias']=$difDias;

        }	  
        return $dataSet;

	 }   
     
    public function CallService($class, $method)
    {
       global $g_BizSystem;
       $svcobj = $g_BizSystem->GetService($class);  //logErr(CallService,CallService,false);
     
       $svcobj->renderXSL($this->m_Name,true,true);
    }   
  
    public function RunSearch()
	{
        include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";
        $estado="";$cadena=array();
        foreach ($this->m_SearchPanel as $elem)
        {     
            if (!$elem->m_FieldName)
                continue;
            
            $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);
            $cadena[$elem->m_FieldName]=$value;
            $activo=true;
            
            if($elem->m_Name=="qry_estado" && $value==-1)
                $activo=false;
            elseif($elem->m_Name=="qry_estado" && $value!=-1)
                $estado=$value;
               
            
            if($elem->m_FuzzySearch=="Y" && $value!=""){
            	$value="*$value*";
            }
                        
                  //  logErr($elem->m_Name,m_Name,false); 
            if ($value && $activo) 
            {  
               // logErr($value,value,false); 
                if(strpos($elem->m_Name,"num_pd")!==false){

                     if((strpos($elem->m_Name,"1")!==false) ){
                           $value=">=".$value;
                        }elseif(strpos($elem->m_Name,"2")!==false){
                           $value="<=".$value;
                        }
                      /*  if(strpos($elem->m_FieldName,"2")===false)
                            $searchStr = InputValToRule($elem->m_FieldName, $value, $this);
                        else
                            $searchStr = InputValToRule("num_pd", $value, $this);      */
                         $searchStr = InputValToRule($elem->m_FieldName, $value, $this);   
                      // logErr($searchStr,searchStr1,false);                                                            
                      
                }elseif(strpos($elem->m_Name,"fecha")!==false){
                    
                        $campo_fecha=$this->getAtributoFecha($estado);
                        if($campo_fecha)
                        {
                        if(strpos($elem->m_Name,"inicio")!==false){
                           $value=">=".$value;
                        }elseif(strpos($elem->m_Name,"fin")!==false){
                           $value="<=".$value;
                        }
                        $searchStr = InputValToRule($campo_fecha, $value, $this);
                        }
                  

                }else{
                    $searchStr = InputValToRule($elem->m_FieldName, $value, $this);
                }        
                if ($searchRule == "")
                   $searchRule .= $searchStr;
                else
                   $searchRule .= " AND " . $searchStr;
            }
        }
              // logErr($searchRule,searchRule,false); 
          $this->m_SearchRule = $searchRule;
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;

        $this->m_CurrentPage = 1;
        $this->guardarCurrentPage();
        
        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);
        
        $this->RunEventLog();
        $this->ReRender();
	}

    public function getAtributoFecha($estado)
    {
 
            switch ($estado){
            case 1: return "fecha_solicitud";

            case 2: return "fecha_envio";

            case 3:
                return "fecha_aprobacion";
            case 4:
                return "fecha_anulacion";
            case 5:
                return false;
            default:
                return false;
            }
        }
   
}
	