<?php 
  include_once(MODULE_PATH.'/epd/reporte/message/ga_pd.msg');  
class f_ga_pd_list_report_cantidad_barniz_couche extends EasyForm
{
	                                
    public function CallService1($class, $method)
    {
       global $g_BizSystem;
       $svcobj = $g_BizSystem->GetService($class);  //logErr(CallService,CallService,false);
     
       $svcobj->renderXSL($this->m_Name,true,true);
    }   
  
    public function RunSearch()
	{
      include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";$cadena=array();
        $pd_ids=array();
        $cantidads=array(); $i=1;
        foreach ($this->m_SearchPanel as $k=>$elem) 
        {
            $check=true;
            if (!$elem->m_FieldName)
                continue;
            
            $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);
            $bizField = $this->GetDataObj()->GetField($elem->m_FieldName);     
             
             if($value)   
             $check=$bizField->CheckValueType($value);  
             
             if($elem->m_Name=='qry_pd_10'  && $value)
              {    
                  $pd_ids[10] =$value; 
                  continue;
              
              }elseif($elem->m_Name=='qry_cantidad_10' && $value)
              {    
                    $cantidads[10] =$value;
                  continue;
              
              }elseif(strripos($elem->m_Name,'_pd_')!==false && $value)
              {    
                  $pos=substr($elem->m_FieldName,strlen($elem->m_FieldName)-1)*1; 
                  $pd_ids[$pos] =trim($value); 
                  continue;
              
              }
              elseif(strripos($elem->m_Name,'_cantidad_')!==false && $value)
              {    
                  $pos=substr($elem->m_FieldName,strlen($elem->m_FieldName)-1)*1; 
                  $cantidads[$pos] =trim($value); 
                  continue;
              
              }
             
             $cadena[$elem->m_FieldName]=$value;   
            
             $activo=true;  
             if($elem->m_BlankOption && strpos($elem->m_BlankOption,'-1') && $value==-1)
                  $activo=false; 


            if($elem->m_FuzzySearch=="Y" && $value!=''){
                $value="*$value*";
            }
            if ($value && $activo) {
                $searchStr = InputValToRule($elem->m_FieldName, $value, $this);
                if ($searchRule == "")
                   $searchRule .= $searchStr;
                else
                   $searchRule .= " AND " . $searchStr;
            }
        }  
        if(count($pd_ids)==0 )
        {
            $reportePDSMEssage = $this->GetMessage("MSG_GA_PD_REPORTE_PDS");
            BizSystem::ClientProxy()->ShowErrorMessage($reportePDSMEssage);
            return false;
        }
         
     
        global $g_BizSystem;             
        $profile = $g_BizSystem->GetUserProfile();  
        
        if($profile['Id']>0)
        {
        $sql1="delete temp_ga_pd_consumo_tintas_barnices_couche_producir
        where temp_ga_pd_consumo_tintas_barnices_couche_producir.usuario = ".$profile['Id'].";" ;
        $this->execute_sql_array($sql1);
        }
         
        if(is_array($pd_ids))
        foreach($pd_ids as $pos=>$pd)
        {
            if(!is_numeric($pd))
            {
                $reportePDSMEssage = $this->GetMessage("MSG_GA_PD_REPORTE_PDS");
                BizSystem::ClientProxy()->ShowErrorMessage($reportePDSMEssage);
                return false;
            }
            if(!is_numeric($cantidads[$pos]))
            {
                $reporteCantidadMessage = $this->GetMessage("MSG_GA_PD_REPORTE_CANTIDAD");
                BizSystem::ClientProxy()->ShowErrorMessage($reporteCantidadMessage);
                return false;
            }     
            $params = array($pd,$cantidads[$pos],$profile['Id'],$pos,$pos,$pos,$pos);
            $ruta = "epd.pd.informeCantidadBarnizCauchePd1"; 
            $sql = $this->LoadQuery($ruta, $params);     
            $this->execute_sql_array($sql);         
        } 
        
               
        $this->m_SearchRule = $searchRule;
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;

        $this->m_CurrentPage = 1;
        $this->guardarCurrentPage();
        
        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);
        
        $this->RunEventLog();
        $this->ReRender();
	}
    
    


   
}
	