<?php 

class f_ga_pd_list_report_plazo_ejecucion extends EasyForm
{
	private $sumaDias = 0;
	private $cantidad = 1;
	
    public function OutputAttrs()
	{
        
          global $g_BizSystem;        

        $output = parent::OutputAttrs();
         $serachRule="";
             $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.reporte.dataobj.v_d_ga_pd_report_pendiente_ejecucion_calculo"); 
        $result = $dataObj->DirectFetch($serachRule);   
                 
        if(!isset($result[0])) return $output;
        
        $output['count']=$result[0]['cantidad']; 
        $output['plazo_medio'] = number_format($result[0]['plazomedio'], 2, '.', '');
        $output['sumaDias'] = $result[0]['dias'] ;
        /*
        global $g_BizSystem;        
        $dateService = $g_BizSystem->GetService('dateService');
		$output = parent::OutputAttrs();
		 $serachRule="";                 
         
        $result = $this->GetDataObj()->DirectFetch($serachRule);
        $this->cantidad=$this->GetDataObj()->Count(); 
        
        foreach($result as $key=>$value)
        {                   
            //logErr($value);
            $difDias = $dateService->restaFechas($value['fecha_solicitud'], date('d-m-Y'));
            $this->sumaDias += $difDias;
            $value['dias']=$difDias;
        }
		$output['count']       = $this->cantidad;
        
		if($this->cantidad!=0)
			$plazo_medio = $this->sumaDias/$this->cantidad;
		else
			$plazo_medio=0;
                $output['plazo_medio'] = number_format($plazo_medio, 2, '.', '');
		        */
                return $output;
	}
      
	public function FetchDataSet()
    {
                global $g_BizSystem;        
        $dateService = $g_BizSystem->GetService('dateService');
	  
	 $result=parent::FetchDataSet();
	 
     foreach($result as &$value)
     {
         $difDias="";
        if($value['fecha_solicitud'] && $value['fecha_fin_desarrollo'])
        {
            $difDias = $dateService->restaFechas($value['fecha_solicitud'], $value['fecha_fin_desarrollo']);
           if($difDias==0 || $difDias ===0 || $difDias=='0')
            $difDias='0';
            $value['dias']=$difDias; 
        }
        else
        {
            $value['dias'] = '-';
        }
              
	}	 
	return $result;

	 }

    public function RunSearch()
    {
        include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";
        $estado=1;$cadena=array();
        $fecha_desde=null; 
        $fecha_hasta=null;
        foreach ($this->m_SearchPanel as $elem)
        {     
            if (!$elem->m_FieldName)
                continue;
            
            $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);
            $cadena[$elem->m_FieldName]=$value;
            $activo=true;
            
            if($elem->m_Name=="qry_estado" && $value==-1)
                $activo=false;
            elseif($elem->m_Name=="qry_estado" && $value!=-1)
                $estado=$value;
             
             if($elem->m_Name=="qry_fecha_inicio" && $value){
                   // $value=">=".$value;
                   // $elem->m_FieldName='fecha';
                   $fecha_desde=split("-",$value);       
                   if(count($fecha_desde))
                   $value=$fecha_desde[2]."-".$fecha_desde[1]."-".$fecha_desde[0] ;
                   $fecha_desde = "CONVERT(datetime, '".$value." 00 :00 :00"."', 102)";     
                   continue;  
             }
             
             if($elem->m_Name=="qry_fecha_fin" && $value){
                    //$value="<=".$value;
                    //$elem->m_FieldName='fecha';   
                   $fecha_hasta=split("-",$value);                          
                   if(count($fecha_hasta))
                   $value=$fecha_hasta[2]."-".$fecha_hasta[1]."-".$fecha_hasta[0] ;
                    $fecha_hasta = "CONVERT(datetime, '".$value." 23 :59 :59.997"."', 102)";  
                    continue;     
             }   
            
            if($elem->m_FuzzySearch=="Y" && $value!=""){
                $value="*$value*";
            }
                        
 
            if ($value && $activo) 
            {  
 
                if(strpos($elem->m_Name,"num_pd")!==false){

                     if((strpos($elem->m_Name,"1")!==false) ){
                           $value=">=".$value;
                        }elseif(strpos($elem->m_Name,"2")!==false){
                           $value="<=".$value;
                        }
 
                         $searchStr = InputValToRule($elem->m_FieldName, $value, $this);   
                                                                          
                      
                }
       
                else{     
                    $searchStr = InputValToRule($elem->m_FieldName, $value, $this);
                }        
                if ($searchRule == "")
                   $searchRule .= $searchStr;
                else
                   $searchRule .= " AND " . $searchStr;
            }
        }
              // logErr($searchRule,searchRule,false); 
        $campo_fecha=$this->getAtributoFecha($estado); 
        $fecha_hoy = "CONVERT(datetime, '".date('Y-m-d')." 00 :00 :00"."', 102)"; 
        
        if($fecha_desde && $fecha_hasta)
        {
          if($searchRule)
            $searchRule.=" AND [$campo_fecha] BETWEEN ".$fecha_desde." AND ".$fecha_hasta;
          else
            $searchRule.="[$campo_fecha] BETWEEN ".$fecha_desde." AND ".$fecha_hasta;  
        }
        elseif($fecha_desde)
        {
            if($searchRule)
            $searchRule.=" AND [$campo_fecha] BETWEEN ".$fecha_desde." AND ".$fecha_hoy;
           else
            $searchRule.="[$campo_fecha] BETWEEN ".$fecha_desde." AND ".$fecha_hoy;         
        }
         elseif($fecha_hasta)
        {
            $fecha_desde = "CONVERT(datetime, '1990-01-01 00 :00 :00"."', 102)";;
            if($searchRule)
            $searchRule.=" AND [$campo_fecha] BETWEEN ".$fecha_desde." AND ".$fecha_hasta;
           else
            $searchRule.="[$campo_fecha] BETWEEN ".$fecha_desde." AND ".$fecha_hasta;         
        }
          
        $this->m_SearchRule = $searchRule;
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;

        $this->m_CurrentPage = 1;
        $this->guardarCurrentPage();
        
        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);
        
        $this->RunEventLog();
        $this->ReRender();
    }

    public function CallService($class, $method)
    {
       global $g_BizSystem;
       $svcobj = $g_BizSystem->GetService($class);     
       $svcobj->renderXSL($this->m_Name,true,true);
    }    

    public function getAtributoFecha($estado)
    {
 
            switch ($estado){
            case 1: return "fecha_solicitud";

            case 2: return "fecha_envio";

            case 3:
                return "fecha_aprobacion";
            case 4:
                return "fecha_anulacion";
            case 6:
                 return "fecha_fin_desarrollo";   
            default:
                return false;
            }
        }
}
	