<?php 

class reportEasyForm extends EasyForm
{
	private $sumaDias = 0;
	private $cantidad = 1;
	
    public function OutputAttrs1()
	{
        global $g_BizSystem;        
        $dateService = $g_BizSystem->GetService('dateService');
		$output = parent::OutputAttrs();
		 $serachRule="";                 
         
        $result = $this->GetDataObj()->DirectFetch($serachRule);
        $this->cantidad=$this->GetDataObj()->Count(); 
        
        foreach($result as $key=>$value)
        {                   
        	//logErr($value);
            $difDias = $dateService->restaFechas($value['fecha_solicitud'], date('d-m-Y'));
            $this->sumaDias += $difDias;
            $value['dias']=$difDias;
        }
		$output['count']       = $this->cantidad;
        
		if($this->cantidad!=0)
			$plazo_medio = $this->sumaDias/$this->cantidad;
		else
			$plazo_medio=0;
                $output['plazo_medio'] = number_format($plazo_medio, 2, '.', '');
		return $output;
	}
      
	public function FetchDataSet()
    {
                global $g_BizSystem;        
        $dateService = $g_BizSystem->GetService('dateService');
	  
	 $result=parent::FetchDataSet();
	 
     foreach($result as &$value)
     {
        $filename="../files/sec_upload/pd_imagen/".$value['Id'].".jpg";

        if(!file_exists($filename))
        {
            $value['image']="";
        }
           $difDias = $dateService->restaFechas($value['fecha_solicitud'], date('d-m-Y'));
            $value['dias']=$difDias;

	}	 
	return $result;

	 }

    public function RunSearch()
	{
        include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";
        $estado="";$cadena=array();
        foreach ($this->m_SearchPanel as $elem)
        {     
            if (!$elem->m_FieldName)
                continue;
            
           // logErr($elem->m_Name, "elem->m_Name", false);
            $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);
            $cadena[$elem->m_FieldName]=$value;
            
            if($elem->m_Name=="qry_estado")
                $estado=$value;
            
            if($elem->m_FuzzySearch=="Y" && $value!=""){
            	$value="*$value*";
            }
            
            if ($value) {
                if(strpos($elem->m_Name,"id")!==false){

                     if((strpos($elem->m_Name,"inicio")!==false) ){
                           $value=">=".$value;
                        }elseif(strpos($elem->m_Name,"fin")!==false){
                           $value="<=".$value;
                        }
                        if(strpos($elem->m_FieldName,"2")==false)
                            $searchStr = InputValToRule($elem->m_FieldName, $value, $this);
                        else
                            $searchStr = InputValToRule("num_pd", $value, $this);
                         
                }elseif(strpos($elem->m_Name,"fecha")!==false){
                    
                        $campo_fecha=$this->getAtributoFecha($estado);
                        if($campo_fecha)
                        {
                        if(strpos($elem->m_Name,"inicio")!==false){
                           $value=">=".$value;
                        }elseif(strpos($elem->m_Name,"fin")!==false){
                           $value="<=".$value;
                        }
                        $searchStr = InputValToRule($campo_fecha, $value, $this);
                        }
                  

                }else{
                    $searchStr = InputValToRule($elem->m_FieldName, $value, $this);
                }
                //$searchStr = InputValToRule($elem->m_FieldName, $value, $this);
                //logErr($searchStr, "elem-searchStr", false);
                if ($searchRule == "")
                   $searchRule .= $searchStr;
                else
                   $searchRule .= " AND " . $searchStr;
            }
        }

        $this->m_SearchRule = $searchRule;
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;

        $this->m_CurrentPage = 1;

        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);

        $this->RunEventLog();
        $this->ReRender();
	}

    public function CallService($class, $method)
    {
       global $g_BizSystem;
       $svcobj = $g_BizSystem->GetService($class);     
       $svcobj->renderXSL($this->m_Name,true,true);
    }    

    public function getAtributoFecha($estado)
    {
 
            switch ($estado){
            case 1: return "fecha_solicitud";

            case 2: return "fecha_envio";

            case 3:
                return "fecha_aprobacion";
            case 4:
                return "fecha_anulacion";
            case 5:
                return false;
            default:
                return false;
            }
        }
}
	